package com.xx.merchanthbh.activity.adapter;

import android.content.Context;
import android.util.Log;
import android.view.View;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ItemAssistantInformationBinding;
import com.xx.merchanthbh.ui.assistant.AssistantManagementViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

public class AssistantInformationAdapter extends xxBaseRecyclerViewAdapter<ItemAssistantInformationBinding, AssistantInformationBean> {

    public AssistantManagementViewModel viewModel;

    public AssistantInformationAdapter(Context context, AssistantManagementViewModel viewModel) {
        super(context);
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_assistant_information;
    }

    //    控制子布局的数据dateBinding.绑定的变量   赋值
    @Override
    protected void covert(ItemAssistantInformationBinding dataBind, AssistantInformationBean data, int position) {

        //   将接口调出来的布局遍历上去
        dataBind.setAssistantInformation(data);
        dataBind.setViewModel(viewModel);
        Log.v("这是当前店员的userId",data.getUserId());
        Log.v("这是当前本地储存的的userId",String.valueOf(LocalData.getMerchant().getUserId()));
        /*获取第一个位置*/
        if (data.getUserId().equals(String.valueOf(LocalData.getMerchant().getUserId()))) {
            /*删除按钮隐藏*/
            dataBind.iconDelete.setVisibility(View.GONE);
            /*店长回显*/
            dataBind.shopowner.setVisibility(View.VISIBLE);
            /*店员隐藏*/
            dataBind.clerk.setVisibility(View.GONE);
        } else {
            /*删除按钮显示*/
            dataBind.iconDelete.setVisibility(View.VISIBLE);
            /*店长隐藏*/
            dataBind.shopowner.setVisibility(View.GONE);
            /*店员回显*/
            dataBind.clerk.setVisibility(View.VISIBLE);
            /*店员的情况下,删除彻底隐藏*/
            Log.d("本地的userid", String.valueOf(LocalData.getUser().getUserId()));
            Log.d("商户的userid", String.valueOf(LocalData.getMerchant().getUserId()));
            if (LocalData.getUser().getUserId()!=LocalData.getMerchant().getUserId()){
                dataBind.iconDelete.setVisibility(View.GONE);
            }
        }

    }

}
