package com.xx.merchanthbh.activity.adapter;

import android.content.Context;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;

import androidx.recyclerview.widget.LinearLayoutManager;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.respons.OrderBean;
import com.xx.merchanthbh.databinding.ItemOrderListBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;


public class OrderListAdapter extends xxBaseRecyclerViewAdapter<ItemOrderListBinding, OrderBean> {

    public boolean staticVisibility=false;

    public OrderListAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_order_list;
    }

    @Override
    protected void covert(ItemOrderListBinding dataBind, OrderBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setOrderBean(data);
        Log.v("订单列表的重要信息:", String.valueOf(data));


        dataBind.rvOrderUnit.setOnTouchListener(new View.OnTouchListener() {
                                                    @Override
                                                    public boolean onTouch(View view, MotionEvent motionEvent) {
                                                        return dataBind.llAll.onTouchEvent(motionEvent);
                                                    }
                                                }
        );
        // 创建第二层RecyclerView的适配器
        OrderUnitAdapter orderUnitAdapter = new OrderUnitAdapter(mContext);
        // 设置第二层RecyclerView
        /*设置布局*/
        dataBind.rvOrderUnit.setLayoutManager(new LinearLayoutManager(mContext, LinearLayoutManager.VERTICAL, false));
        /*设置内层列表值*/
        orderUnitAdapter.mList = data.getCommodityList();
        /*设置内层适配器*/
        dataBind.rvOrderUnit.setAdapter(orderUnitAdapter);

        if (staticVisibility)
        {
            dataBind.tvOrderStatic.setVisibility(View.VISIBLE);
            /*orderStatus string 订单状态 1-待付款 2-已完成 3-已关闭*/
            switch (data.getOrderStatus())
            {
                case "1":
                    dataBind.tvOrderStatic.setText("待付款");
                    dataBind.tvOrderStatic.setTextColor(mContext.getColor(R.color.static_deal));
                    break;
                case "2":
                    dataBind.tvOrderStatic.setText("已完成");
                    dataBind.tvOrderStatic.setTextColor(mContext.getColor(R.color.text_foreground));
                    break;
                case "3":
                    dataBind.tvOrderStatic.setText("已关闭");
                    dataBind.tvOrderStatic.setTextColor(mContext.getColor(R.color.static_gray));
                    break;
            }

        }else {
            dataBind.tvOrderStatic.setVisibility(View.GONE);
        }

    }
}
