package com.xx.merchanthbh.data.http

import com.xx.merchanthbh.data.http.respons.ActivityCenterBean
import com.xx.merchanthbh.data.http.respons.AdvertisingBean
import com.xx.merchanthbh.data.http.respons.AppealBean
import com.xx.merchanthbh.data.http.respons.AppealListBean
import com.xx.merchanthbh.data.http.respons.AppealTypeBean
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean
import com.xx.merchanthbh.data.http.respons.BillDetailBean
import com.xx.merchanthbh.data.http.respons.BillListBean
import com.xx.merchanthbh.data.http.respons.BoothBean
import com.xx.merchanthbh.data.http.respons.CategoryBean
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean
import com.xx.merchanthbh.data.http.respons.ElectricInfoBean
import com.xx.merchanthbh.data.http.respons.ElectricMsgBean
import com.xx.merchanthbh.data.http.respons.Filebean
import com.xx.merchanthbh.data.http.respons.HomeStatisticalBean
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean
import com.xx.merchanthbh.data.http.respons.JobDetailBean
import com.xx.merchanthbh.data.http.respons.JobInformationBean
import com.xx.merchanthbh.data.http.respons.MemberInfoBean
import com.xx.merchanthbh.data.http.respons.MerchantBean
import com.xx.merchanthbh.data.http.respons.MerchantPointBean
import com.xx.merchanthbh.data.http.respons.MessageBean
import com.xx.merchanthbh.data.http.respons.OrderBean
import com.xx.merchanthbh.data.http.respons.OrderDetailBean
import com.xx.merchanthbh.data.http.respons.PayMsgBean
import com.xx.merchanthbh.data.http.respons.ProductBean
import com.xx.merchanthbh.data.http.respons.ProductForOrderBean
import com.xx.merchanthbh.data.http.respons.ProductListBean
import com.xx.merchanthbh.data.http.respons.RegisterBean
import com.xx.merchanthbh.data.http.respons.ShareTotalBean
import com.xx.merchanthbh.data.http.respons.UserInfoBean
import com.xx.xxviewlibrary.model.VersionBean
import com.xx.xxviewlibrary.witget.model.FileBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.BasePageResponse
import me.goldze.mvvmhabit.http.BaseResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import okhttp3.ResponseBody
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.Headers
import retrofit2.http.Multipart
import retrofit2.http.POST
import retrofit2.http.PUT
import retrofit2.http.Part
import retrofit2.http.Path
import retrofit2.http.Query
import retrofit2.http.Streaming
import retrofit2.http.Url


interface ApiService {

    /**
     * 登陆
     */
    @Headers("Content-type:application/json")
    @POST("app/user/login")
    open fun Login(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 修改密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/update-password")
    open fun ChangePwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 忘记密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/forget-password")
    open fun ForegetPwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 设置密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/set-password")
    open fun SetPwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 更改手机号
     */
    @Headers("Content-type:application/json")
    @POST("app/user/update-phone")
    open fun ChangePhone(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 获取验证码
     */
    @Headers("Content-type:application/json")
    @GET("app/user/send-verification-code")
    open fun getCode(@Query("phone") phone: String): Observable<BaseResponse<String>>

    /**
     * 注册
     */
    @Headers("Content-type:application/json")
    @POST("app/user/register")
    open fun register(@Body requestBody: RequestBody): Observable<BaseResponse<RegisterBean>>


    /**
     * 获取用户信息
     */
    @Headers("Content-type:application/json")
    @GET("app/getInfo")
    open fun getUserInfo(): Observable<BaseResponse<UserInfoBean>>

    /**
     * 商户首页统计数据
     */
    @Headers("Content-type:application/json")
    @GET("app/order/merchant-app/commercial-home-page")
    open fun getHomeStatistical(
    ): Observable<BaseResponse<HomeStatisticalBean>>


    /**
     * 获取展位管理列表
     * status:状态 0启用 1停用
     * affiliatedCompany:所属公司
     */
    @Headers("Content-type:application/json")
    @GET("app/booth/list-all")
    open fun getBoothList(
        @Query("status") status: String,
        @Query("affiliatedCompany") affiliatedCompany: String?,
        @Query("params[merchantCount]") merchantCount: String
    ): Observable<BaseResponse<List<BoothBean>>>

    /**
     * 获取反馈类型列表(数据字典)
     */
    @Headers("Content-type:application/json")
    @GET("system/dict/data/type/appeal_type")
    open fun getAppealTypeList(
    ): Observable<BaseResponse<List<AppealTypeBean>>>

    /**
     * 获取会员积分变动列表(数据字典) 废弃
     */
    /*   @Headers("Content-type:application/json")
       @GET("system/dict/data/type/integral_type")
       open fun getIntegralTypeList(
       ): Observable<BaseResponse<List<IntegralTypeBean>>>*/

    /**
     * 店员列表查询(不分页,供转发统计使用)
     */
    @Headers("Content-type:application/json")
    @GET("app/shop-person/list-all")
    open fun getAssistantListAll(
        @Query(value="searchWord" ,encoded = true) searchWord: String
    ): Observable<BaseResponse<List<AssistantInformationBean>>>
    /**
     * 店员列表查询(分页,供店员管理使用)
     */
    @Headers("Content-type:application/json")
    @GET("app/shop-person/list")
    open fun getAssistantList(
        @Query(value="searchWord" ,encoded = true) searchWord: String,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<AssistantInformationBean>>

    /**
     * 删除店员
     */
    @Headers("Content-type:application/json")
    @DELETE("app/shop-person/del-person/{businessId}")
    open fun deleteAssistant(
        @Path("businessId") id: String
    ): Observable<BaseResponse<Boolean>>

    /**
     * 上传
     */
    @Multipart
    @Headers("clientType:fy_authrity")
    @POST("common/uploads")
    fun upLoadFile(@Part file: List<MultipartBody.Part>): Observable<BaseResponse<List<Filebean>>>


    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/activity/queryAppActivityList")
    fun getActivityList(
        @Body requestBody: RequestBody,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<ActivityCenterBean>>

    /**
     * 首页--APP广告位查询
     */
    @Headers("Content-type:application/json")
    @POST("app/adList/list")
    fun getADList(@Body requestBody: RequestBody): Observable<BaseResponse<List<AdvertisingBean>>>

    /**
     * 人才招聘--文件上传
     */
    @Multipart
    @Headers("clientType:fy_authority")
    @POST("common/uploads")
    fun getResumes(@Part file: MultipartBody.Part):Observable<BaseResponse<List<Filebean>>>

    /**
     * 新增应聘记录(简历投递)
     */
    @Headers("Content-type:application/json")
    @POST("app/recruitment/add")
    fun addRecruitmentList(@Body requestBody: RequestBody): Observable<BaseResponse<Number>>

    /**
     * 查询资讯列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/information/getAppInformationList")
    fun getConsultationInformationList(@Body requestBody: RequestBody): Observable<BaseResponse<List<ConsultationTitleBean>>>


    /**
     * 首页--查询招聘列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/recruitment/queryAppRecruitmentList")
    fun getJobInformationList(
        @Body requestBody: RequestBody,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<JobInformationBean>>


    /**
     * 提交商户开店信息
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/online")
    fun postMerchantMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 商户线上重新申请开店
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/online/re")
    fun postReMerchantMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 修改商户开店信息
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/edit-info")
    fun postChangeMerchantMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 提交新建店员
     */
    @Headers("Content-type:application/json")
    @POST("app/shop-person/add-person")
    fun postAssistantMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @POST("app/adList/list")
    fun postADList(@Body requestBody: RequestBody): Observable<BaseResponse<List<AdvertisingBean>>>

    /**
     * 订单列表查询
     */
    @Headers("Content-type:application/json")
    @GET("app/order/merchant-app/list")
    /*订单状态 1-待付款 2-已完成 3-已关闭*/
    open fun getOderList(
        @Query("orderStatus") orderStatus: String,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<OrderBean>>

    /**
     * 消息列表查询
     */
    @Headers("Content-type:application/json")
    @GET("app/message/getMessageList")
    /*标记 0-未读 1-已读*/
    open fun getMessageList(@Query("flag") flag: String, @Query("pageNum") num: Int): Observable<BasePageResponse<MessageBean>>


    /**
     * 获取订单管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/order/merchant-app/order-info/{businessId}")
    fun getOrderDetailById(@Path("businessId") id: String?): Observable<BaseResponse<OrderDetailBean>>


    /**
     * 获取招聘信息详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/recruitment/{businessId}")
    fun getJobInformationDetailById(@Path("businessId") id: String?): Observable<BaseResponse<JobDetailBean>>


    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant/{businessId}")
    fun getMerchantById(@Path("businessId") id: String?): Observable<BaseResponse<MerchantBean>>

    /**
     * 获取诉求管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/appeal/management-all-operate/{businessId}")
    fun getAppealDetailById(@Path("businessId") id: String?): Observable<BaseResponse<AppealBean>>

    /**
     * 更改诉求信息
     */
    @Headers("Content-type:application/json")
    @PUT("app/appeal/management")
    fun putAppealEditUpdate(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>


    /**
     * 首页-商铺积分-查询
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/integral/list")
    fun getMerchantPointList(@Body requestBody: RequestBody): Observable<BaseResponse<List<MerchantPointBean>>>

    /**
     * 获取三级分类
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/category-tree")
    fun postCategory(@Body requestBody: RequestBody): Observable<BaseResponse<List<CategoryBean>>>


    /**
     * 新增商品
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/merchant-app/add")
    fun postAddProduct(@Body requestBody: RequestBody): Observable<BaseResponse<Object>>

    /**
     * 新增诉求管理
     */
    @Headers("Content-type:application/json")
    @POST("app/appeal/management")
    fun postAddAppeal(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 修改诉求管理
     */
    @Headers("Content-type:application/json")
    @PUT("app/appeal/management")
    fun postEditAppeal(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 获取商品列表
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/merchant-app/list")
    fun postProductList(
        @Body requestBody: RequestBody,
        @Query("pageSize") size: Int,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<ProductListBean>>

    /**
     * 删除商品
     */
    @Headers("Content-type:application/json")
    @DELETE("app/commodity/merchant-app/del/{businessIds}")
    fun deleteProductById(@Path("businessIds") id: String): Observable<BaseResponse<Int>>

    /**
     * 修改商品状态
     */
    @Headers("Content-type:application/json")
    @PUT("app/commodity/merchant-app/edit-status")
    fun putProductStatic(@Body requestBody: RequestBody): Observable<BaseResponse<Int>>


    /**
     * 根据手机号获取用户信息
     */
    @Headers("Content-type:application/json")
    @GET("app/order/merchant-app/member-info")
    fun getProductStatic(@Query("memberPhone") phone: String): Observable<BaseResponse<MemberInfoBean>>


    /**
     * 获取商品
     */
    @Headers("Content-type:application/json")
    @GET("app/order/merchant-app/commodity-list")
    fun getProductForOrder(
        @Query("searchWord") word: String,
        @Query("pageSize") size: Int,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<ProductForOrderBean>>


    /**
     * 创建订单
     */
    @Headers("Content-type:application/json")
    @POST("app/order/merchant-app/add")
    fun postCreateOrder(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 获取诉求列表
     */
    @Headers("Content-type:application/json")
    @POST("app/appeal/management/list")
    fun postAppealList(
        @Body requestBody: RequestBody,
        @Query("pageSize") size: Int,
        @Query("pageNum") num: Int
    ): Observable<BasePageResponse<AppealListBean>>

    /**
     * 更新消息状态
     */
    @Headers("Content-type:application/json")
    @PUT("app/message/unreadMerchant")
    fun putMessageStaticUpdate(@Body requestBody: RequestBody): Observable<BaseResponse<Number>>


    /**
     * 获取转发统计列表
     */
    @Headers("Content-type:application/json")
    @POST("app/activity-forward/queryAppActivityForwardTotalList")
    fun postShareTotal(@Body requestBody: RequestBody): Observable<BaseResponse<List<ShareTotalBean>>>

    /**
     * 签到
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant/sign-in")
    fun getSign(@Query("businessId") businessId: String): Observable<BaseResponse<Boolean>>

    /**
     * 获取商品详情
     */
    @Headers("Content-type:application/json")
    @GET("app/commodity/merchant-app/detail-none-empty-str/{businessId}")
    fun getProductInfo(@Path("businessId") businessId: String): Observable<BaseResponse<ProductBean>>

    /**
     * 修改商品信息
     */
    @Headers("Content-type:application/json")
    @PUT("app/commodity/merchant-app/edit")
    fun putProductMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Object>>


    /**
     * 获取会员积分变动规则列表
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/integral/set-list")
    open fun getIntegralTypeList(@Body requestBody: RequestBody
    ): Observable<BaseResponse<List<IntegralTypeBean>>>


    /**
     * 修改品牌授权信息
     */
    @Headers("Content-type:application/json")
    @PUT("app/merchant/brand/modify")
    fun putMerchantBrandChange(@Body requestBody: RequestBody): Observable<BaseResponse<Object>>

    /**
     * 新增品牌授权信息
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant/brand/add")
    fun postMerchantBrand(@Body requestBody: RequestBody): Observable<BaseResponse<IntegralTypeBean>>

    /**
     * 删除品牌授权信息
     */
    @Headers("Content-type:application/json")
    @DELETE("app/merchant/brand/del/{businessId}")
    fun deleteMerchantBrand(@Path("businessId") id: String): Observable<BaseResponse<Object>>


    /**
     * 更改手机号
     */
    @Headers("Content-type:application/json")
    @PUT("app/user/update-user")
    open fun updateUser(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 验证是否注册
     */
    @Headers("Content-type:application/json")
    @POST("app/user/check-phone")
    open fun checkRegister(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    /**
     * 下载文件
     *
     * @param url
     * @return
     */
    @Streaming
    @GET
    fun download(@Url url: String?): Observable<ResponseBody>

    /**
     * 获取版本
     */
    @Headers("Content-type:application/json")
    @POST("app/system/version/current")
    open fun getLineVersion(@Body requestBody: RequestBody): Observable<BaseResponse<VersionBean>>


    /**
     * 获取协议
     * 旧接口:app/agreement/getBasicList
     * 新接口:app/agreement/getStaticPageList
     */
    @Headers("Content-type:application/json")
    @POST("app/agreement/getStaticPageList")
    open fun getProtocols(@Body requestBody: RequestBody): Observable<BaseResponse<List<String>>>


    /**
     * 判断品牌授权是否可以修改与删除
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant/brand/check-allow-modify/{businessId}")
    open fun checkBrandAllow(@Path("businessId") businessId: String): Observable<BaseResponse<Boolean>>

    /**
     * 分享统计
     */
    @Headers("Content-type:application/json")
    @POST("app/activity/addActivityForward")
    open fun shareActivity(@Body requestBody: RequestBody): Observable<BaseResponse<String>>


    /**
     * PDF增加浏览量
     */
    @Headers("Content-type:application/json")
    @PUT("app/information/addView")
    open fun addLook(@Body requestBody: RequestBody): Observable<BaseResponse<String>>


    /**
     * 获取电表详情
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant-electricity/electricity-meter-list")
    open fun getElectricMsg(): Observable<BaseResponse<ElectricMsgBean>>

    /**
     * 电表详情
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant-electricity/electricity-meter-detail")
    open fun getElectricInfo(@Body requestBody: RequestBody): Observable<BaseResponse<ElectricInfoBean>>


    /**
     * 请求支付信息
     */
    @Headers("Content-type:application/json")
    @POST("app/merchant-electricity/buy-electricity")
    open fun requestPayMsg(@Body requestBody: RequestBody): Observable<BaseResponse<PayMsgBean>>


    /**
     * 请求账单列表
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant-electricity/order-list")
    open fun getBillList(@Query("createTime") createTime:String?,@Query("itemId") itemId:Int?,@Query("status") status:String?,@Query("pageNum") pageNum:Int?): Observable<BasePageResponse<BillListBean>>


    /**
     * 获取账单详情
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant-electricity/order-detail/{orderId}")
    open fun getBillDetail(@Path("orderId") orderId:String): Observable<BaseResponse<BillDetailBean>>

    /**
     * 刷新充值状态
     */
    @Headers("Content-type:application/json")
    @PUT("app/merchant-electricity/update-order-info/{businessId}")
    open fun refreshOrder(@Path("businessId") businessId:String): Observable<BaseResponse<BillListBean>>

    /**
     * 注销账号
     */
    @Headers("Content-type:application/json")
    @PUT("app/user/closure-with-reason")
    open fun logOffUser(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>
}