package com.xx.merchanthbh.data.http

import android.os.Environment
import android.util.Log
import com.xx.merchanthbh.data.http.respons.Filebean
import com.xx.merchanthbh.utils.RetrofitClient
import io.reactivex.rxjava3.android.schedulers.AndroidSchedulers
import io.reactivex.rxjava3.core.Observable
import io.reactivex.rxjava3.schedulers.Schedulers
import me.goldze.mvvmhabit.base.BaseModel
import me.goldze.mvvmhabit.http.BaseResponse
import okhttp3.MediaType
import okhttp3.MultipartBody
import okhttp3.RequestBody
import okhttp3.ResponseBody
import java.io.File
import java.io.FileOutputStream
import java.io.IOException

open class BaseRespons: BaseModel() {

     var apiService: ApiService
    init {
        apiService= RetrofitClient.getInstance().create(ApiService::class.java)
    }

    //文件上传
    fun upLoadFile(file:File):Observable<BaseResponse<List<Filebean>>>
    {
        val files: MutableList<File> = ArrayList()
        files.add(file)
        return upLoadFiles(files);
    }

    /**
     * 文件多个上传
     */
    fun upLoadFiles(files:List<File>): Observable<BaseResponse<List<Filebean>>>
    {
        val builder = MultipartBody.Builder()
            .setType(MultipartBody.FORM) //在这里添加服务器除了文件之外的其他参数
//            .addFormDataPart("type", "0").addFormDataPart("dir", "")
        for (fl in files) {
            val requestBody = RequestBody.create(MediaType.parse("multipart/form-data"), fl)
            builder.addFormDataPart("files", fl.name, requestBody)
        }

        val parts = builder.build().parts()

       return apiService.upLoadFile(parts)
    }


    fun downFile(url:String,name:String):Observable<ResponseBody>
    {

       return apiService.download(url).subscribeOn(Schedulers.io()) .unsubscribeOn(Schedulers.io()).doOnNext { body -> saveFile(body,
               name) }.observeOn(AndroidSchedulers.mainThread())
    }




    open fun saveFile(body: ResponseBody, writeUrl: String) {
        val buf = ByteArray(2048)
        var len: Int
        try {
            val file = File(writeUrl)
            val fileBasePath = writeUrl.substring(0, writeUrl.lastIndexOf("/"))
            val filePath = File(fileBasePath)
            //创建目录
            if (!filePath.exists()) {
                filePath.mkdirs()
            }
            if (!file.exists()) {
                file.createNewFile()
            }
            val fos = FileOutputStream(file)
            val secInputstream = body.byteStream()
            while (secInputstream.read(buf).also { len = it } != -1) {

                fos.write(buf, 0, len)
            }
            secInputstream.close()
            fos.close()
        } catch (e: IOException) {
            e.printStackTrace()
        }
    }
}


