package com.xx.merchanthbh.data.http.requst

import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.requst.body.ProductBody
import com.xx.merchanthbh.data.http.respons.CategoryBean
import com.xx.merchanthbh.data.http.respons.MerchantBean
import com.xx.merchanthbh.data.http.respons.ProductBean
import com.xx.merchanthbh.data.local.LocalData
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse

class AddProductRequest : BaseRespons() {
   var merchantBean:MerchantBean?= LocalData.getMerchant()

    /**
     * 获取用户分类
     */
    fun getCategory(): Observable<BaseResponse<List<CategoryBean>>> {
        return apiService.postCategory(ApiParams<AffiliatedCompanyBody>().setParams(AffiliatedCompanyBody(merchantBean?.booth?.affiliatedCompany!!)))
    }


    /**
     * 商品新建
     */
    fun addProduct(number:String,name:String,pImgs:String,dImgs:String,typeId:String,pPrice:String,describe:String,brandId:String?,staticStr:String): Observable<BaseResponse<Object>> {

       val  body:ProductBody=ProductBody(null,brandId,typeId,describe,name, pPrice.toDouble(),pImgs ,dImgs,if ("".equals(number)) null else number,staticStr)
        return apiService.postAddProduct(ApiParams<ProductBody>().setParams(body))
    }

    /**
     * 获取商品详情
     */
    fun getProductInfo(id:String):Observable<BaseResponse<ProductBean>>
    {
        return apiService.getProductInfo(id);
    }

    /**
     * 获取商品详情
     */
    fun changeProduct(id:String,number:String,name:String,pImgs:String,dImgs:String,typeId:String,pPrice:String,describe:String,brandId:String?): Observable<BaseResponse<Object>> {

        val  body:ProductBody=ProductBody(id,brandId,typeId,describe,name, pPrice.toDouble(),pImgs ,dImgs,if ("".equals(number)) null else number)
        return apiService.putProductMsg(ApiParams<ProductBody>().setParams(body))
    }

    data class AffiliatedCompanyBody(var affiliatedCompany:String)
}