package com.xx.merchanthbh.data.http.requst

import androidx.databinding.ObservableField
import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.requst.body.AppealBody
import com.xx.merchanthbh.data.http.requst.body.AppealEditBody
import com.xx.merchanthbh.data.http.requst.body.Brankbody
import com.xx.merchanthbh.data.http.respons.AppealBean
import com.xx.merchanthbh.data.http.respons.AppealTypeBean
import com.xx.merchanthbh.data.local.LocalData
import com.xx.xxviewlibrary.witget.model.FileBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse

class AppealRequest : BaseRespons() {


   /*创建诉求*/
   /*依次传入1-类型 2-商户 3-反馈人 4-联系方式 5-诉求描述 6-上传图片*/
    fun addAppeal(
       dictSort: String,
       appealPerson:String?,
       appealPhone:String,
       appealDescribe:String,
       uploadImgs: List<String>
   ): Observable<BaseResponse<Boolean>> {


        val  body: AppealBody = AppealBody(dictSort,LocalData.getMerchant()!!.businessId,appealPerson,appealPhone, appealDescribe,uploadImgs,"1")
        return apiService.postAddAppeal(ApiParams<AppealBody>().setParams(body))
    }
   /*修改诉求*/
   /*依次传入1-类型 2-商户 3-反馈人 4-联系方式 5-诉求描述 6-上传图片*/
    fun postEditAppeal(
       businessId: String,
       dictSort: String,
       merchantId:String,
       appealPerson:String,
       appealPhone:String,
       appealDescribe:String,
       uploadImgs: List<String>
   ): Observable<BaseResponse<Boolean>> {

        val  body: AppealEditBody = AppealEditBody(businessId,dictSort,merchantId,appealPerson,appealPhone, appealDescribe,uploadImgs,"1")
        return apiService.postEditAppeal(ApiParams<AppealEditBody>().setParams(body))
    }



    /**
     * 获取反馈类型列表
     */
    fun getAppealTypeList(): Observable<BaseResponse<List<AppealTypeBean>>> {
        return apiService.getAppealTypeList();
    }
    /**
     * 获取诉求详情
     */
    fun getAppealDetailById(id:String): Observable<BaseResponse<AppealBean>> {
        return apiService.getAppealDetailById(id);
    }

    class AppealInfo(
        var dictLabel: ObservableField<String>,
        var dictSort: String?,
        var storeName: ObservableField<String>,
        var companyName: ObservableField<String>,
        var responsiblePerson: ObservableField<String>,
        var personPhone: ObservableField<String>,
        var remark: ObservableField<String>,
        var companyLogo: ObservableField<FileBean>,
        var businessLicense: ObservableField<FileBean>,
        var operatingPermit: ObservableField<FileBean>,
        var branklist: List<Brankbody>?
    ) {

        constructor(phone: String) : this(
            ObservableField("请选择"),
            null,
            personPhone = ObservableField(phone),
            storeName = ObservableField(""),
            companyName = ObservableField(""),
            responsiblePerson = ObservableField(""),
            remark = ObservableField(""),
            companyLogo = ObservableField(FileBean("", "")),
            businessLicense = ObservableField(FileBean("", "")),
            operatingPermit = ObservableField(FileBean("", "")),
            branklist = ArrayList(),
        )

        constructor(info: AppealBean) : this(
            ObservableField(info.type?.dictLabel),
            info.type?.dictSort,
            ObservableField(info.storeName),
            ObservableField(info.companyName),
            ObservableField(info.responsiblePerson),
            ObservableField(info.personPhone),
            ObservableField(info.remark),
            ObservableField(FileBean(info.logoFile?.businessId, info.logoFile?.url)),
            ObservableField(
                FileBean(
                    info.businessLicenseFile?.businessId,
                    info.businessLicenseFile?.url
                )
            ),
            ObservableField(
                FileBean(
                    info.operatingPermitFile?.businessId,
                    info.operatingPermitFile?.url
                )
            ),
            ArrayList()


        )

        fun setAppealInfo(bean: AppealBean) {
            dictLabel.set(bean.type?.dictLabel)
            dictSort = bean.type?.dictSort
        }


    }

}