package com.xx.merchanthbh.data.http.requst;


import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class ConsultRequest extends BaseRespons {
    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public Observable<BaseResponse<List<AdvertisingBean>>> getAdList() {
        ApiParams<AdvertisingRequestBody> apiParams = new ApiParams<AdvertisingRequestBody>();
        AdvertisingRequestBody requestBody = new AdvertisingRequestBody("1","2");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getADList(body);
    }
    /**
     * 资讯列表
     */
    public Observable<BaseResponse<List<ConsultationTitleBean>>> getConsultationInformationList() {
        ApiParams<ConsultationRequestBody> apiParams = new ApiParams<ConsultationRequestBody>();
        ConsultationRequestBody requestBody = new ConsultationRequestBody("2");
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getConsultationInformationList(body);
    }

    /**
     * 获取广告列表
     * affiliatedCompany  string 所属公司 1- 河西 2-滨海
     * rotographDisplay string  1-消费者app 2-商户app 3-企业app
     */
    public class AdvertisingRequestBody {
        public String affiliatedCompany;
        public String rotographDisplay;

        public AdvertisingRequestBody(String affiliatedCompany,String rotographDisplay) {
            this.affiliatedCompany = affiliatedCompany;
            this.rotographDisplay = rotographDisplay;
        }
    }

    /**
     * "isPublish": 传APP类型 1-消费者 2-企业 3-商户
     */
    public class ConsultationRequestBody {
        public String appSide;
        public ConsultationRequestBody(String appSide) {
            this.appSide = appSide;
        }
    }


    /**
     * 添加浏览数
     * @param id 咨询id
     * @return
     */
    public Observable<BaseResponse<String>> addLook(String id) {

        ApiParams<ProductManagerRequst.productStaticBody> apiParams = new ApiParams<ProductManagerRequst.productStaticBody>();

        return getApiService().addLook(apiParams.setParams(new ProductManagerRequst.productStaticBody(id,null)));
    }

}
