package com.xx.merchanthbh.data.http.requst

import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.respons.ElectricInfoBean
import com.xx.merchanthbh.data.http.respons.ElectricMsgBean
import com.xx.merchanthbh.data.http.respons.EletricListBean
import com.xx.merchanthbh.data.http.respons.PayMsgBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse
import kotlin.math.E

class ElectricPayRequest : BaseRespons() {

    /**
     * 获取电表信息
     */
    fun getElectricMsg(): Observable<BaseResponse<ElectricMsgBean>>
    {
       return apiService.getElectricMsg()
    }


    /**
     * 获取电表详情
     */
    fun getElectricInfo(accountId:Int,itemId:Int,itemType:String):Observable<BaseResponse<ElectricInfoBean>>
    {
        return apiService.getElectricInfo(ApiParams<EletricListBean>().setParams(EletricListBean(accountId,null,itemId,null,itemType,null,null)))
    }


    /**
     * 请求支付信息
     */
    fun requestPayMsg( bean:ElectricInfoBean ,merchantId:String, payMoney:Int , payTypeEnum:String):Observable<BaseResponse<PayMsgBean>>
    {
        return apiService.requestPayMsg(ApiParams<RequestPayMsgBody>().setParams(RequestPayMsgBody(bean.accountId,bean.itemId,merchantId,payMoney,payTypeEnum)))
    }


    /**
     * 支付信息请求入参
     * payTypeEnum：交易类型:ALIPAY-支付宝,WECHAT-微信,UNION_PAY-银联云闪付,APPLE_PAY-Apple Pay,QMF-全民付,ALIPAY_MINI-支付宝小程序
     */
    data class RequestPayMsgBody(var accountId:Int,var itemId:Int ,var merchantId:String ,var payMoney:Int ,var payTypeEnum:String )

}