package com.xx.merchanthbh.data.http.requst

import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.requst.body.AppealEditBody
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse

class LogOffRequest : BaseRespons() {
    /**
     * 注销账号
     * 依次传入1-注销备注 2-注销原因 (1-需要解绑手机，2-安全/隐私顾虑，3-其他 )
     */
    fun logOffUser(
        accountClosureMark: String,
        accountClosureReason: String
    ): Observable<BaseResponse<Boolean>> {

        val body: LogOffRequestBody = LogOffRequestBody(accountClosureMark, accountClosureReason)
        return apiService.logOffUser(ApiParams<LogOffRequestBody>().setParams(body))
    }

    /**
     * 依次传入1-注销备注 2-注销原因 (1-需要解绑手机，2-安全/隐私顾虑，3-其他 )
     */
    class LogOffRequestBody(var accountClosureMark: String, var accountClosureReason: String)

}
