package com.xx.merchanthbh.data.http.requst

import androidx.databinding.ObservableField
import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.requst.body.BrankBean
import com.xx.merchanthbh.data.http.requst.body.Brankbody
import com.xx.merchanthbh.data.http.requst.body.MerchantMsgbody
import com.xx.merchanthbh.data.http.respons.BoothBean
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean
import com.xx.merchanthbh.data.http.respons.MerchantBean
import com.xx.merchanthbh.data.http.respons.RegisterBean
import com.xx.merchanthbh.data.local.LocalData
import com.xx.merchanthbh.data.staticdata.StaticData.sUserType
import com.xx.merchanthbh.ui.merchantenter.MerchantEnterViewModel
import com.xx.merchanthbh.ui.merchantenter.MerchantEnterViewModel.RegisterModel
import com.xx.xxviewlibrary.witget.model.FileBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse
import me.goldze.mvvmhabit.utils.StringUtils
import me.goldze.mvvmhabit.utils.ToastUtils

class MerchantEnterRequst: BaseRespons() {
    var merchant: MerchantBean? = LocalData.getMerchant();

    /**
     * 获取验证码
     */
    fun getCode(phone:String): Observable<BaseResponse<String>>
    {
        return apiService.getCode(phone);
    }


    /**
     * 注册
     */
    fun register( body: MerchantEnterViewModel.RegisterModel):Observable<BaseResponse<RegisterBean>>
    {
        return apiService.register(ApiParams<RegisterRequestBody>().setParams(RegisterRequestBody(body)))
    }

    /**
     * 登陆
     */
    fun Login( body: MerchantEnterViewModel.RegisterModel): Observable<BaseResponse<String>>
    {
        return apiService.Login(ApiParams<LoginRequest.LoginRequestBody>().setParams(
            LoginRequest.LoginRequestBody(
                body.oPhone.get().toString(),
                body.oPassword.get().toString(),
                "02"
            )
        ))
    }

    /**
     * 获取展位
     */
    fun getBoothList(): Observable<BaseResponse<List<BoothBean>>>
    {
        return apiService.getBoothList("0",null,"0")
    }


    /**
     * 上传商户开店信息
     */
    fun postMerchantMsg(merchantMsgbody: MerchantMsgbody): Observable<BaseResponse<Boolean>>
    {

        return apiService.postMerchantMsg(ApiParams<MerchantMsgbody>().setParams(merchantMsgbody))
    }


    /**
     * 重新商户开店信息
     */
    fun postREMerchantMsg(merchantMsgbody: MerchantMsgbody): Observable<BaseResponse<Boolean>>
    {

        return apiService.postReMerchantMsg(ApiParams<MerchantMsgbody>().setParams(merchantMsgbody))
    }
    /**
     * 修改商户开店信息
     */
    fun postChangeMerchantMsg(merchantMsgbody: MerchantMsgbody): Observable<BaseResponse<Boolean>>
    {

        return apiService.postChangeMerchantMsg(ApiParams<MerchantMsgbody>().setParams(merchantMsgbody))
    }

    /**
     * 获取商户信息
     */
    fun getMerchantInfoById(): Observable<BaseResponse<MerchantBean>>
    {

        return apiService.getMerchantById(LocalData.getMerchant()!!.businessId);


    }

    /**
     * 修改商品品牌授权信息
     */
    fun changeMerchantBrand(name:String, imgs:MutableList<String> ,id:String):Observable<BaseResponse<Object>>
    {

        return apiService.putMerchantBrandChange(ApiParams<MerchantBrandBody>().setParams(MerchantBrandBody(name,id,imgs,merchant?.businessId)) )
    }


    /**
     * 修改商品品牌授权信息
     */
    fun deleteMerchantBrand(id:String):Observable<BaseResponse<Object>>
    {

        return apiService.deleteMerchantBrand(id)
    }

    /**
     * 添加商品品牌授权信息
     */
    fun addMerchantBrand(name:String, list:MutableList<String> ):Observable<BaseResponse<IntegralTypeBean>>
    {



        return apiService.postMerchantBrand(ApiParams<MerchantBrandBody>().setParams(MerchantBrandBody(name,null,list,null)) )
    }

    /**
     * 核对是否注册过
     */
    fun checkRegisterPhone(phone:String):Observable<BaseResponse<Boolean>>
    {
        return apiService.checkRegister(ApiParams<checkPhoneBody>().setParams(checkPhoneBody(phone)))
    }

    fun checkBrandAllow(id:String):Observable<BaseResponse<Boolean>>
    {
        return apiService.checkBrandAllow(id)
    }

    data class checkPhoneBody(var phonenumber:String, var userType:String="02")

    class MerchantBrandBody(var brandName:String? , var businessId:String?,var fileIdList :MutableList<String>  ,var merchantManagementId :String? )






    /**
     * 注册内容
     */
    internal class RegisterRequestBody(model: RegisterModel?) {
        var userType: String
        var phone: String? = null
        var code: String? = null
        var password: String? = null

        init {
            userType = sUserType
            phone= model?.oPhone?.get()
            code= model?.oCode?.get()
            password= model?.oPassword?.get()

        }
    }




    class MerchantInfo(
        var boothNum: ObservableField<String>,
        var boothId: String? ,
        var storeName: ObservableField<String>,
        var companyName: ObservableField<String>,
        var responsiblePerson: ObservableField<String>,
        var personPhone: ObservableField<String>,
        var remark: ObservableField<String>,
        var companyLogo: ObservableField<FileBean>,
        var businessLicense: ObservableField<FileBean>,
        var operatingPermit: ObservableField<FileBean>,
        var branklist: List<Brankbody>?,
        var refuseString:String?=""
   )
    {

        constructor(phone:String) : this(
             ObservableField("请选择"),
            null,
            personPhone = ObservableField(phone),
            storeName = ObservableField(""),
            companyName = ObservableField(""),
            responsiblePerson = ObservableField(""),
            remark = ObservableField(""),
            companyLogo = ObservableField(FileBean("", "")),
            businessLicense = ObservableField(FileBean("", "")),
            operatingPermit = ObservableField(FileBean("", "")),
            branklist = ArrayList(),

        )
        constructor(info:MerchantBean) : this(
            ObservableField(info.booth?.boothNumber),
           info.boothId,
            ObservableField(info.storeName),
            ObservableField(info.companyName),
            ObservableField(info.responsiblePerson),
            ObservableField(info.personPhone),
            ObservableField(info.remark),
            ObservableField(FileBean(info.logoFile?.businessId,info.logoFile?.url)),
            ObservableField(FileBean(info.businessLicenseFile?.businessId,info.businessLicenseFile?.url)),
            ObservableField(FileBean(info.operatingPermitFile?.businessId,info.operatingPermitFile?.url)),
            ArrayList(),


        )
        fun reBranks(): List<BrankBean>{
                val list: MutableList<BrankBean> = ArrayList()
                if (branklist != null && branklist!!.size > 0) {
                    for (bean in branklist!!) {
                        list.add(BrankBean(bean))
                    }
                }
                return list
            }
        fun setMerchantInfo(bean: MerchantBean) {
            boothNum.set(bean.booth?.boothNumber)
            personPhone.set(bean.personPhone)
            storeName.set(bean.storeName)
            companyName.set(bean.companyName)
            responsiblePerson.set(bean.responsiblePerson)
            if (bean.logoFile != null) {
                companyLogo.set(FileBean(bean.logoFile!!.businessId, bean.logoFile!!.url))
            }
            if (bean.businessLicenseFile != null) {
                businessLicense.set(
                    FileBean(
                        bean.businessLicenseFile!!.businessId,
                        bean.businessLicenseFile!!.url
                    )
                )
            }
            if (bean.operatingPermitFile != null) {
                operatingPermit.set(
                    FileBean(
                        bean.operatingPermitFile!!.businessId,
                        bean.operatingPermitFile!!.url
                    )
                )
            }
            boothId = bean.boothId






        }

        fun reBrankbody(list:List<BrankBean>):List<Brankbody>
        {
            val listBody: MutableList<Brankbody> = ArrayList()
            for (brank in list)
            {
                if (brank.fileList==null)
                {
                    listBody.add(Brankbody(brank.brandName,ArrayList(),brank.businessId))
                }else{
                    listBody.add(Brankbody(brank.brandName, brank.fileList!!,brank.businessId))
                }
               
            }
            branklist=listBody;
            return listBody
        }

    }

}