package com.xx.merchanthbh.data.http.requst

import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.respons.MemberInfoBean
import com.xx.merchanthbh.data.http.respons.ProductForOrderBean
import com.xx.merchanthbh.data.http.respons.ProductListBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BasePageResponse
import me.goldze.mvvmhabit.http.BaseResponse
import java.util.Objects

class OrderCreateRequest : BaseRespons() {

    /**
     * 根据手机号获取会员信息
     */
    public fun getMemberByPhone(phone:String): Observable<BaseResponse<MemberInfoBean>>
    {
        return apiService.getProductStatic(phone)
    }


    /**
     * 获取商品列表
     */
    public fun getProductForPrder(word:String,page:Int):Observable<BasePageResponse<ProductForOrderBean>>
    {
        return apiService.getProductForOrder(word,10,page)
    }

    /**
     * 提交订单
     */
    public fun createOrder(memberInfoBean:MemberInfoBean,products:List<ProductForOrderBean>):Observable<BaseResponse<Boolean>>
    {
        var orderCommodityList: MutableList<OrderProductBody> = ArrayList();
        for (bean in products)
        {
            orderCommodityList.add(OrderProductBody(bean.businessId,bean.price,bean.reCommodityQuantity()))
        }
        return apiService.postCreateOrder(ApiParams<createOrderBody>().setParams(createOrderBody(memberInfoBean.businessId,memberInfoBean.memberPhone,orderCommodityList)))
    }


    data class createOrderBody(var memberId:String,var memberAccount:String,var orderCommodityList: MutableList<OrderProductBody>)


    data class OrderProductBody(var commodityId:String,var price :Double, var commodityQuantity:Int)


}