package com.xx.merchanthbh.data.http.requst

import com.xx.merchanthbh.data.http.BaseRespons
import com.xx.merchanthbh.data.http.respons.ProductListBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BasePageResponse
import me.goldze.mvvmhabit.http.BaseResponse

class ProductManagerRequst : BaseRespons() {


    /**
     * 获取商品列表
     *  commodityStatus 商品状态 1-待提交 2-待审核 3-已上架 4-未上架 5-已驳回:1-待提交,2-待审核,3-已上架,4-待上架,5-已驳回
     *  sortRules 排序方式:0-时间降序,1-时间升序,2-价格降序,3-价格升序
     */
    fun getProductList(commodityStatus:String?,sortRules:String , page:Int): Observable<BasePageResponse<ProductListBean>>
    {
       return apiService.postProductList( ApiParams<ProductListBody>().setParams(ProductListBody(commodityStatus,sortRules)),10,page)
    }


    /**
     * 删除商品
     */
    fun deleteProduct(id:String):Observable<BaseResponse<Int>>
    {
        return apiService.deleteProductById(id)
    }


    /**
     * 修改商品状态
     */
    fun putProductStatic( businessId:String, status:String):Observable<BaseResponse<Int>>
    {
        return apiService.putProductStatic(ApiParams<productStaticBody>().setParams(productStaticBody(businessId,status)))
    }


    data class ProductListBody(var commodityStatus:String?,var sortRules:String)

    /**
     * status商品状态 1-待提交 2-待审核 3-已上架 4-未上架 5-已驳回
     */
    data class productStaticBody(var businessId:String,var status:String?)

}