package com.xx.merchanthbh.data.http.requst;


import android.util.Log;

import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.JobDetailBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;

/*人才招聘列表*/
public class RecruitmentRequest extends BaseRespons {

    /**
     * 新增应聘记录(简历投递)传参 1-appSide:1消费者,2商户app,3企业app 2-recruitmentId:招聘ID 3-resumeFileId:文件ID
     */
    public Observable<BaseResponse<Number>> addRecruitmentList(String recruitmentId, String resumeFileId) {
        ApiParams<addRecruitmentRequestBody> apiParams = new ApiParams<addRecruitmentRequestBody>();
        addRecruitmentRequestBody addRecruitmentRequestBody = new addRecruitmentRequestBody("2", recruitmentId, resumeFileId);
        RequestBody body = apiParams.setParams(addRecruitmentRequestBody);
        return getApiService().addRecruitmentList(body);
    }

    /*简历文件上传*/
    public Observable<BaseResponse<List<Filebean>>> getResumesList(File file) {
        RequestBody requestFile = RequestBody.create(MediaType.parse("multipart/form-data"), file);

        MultipartBody.Part filePart = MultipartBody.Part.createFormData("files", file.getName(), requestFile);
        Log.v("最后传给接口的二进制文件", filePart.headers().toString());

        return getApiService().getResumes(filePart);
    }

    /**
     * 招聘列表
     */
    public Observable<BasePageResponse<JobInformationBean>> getJobInformationList(String recruitmentType, Integer page) {
        ApiParams<JobRequestBody> apiParams = new ApiParams<JobRequestBody>();
        JobRequestBody requestBody = new JobRequestBody(recruitmentType);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getJobInformationList(body, page);
    }

    /**
     * 获取招聘详情信息
     */
    public Observable<BaseResponse<JobDetailBean>> getJobInformationDetailById(String businessId) {
        return getApiService().getJobInformationDetailById(businessId);
    }


    /**
     * 不需要传参
     */
    public class JobRequestBody {
        public String recruitmentType;

        public JobRequestBody(String recruitmentType) {
            this.recruitmentType = recruitmentType;
        }
    }

    /**
     * 新增应聘记录(简历投递)传参 1-appSide:1消费者,2商户app,3企业app 2-recruitmentId:招聘ID 3-resumeFileld:文件ID
     */
    public class addRecruitmentRequestBody {
        /*1-appSide:1消费者,2商户app,3企业app*/
        public String appSide;
        /*2-recruitmentId:招聘ID*/
        public String recruitmentId;
        /*3-resumeFileld:文件ID*/
        public String resumeFileId;

        public addRecruitmentRequestBody(String appSide, String recruitmentId, String resumeFileId) {
            this.appSide = appSide;
            this.recruitmentId = recruitmentId;
            this.resumeFileId = resumeFileId;
        }

    }
}
