package com.xx.merchanthbh.data.http.requst;

import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.respons.AppealTypeBean;
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.http.respons.MerchantPointBean;
import com.xx.merchanthbh.data.local.LocalData;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class StorePointsRequest extends BaseRespons {


    MerchantBean bean=LocalData.getMerchant();
    /**
     获取商户信息
     */
    public Observable<BaseResponse<MerchantBean>> getMerchantInfoById() {
        return getApiService().getMerchantById(LocalData.getMerchant().getBusinessId());
    }
    /**
     * 筛选-积分类型列表
     */
    public Observable<BaseResponse<List<IntegralTypeBean>>> getIntegralTypeList() {
        return getApiService().getIntegralTypeList(new ApiParams<IntegralTypeBody>().setParams(new IntegralTypeBody()));
    }
    /**
     * 依次传商户id,筛选类型的字典值(非必传),筛选时间的拼接值(非必传)
     */
    public Observable<BaseResponse<List<MerchantPointBean>>> getMerchantPointList(String integralType,String variableTime) {

        ApiParams<MerchantPointRequestBody> apiParams = new ApiParams<MerchantPointRequestBody>();
        MerchantPointRequestBody requestBody = new MerchantPointRequestBody( LocalData.getMerchant().getBusinessId(),integralType,variableTime);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getMerchantPointList(body);
    }
    /**
     * 依次传商户id,筛选类型的字典值(非必传),筛选时间的拼接值(非必传)
     */
    public class MerchantPointRequestBody {
        public String merchantId;
        public String integralType;
        public String variableTime;

        public MerchantPointRequestBody(String merchantId,String integralType,String variableTime) {

            this.merchantId = merchantId;
            this.integralType = integralType;
            this.variableTime = variableTime;
        }
    }

    class IntegralTypeBody
    {
        /*
        1-消费者积分获取,2-商户积分获取
         */
        public String integralType;
        public String merchantId;

        public IntegralTypeBody()
        {
            integralType="2";
            merchantId=bean.getBusinessId();
        }


        public String getIntegralType() {
            return integralType;
        }

        public void setIntegralType(String integralType) {
            this.integralType = integralType;
        }

        public String getMerchantId() {
            return merchantId;
        }

        public void setMerchantId(String merchantId) {
            this.merchantId = merchantId;
        }
    }

}
