package com.xx.merchanthbh.data.staticdata

import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.respons.EletricListBean
import com.xx.merchanthbh.ui.billdetail.OrderStatusData

object StaticData {
    /**
     * 状态样式
     */
    @JvmField
    var statusStr: String = ""

    /**
     * 电表样式
     */
    @JvmField
    var itemName: String = ""

    /**
     * 日期样式年
     */
    @JvmField
    var dateYearsStr: String = ""

    /**
     * 日期样式月
     */
    @JvmField
    var dateMonthsStr: String =""

        /**
         * 选择的账单状态回显
         */
        @JvmField
        var selectStatus: String = "状态"

    /**
     * 选择的账单状态回显
     */
    @JvmField
    var selectElectric: String = "全部设备"

    /**
     * 选择的账单状态回显
     */
    @JvmField
    var selectTime: String = "全部时间"

    /**
     * 电费缴费金额
     */
    @JvmField
    var parsePrice: Int = 0

    /**
     * 注销状态 0-未注销 1-已注销
     */
    @JvmField
    var logOffData: Int = 0

    /**
     * 当前版本号*/
    @JvmField
    var appVersionNumber = ""

    @JvmField
    var sUserType = "02"

    /**
     * 登录-强制更新状态位  0-不能登录 1-可登录
     */
    @JvmField
    var updateLogin: Int = 1


    /**
     * 订单详情-状态位  订单状态 1-待付款 2-已完成 3-已关闭
     */
    @JvmField
    var statusData: Int = 0

    /**
     * 反馈详情-状态位  是否有图片状态 0-有 1-没有
     */
    @JvmField
    var imageFilesData: Int = 0

    /**
     * 店员列表-状态位  是否有数据 0-有 1-没有
     */
    @JvmField
    var AssistantData: Int = 0

    /**
     * 消息列表-状态位  是否有数据 0-有 1-没有
     */
    @JvmField
    var messageData: Int = 0

    /**
     * 积分列表-状态位  是否有数据 0-有 1-没有
     */
    @JvmField
    var PointData: Int = 0

    /**
     * 订单详情-状态位  订单状态 1-待付款 2-已完成 3-已关闭
     */
    lateinit var filePath: String

    /**
     * 活动中心-状态位  flag 0-未读 1-已读
     */
    @JvmField
    var flag: Int = 0

    /**
     * 登录人角色  personType 0-店长  1-店员
     */
    @JvmField
    var personType: Int = 1

    /**
    5 用户协议
    4 积分说明
    3 隐私条款
    2 服务条款
    1 会员体系
     */
    @JvmField
    var Protocols: List<String> = ArrayList();

    /**
     * 支付方式
     */
    @JvmField
    var PayWay: Map<String, String> =
        mapOf("ALIPAY" to "支付宝", "WECHAT" to "微信", "UNION_PAY" to "银联云闪付")


    @JvmField
    var ElectricOrderStatus: Map<String, OrderStatusData> = mapOf(
        "0" to OrderStatusData(R.mipmap.dingdan_icon_daifukuan, "待付款"),
        "2" to OrderStatusData(R.mipmap.dingdan_icon_wancheng, "已完成"),
        "1" to OrderStatusData(R.mipmap.dingdan_icon_guanbi, "已关闭"),
        "3" to OrderStatusData(R.mipmap.dianfei_icon_chongdianzhong, "充电中")
    )

    @JvmField
    var ElectricList: ArrayList<EletricListBean> = ArrayList();

}