package com.xx.merchanthbh.dialog

import android.content.Context
import android.os.Build
import android.util.Log
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import androidx.annotation.RequiresApi
import com.github.gzuliyujiang.wheelpicker.entity.DateEntity
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.respons.CategoryBean
import com.xx.merchanthbh.data.staticdata.StaticData
import com.xx.merchanthbh.databinding.DialogDataPickerBinding
import com.xx.merchanthbh.databinding.DialogProductTypeBinding
import com.xx.merchanthbh.dialog.data.ProductTypeProvider
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.goldze.mvvmhabit.utils.StringUtils
import me.jessyan.autosize.utils.AutoSizeUtils
import java.time.LocalDate

class DataPickerDialog(context: Context) : xxBaseDialog<DialogDataPickerBinding>(context) {

    var dataStr: String = "";

    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_data_picker, true,
            Gravity.BOTTOM, true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(
                context,
                321.0F
            )
        );
    }

    @RequiresApi(Build.VERSION_CODES.O)
    override fun InitData() {
        binding.dialog = this
        /*取当前时间的年月日,然后赋初始值*/
        val currentYear = LocalDate.now().year
        val currentMonth = LocalDate.now().monthValue
        val currentDay = LocalDate.now().dayOfMonth
        /*如果后续进行筛选赋值,应该每次打开都是上一次筛选的值*/
        val startYear = if (StaticData.dateYearsStr.isNullOrEmpty()) {
            currentYear
        } else {
            StaticData.dateYearsStr.toInt()
        }

        val startMonth = if (StaticData.dateMonthsStr.isNullOrEmpty()) {
            currentMonth
        } else {
            StaticData.dateMonthsStr.toInt()
        }

        val startDay = currentDay
        Log.v("当前年份:", startYear.toString())
        Log.v("当前月份:", startMonth.toString())
        Log.v("当前日期:", startDay.toString())
        /*设置进去*/
        binding.lwlDpt.setRange(
            DateEntity.target(2010, 1, 1),
            DateEntity.target(2050, 12, 31),
            DateEntity.target(startYear, startMonth, startDay)
        )

    }

    fun productTypeClickDialog(view: View) {

        if (DialogClickListener != null) {
            DialogClickListener.dialogClickBack(
                0,
                binding.lwlDpt.selectedYear.toString() + "-" + binding.lwlDpt.selectedMonth.toString()
            );
            Log.v("选择年份", binding.lwlDpt.selectedYear.toString())
            Log.v("选择日子", binding.lwlDpt.selectedMonth.toString())
            /*将上一次选择的日期保留下来*/
            StaticData.dateYearsStr = binding.lwlDpt.selectedYear.toString()
            StaticData.dateMonthsStr = binding.lwlDpt.selectedMonth.toString()
            dismiss()
        }


    }


}