package com.xx.merchanthbh.dialog

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import androidx.databinding.ObservableField
import com.xx.merchanthbh.R
import com.xx.merchanthbh.databinding.DialogRejectReasonBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.goldze.mvvmhabit.utils.StringUtils

class RejectDialog(
    context: Context,
    private val rejectionStrs: String,
    private val rejectionReason: String,
    private val secondRejectStr: String,
    private val secondRejectReason: String,
    private val thirdRejectStr: String,
    private val thirdRejectReason: String
) : xxBaseDialog<DialogRejectReasonBinding>(context) {
    var rejectionStr = ObservableField("")
    var rejectionFlag = ObservableField(View.VISIBLE)
    var rejectionReasons = ObservableField("")
    var secondRejectStrs = ObservableField("")
    var secondFlag = ObservableField(View.VISIBLE)
    var secondRejectReasons = ObservableField("")
    var thirdRejectStrs = ObservableField("")
    var thirdFlag = ObservableField(View.VISIBLE)
    var thirdRejectReasons = ObservableField("")
    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_reject_reason, true,
            Gravity.CENTER_VERTICAL, true, WindowManager.LayoutParams.MATCH_PARENT,
            WindowManager.LayoutParams.WRAP_CONTENT
        )
    }

    override fun InitData() {
        binding.rejectDialog = this
        binding.btnConfirm.setOnClickListener {
            dismiss()
        }
        /*给反驳原因赋值*/
        rejectionStr.set(rejectionStrs)
        /*给反驳原因赋值*/
        rejectionReasons.set(rejectionReason)
        if (StringUtils.isEmpty(rejectionStr.get())) rejectionFlag.set(View.GONE)
        secondRejectStrs.set(secondRejectStr)
        secondRejectReasons.set(secondRejectReason)
        if (StringUtils.isEmpty(secondRejectStrs.get())) secondFlag.set(View.GONE)
        thirdRejectStrs.set(thirdRejectStr)
        thirdRejectReasons.set(thirdRejectReason)
        if (StringUtils.isEmpty(thirdRejectStrs.get())) thirdFlag.set(View.GONE)
    }
}