package com.xx.merchanthbh.fragment.adapter;


import static com.xx.merchanthbh.utils.RetrofitClient.baseH5Url;
import static com.xx.merchanthbh.utils.RetrofitClient.baseImgUrl;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;

import com.bumptech.glide.Glide;
import com.bumptech.glide.RequestBuilder;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.databinding.ItemActivitiesCenterBinding;
import com.xx.merchanthbh.ui.web.CommWabActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;
import me.jessyan.autosize.utils.AutoSizeUtils;

public class ActivitiesCenterListAdapter extends xxBaseRecyclerViewAdapter<ItemActivitiesCenterBinding, ActivityCenterBean> implements xxBaseRecyclerViewAdapter.OnItemClick<ActivityCenterBean> {



    public ActivitiesCenterListAdapter(Context mContext) {
        super(mContext);
        itemClick=this;
    }

    @Override
    public int initLayout() {
        return R.layout.item_activities_center;
    }

    @Override
    protected void covert(ItemActivitiesCenterBinding dataBind, ActivityCenterBean data, int position) {
        RequestOptions options = new RequestOptions()
                .bitmapTransform(new RoundedCorners(AutoSizeUtils.dp2px(mContext, 12)));
        RequestBuilder<Bitmap> apply = Glide.with(mContext).asBitmap()
                .apply(options);
        if (StringUtils.isEmpty(data.getActivityCover())) {
            apply = apply.load(R.drawable.quanju_img_quetu);
        } else {
            apply = apply.load(baseImgUrl+data.getActivityCover());
        }
        apply.error(Glide.with(mContext).asBitmap().load(R.drawable.quanju_img_quetu))
                .into(dataBind.ivIdbSelect);

    }

    @Override
    public void itemClickCalBack(int position, ActivityCenterBean data) {

        Intent intent=new Intent(mContext, CommWabActivity.class);
        intent.putExtra("title","活动详情");
        intent.putExtra("URL",baseH5Url+data.getActivityUrl());
        intent.putExtra("activityName",data.getActivityName());

        mContext.startActivity(intent);
    }
}
