package com.xx.merchanthbh.fragment.adapter;
import static com.xx.merchanthbh.utils.RetrofitClient.baseImgUrl;

import android.content.Context;
import android.view.View;
import android.widget.Toast;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.stfalcon.imageviewer.StfalconImageViewer;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AppealBean;
import com.xx.merchanthbh.data.http.respons.AppealFilesBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.databinding.ItemActivityCenterBinding;
import com.xx.merchanthbh.databinding.ItemAppealDetailBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import me.jessyan.autosize.utils.AutoSizeUtils;

public class AppealDetailListAdapter extends xxBaseRecyclerViewAdapter<ItemAppealDetailBinding, Filebean> {

    public AppealDetailListAdapter(Context mContext) {
        super(mContext);
    }

    @Override
    public int initLayout() {
        return R.layout.item_appeal_detail;
    }

    @Override
    protected void covert(ItemAppealDetailBinding dataBind, Filebean data, int position) {
        RequestOptions options = new RequestOptions()
                .bitmapTransform(new RoundedCorners(AutoSizeUtils.dp2px(mContext, 12)));
        Glide.with(mContext).asBitmap()
                .apply(options).load(baseImgUrl+data.getFilePath()).into(dataBind.ivIdbSelect);

        // 设置点击事件监听器
        dataBind.ivIdbSelect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (data != null) {
                    // 图片放大
                    new StfalconImageViewer.Builder<>(mContext, mList, (view, image) -> {
                        Glide.with(mContext).load(baseImgUrl+data.getFilePath()).into(view);
                    }).withStartPosition(position).show();
                }
            }
        });
    }



}
