package com.xx.merchanthbh.fragment.adapter;


import android.content.Context;
import android.view.View;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;
import com.xx.merchanthbh.databinding.ItemJobInformationBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

public class JobInformationListAdapter extends xxBaseRecyclerViewAdapter<ItemJobInformationBinding, JobInformationBean> {
    //educationalRequirement string
    //学历要求 1-硕士及以上 2-本科及以上 3-专科及以上 4-高中及以上 5-初中及以上 6-无
    private String[] educationalMapping = {"硕士及以上", "本科及以上", "专科及以上", "高中及以上", "初中及以上", "无"};
    //workExperience string
    //工作经验 1、1年 2、1-3年 3、3-5年 4、5-7年 5、7-10年 6、10年以上 7、无
    private String[] workExperienceMapping = {"1年", "1-3年", "3-5年", "5-7年", "7-10年", "10年以上", "无"};
    //workPlace string
    //工作地点 1-环渤海河西  2-滨海宏达公司
    private String[] workPlaceMapping = {"环渤海河西", "滨海宏达公司"};

    public JobInformationListAdapter(Context context) {
        super(context);
    }

    @Override
    public int initLayout() {
        return R.layout.item_job_information;
    }

    //    控制子布局的数据dateBinding.绑定的变量   赋值
    @Override
    protected void covert(ItemJobInformationBinding dataBind, JobInformationBean data, int position) {
        dataBind.setJobInformationBean(data);
        // 学历数值转换
        String educationalResult;
        //做判空处理
        if (data.getEducationalRequirement() == null || data.getEducationalRequirement().isEmpty()) {
            educationalResult = "无"; // 如果字符串为空，将value变量赋值为0（或其他默认值）
        } else {
            int educationalValue = Integer.parseInt(data.getEducationalRequirement()); // 这里是接口返回的数值
            if (educationalValue >= 1 && educationalValue <= educationalMapping.length) {
                educationalResult = educationalMapping[educationalValue - 1];
            } else {
                educationalResult = "无"; // 如果数值没有对应的学段，返回一个默认值
            }
        }
        data.setEducationalRequirementti(educationalResult);

        // 工作经验数值转换
        String workExperienceResult;
        //做判空处理
        if (data.getWorkExperience() == null || data.getWorkExperience().isEmpty()) {
            workExperienceResult = "无"; // 如果字符串为空，将value变量赋值为0（或其他默认值）
        } else {
            int workExperienceValue = Integer.parseInt(data.getWorkExperience()); // 这里是接口返回的数值
            if (workExperienceValue >= 1 && workExperienceValue <= workExperienceMapping.length) {
                workExperienceResult = workExperienceMapping[workExperienceValue - 1];
            } else {
                workExperienceResult = "无"; // 如果数值没有对应的学段，返回一个默认值
            }
        }
        data.setWorkExperienceti(workExperienceResult);

        // 工作地点数值转换
        String workPlaceResult;
        //做判空处理
        if (data.getWorkPlace() == null || data.getWorkPlace().isEmpty()) {
            workPlaceResult = "无"; // 如果字符串为空，将value变量赋值为0（或其他默认值）
        } else {
            int workPlaceValue = Integer.parseInt(data.getWorkPlace()); // 这里是接口返回的数值
            if (workPlaceValue >= 1 && workPlaceValue <= workPlaceMapping.length) {
                workPlaceResult = workPlaceMapping[workPlaceValue - 1];
            } else {
                workPlaceResult = "无"; // 如果数值没有对应的学段，返回一个默认值
            }
        }

        if(data.getRecruitmentType().equals("1")){
            dataBind.llEducational.setVisibility(View.VISIBLE);
            dataBind.tvEnterprise.setVisibility(View.GONE);
            dataBind.llWork.setVisibility(View.VISIBLE);
        }else {
            dataBind.llEducational.setVisibility(View.GONE);
            dataBind.tvEnterprise.setVisibility(View.VISIBLE);
            dataBind.llWork.setVisibility(View.GONE);
        }
        data.setWorkPlaceti(workPlaceResult);
    }


}
