package com.xx.merchanthbh.ui.activities;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.ActivitiesRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.databinding.ActivityActivitiesListBinding;
import com.xx.merchanthbh.fragment.adapter.ActivitiesCenterListAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class ActivitiesActivity extends BaseActivity<ActivityActivitiesListBinding, ActivitiesViewModel> implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_activities_list;
    }

    @Override
    public int initVariableId() {
        return BR.activitiesViewModel;
    }


    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        //展示活动列表
        viewModel.activitiesCenterListAdapter = new ActivitiesCenterListAdapter(this);
        binding.rvDblList.setAdapter(viewModel.activitiesCenterListAdapter);
        viewModel.ActivityCenterList.observe(this, new Observer<List<ActivityCenterBean>>() {
            @Override
            public void onChanged(List<ActivityCenterBean> activityCenterBeanList) {
                viewModel.activitiesCenterListAdapter.mList = activityCenterBeanList;
                viewModel.activitiesCenterListAdapter.notifyDataSetChanged();
            }
        });
        viewModel.loadMoreStatic.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 1) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvDblList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMore();
                } else if (it == 2) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvDblList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMoreWithNoMoreData();
                } else if (it == 3) {
                    /*显示recycleView和它的暂无数据列表*/
                    binding.rvDblList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                    binding.refresh.setEnableLoadMore(false);
                }
                binding.refresh.finishRefresh();
            }
        });
        /*调接口*/
        viewModel.getActivityCenterList();
    }

    @Override
    public ActivitiesViewModel initViewModel() {
        ActivitiesRequest lm = new ActivitiesRequest();
        return new ActivitiesViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(RefreshLayout refreshLayout) {
        viewModel.page++;
        viewModel.getActivityCenterList();
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page = 1;
        viewModel.getActivityCenterList();
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
    }
}
