package com.xx.merchanthbh.ui.activities;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;


import me.goldze.mvvmhabit.base.ListBaseViewModel;
import com.xx.merchanthbh.data.http.requst.ActivitiesRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.fragment.adapter.ActivitiesCenterListAdapter;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ActivitiesViewModel extends ListBaseViewModel<ActivitiesRequest> {
    ActivitiesCenterListAdapter activitiesCenterListAdapter;
    //    创建活动中心实体对象
    public MutableLiveData<List<ActivityCenterBean>> ActivityCenterList = new MutableLiveData<>(new ArrayList<>());

    public ActivitiesViewModel(@NonNull Application application) {
        super(application);
    }


    public ActivitiesViewModel(@NonNull Application application, ActivitiesRequest model) {
        super(application, model);
    }
    //调用活动中心的接口信息
    public void getActivityCenterList() {
        model.getActivityList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ActivitiesViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<ActivityCenterBean >() {
                    @Override
                    public void onSuccess(List<ActivityCenterBean> resultBean) {
//                        ActivityCenterList.postValue(resultBean);
                        dismissDialog();
                        if (page == 1) {
                            activitiesCenterListAdapter.mList = resultBean;
                        } else {
                            activitiesCenterListAdapter.mList.addAll(resultBean);
                        }
                        activitiesCenterListAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        if (total==0)
                        {
                            loadMoreStatic.postValue(3);
                        }else if (activitiesCenterListAdapter.mList.size()>=total)
                        {
                            loadMoreStatic.postValue(2);
                        }else {
                            loadMoreStatic.postValue(1);
                        }
                    }


                });
    }

}
