package com.xx.merchanthbh.ui.addproduct

import android.os.Bundle
import android.text.TextUtils
import android.view.View
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.AddProductRequest
import com.xx.merchanthbh.data.http.respons.RejectionBhBean
import com.xx.merchanthbh.data.http.respons.RejectionShelfBean
import com.xx.merchanthbh.databinding.ActivityAddProductBinding
import com.xx.merchanthbh.dialog.OffShelfDialog
import com.xx.merchanthbh.dialog.RejectDialog
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter.OnItemClick
import com.xx.xxviewlibrary.utils.AddImgAdapter
import com.xx.xxviewlibrary.witget.model.FileBean
import me.goldze.mvvmhabit.base.BaseActivity

class AddProductActivity : BaseActivity<ActivityAddProductBinding, AddProductViewModel>() {


    override fun initContentView(savedInstanceState: Bundle?): Int {
      return R.layout.activity_add_product
    }

    override fun initVariableId(): Int {
       return BR.viewModel
    }



    override fun initData() {
        super.initData()



        viewModel.productAdapter= AddImgAdapter(this,ArrayList(),5)
        binding.rvAapProduct.adapter=viewModel.productAdapter
        viewModel.productAdapter.setOnItemClick(object : OnItemClick<FileBean?> {

            override fun itemClickCalBack(position: Int, data: FileBean?) {
                viewModel.openPhoto( viewModel.productAdapter,position)
            }
        })


        viewModel.detailAdapter= AddImgAdapter(this,ArrayList(),5)
        binding.rvAapDetail.adapter=viewModel.detailAdapter
        viewModel.detailAdapter.setOnItemClick(object : OnItemClick<FileBean?> {

            override fun itemClickCalBack(position: Int, data: FileBean?) {
                viewModel.openPhoto( viewModel.detailAdapter,position)
            }
        })

        if(!TextUtils.isEmpty(intent.getStringExtra("goodsId")))
        {
            viewModel.getInfo(intent.getStringExtra("goodsId"));
            viewModel.title.set("编辑商品")
            binding.btnAapSave.setText("确定")
            binding.btnAapDraft.visibility= View.GONE;
        }




        /*下架原因回显*/
        val rejectionReason = viewModel.remark.value
        viewModel.showOffShelfDialog.observe(
            this
        ) { show: RejectionShelfBean? ->
            val rejectionPerson = viewModel.operator.value
            val rejectionReason = viewModel.remark.value
            val rejectionDialog =
                OffShelfDialog(this, rejectionPerson!!, rejectionReason!!)
            rejectionDialog.show()
        }
        // 如果有下架原因则显示控件
        viewModel.remark.observe(this) { remark: String? ->
            if (remark != null) {
//                binding.rejectReasonTip.visibility = View.VISIBLE
            }
        }

        /*驳回原因回显*/
        val rejectionBhReason = viewModel.remark.value
        viewModel.showRejectDialog.observe(
            this
        ) { show: RejectionBhBean? ->
            val rejectionStr = viewModel.operationStr.value
            val rejectionReason = viewModel.remark.value
            val secondRejectStr = viewModel.secondRejectStr.value
            val secondRejectionReason = viewModel.secondRejectReason.value
            val thirdRejectionStr = viewModel.thirdRejectStr.value
            val thirdRejectionReason = viewModel.thirdRejectReason.value

            val rejectionDialog =
                RejectDialog(this, rejectionStr!!, rejectionReason!!,secondRejectStr!!, secondRejectionReason!!, thirdRejectionStr!!, thirdRejectionReason!!)
            rejectionDialog.show()
        }
        // 如果有驳回原因则显示控件
        viewModel.remark.observe(this) { remark: String? ->
            if (remark != null) {
//                binding.rejectReasonTip.visibility = View.VISIBLE
            }
        }

    }



    override fun initViewModel(): AddProductViewModel {
        val lm: AddProductRequest = AddProductRequest()
        return AddProductViewModel(application,lm)
    }
}