package com.xx.merchanthbh.ui.addproduct;

import android.app.Application;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.AddProductRequest;
import com.xx.merchanthbh.data.http.respons.CategoryBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.ProductBean;
import com.xx.merchanthbh.data.http.respons.RecentRejectionBhLogBean;
import com.xx.merchanthbh.data.http.respons.RejectionBhBean;
import com.xx.merchanthbh.data.http.respons.RejectionShelfBean;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.dialog.ProductTypeDialog;
import com.xx.merchanthbh.dialog.data.ProductTypeProvider;
import com.xx.merchanthbh.dialog.data.TextListProvider;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.BaseResponse;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class AddProductViewModel extends BaseViewModel<AddProductRequest> {
    /*操作说明*/
    public MutableLiveData<String> operationStr = new MutableLiveData<>("");
    /*操作人*/
    public MutableLiveData<String> operator = new MutableLiveData<>("");
    /*下架原因*/
    public MutableLiveData<String> remark = new MutableLiveData<>("");
    public MutableLiveData<String> secondRejectReason = new MutableLiveData<>("");
    public MutableLiveData<String> secondRejectStr = new MutableLiveData<>("");
    public MutableLiveData<String> thirdRejectReason = new MutableLiveData<>("");
    public MutableLiveData<String> thirdRejectStr = new MutableLiveData<>("");
    //展示下架原因弹窗
    public MutableLiveData<RejectionShelfBean> showOffShelfDialog = new MutableLiveData<>();
    //展示驳回原因弹窗
    public MutableLiveData<RejectionBhBean> showRejectDialog = new MutableLiveData<RejectionBhBean>();

    public String goodsId = null;

    public ObservableField<String> title = new ObservableField<>("添加商品");


    public MutableLiveData<String> name;

    //品牌是否隐藏
    public MutableLiveData<Integer> brandGone = new MutableLiveData(View.GONE);

    //品牌清空是否隐藏
    public ObservableField<Integer> brandDeleteGone = new ObservableField(View.GONE);

    //下架原因是否隐藏
    public ObservableField<Integer> RecentRejectionGone = new ObservableField(View.GONE);

    //驳回原因是否隐藏
    public ObservableField<Integer> RecentBhGone = new ObservableField(View.GONE);
    /*下架原因*/
    public String RecentRejectionStr = "";
    /*驳回原因*/
    public String RecentBhStr = "";
    /**
     * productAdapter 商品图片
     * detailAdapter 详细图片
     */
    public AddImgAdapter productAdapter, detailAdapter;

    public ProductTypeProvider categoryDialogData;

    public ObservableField<String> pNumber = new ObservableField<>("");

    public ObservableField<String> pName = new ObservableField<>("");

    public ObservableField<String> pDescribe = new ObservableField<>("");

    public ObservableField<String> pPrice = new ObservableField<>("");

    public ObservableField<String> pType = new ObservableField<>("请选择");

    public String typeId = "";

    public ObservableField<String> pBrand = new ObservableField<>("请选择");

    public String brandID = null;

    public AddProductViewModel(@NonNull Application application) {
        super(application);
    }

    public AddProductViewModel(@NonNull Application application, AddProductRequest model) {
        super(application, model);
    }

    @Override
    public void onResume() {
        super.onResume();
        getCategoryData();
        if (model.getMerchantBean().getBrandAuthorizationList().size() <= 0) {
            brandGone.setValue(View.GONE);
        } else {
            brandGone.setValue(View.VISIBLE);
        }
    }

    /**
     * 上传图片
     *
     * @param type
     * @param position
     */
    public void openPhoto(AddImgAdapter type, int position) {


        int max = 1;
        if (TextUtils.isEmpty(productAdapter.mList.get(position).getId())) {
            max = 5 - productAdapter.getItemCount() + 1;
        }


        startPhotoPage(true, max,"申请的是摄像头和照片视频读取权限，用于添加商品图片时读取和写入相册和文件内容", new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                List<File> fList = new ArrayList<>();
                for (Photo p : photos) {
                    fList.add(new File(p.path));
                }

                model.upLoadFiles(fList).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(AddProductViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {

                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {

                                if (TextUtils.isEmpty(type.mList.get(position).getId())) {

                                    List<FileBean> fList = new ArrayList<>();
                                    for (Filebean fb : resultBean) {
                                        fList.add(new FileBean(fb.getBusinessId(), fb.getUrl()));
                                    }
                                    type.addImg(fList);
                                } else {
                                    type.mList.get(position).setId(resultBean.get(0).getBusinessId());
                                    type.mList.get(position).setPath(resultBean.get(0).getUrl());
                                }

                                type.notifyDataSetChanged();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 获取分类数据
     */
    public void getCategoryData() {
        model.getCategory().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddProductViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<List<CategoryBean>>() {
                    @Override
                    public void onSuccess(List<CategoryBean> resultBean) {
                        categoryDialogData = new ProductTypeProvider(resultBean);
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

    /**
     * 添加商品
     *
     * @param view
     */
    public void saveDrafts(View view) {

        if (TextUtils.isEmpty(pName.get())) {
            ToastUtils.showShort("请输入商品名称！");
            return;
        }

        //获取图片数据
        String productImgs = StringUtils.join(productAdapter.mList, ",", (data) -> data.getId()).replace(",null", "").replace("null", "");
        String describeImgs = StringUtils.join(detailAdapter.mList, ",", (data) -> data.getId()).replace(",null", "").replace("null", "");
        if (TextUtils.isEmpty(productImgs)) {
            ToastUtils.showShort("请添加商品图片！");
            return;
        }
        //分辨放入草稿和提交
        String staticSttr;
        if (view.getId() == R.id.btn_aap_draft) {
            staticSttr = "1";
        } else {
            staticSttr = "2";
        }

        if (TextUtils.isEmpty(typeId)) {
            ToastUtils.showShort("请选择商品分类！");
            return;
        }

        if (TextUtils.isEmpty(pPrice.get())) {
            ToastUtils.showShort("请输入商品价格！");
            return;
        }
        Observable<BaseResponse<Object>> observable;
        if (TextUtils.isEmpty(goodsId)) {
            observable = model.addProduct(pNumber.get(), pName.get(), productImgs, describeImgs, typeId, pPrice.get(), pDescribe.get(), brandID, staticSttr);
        } else {
            observable = model.changeProduct(goodsId, pNumber.get(), pName.get(), productImgs, describeImgs, typeId, pPrice.get(), pDescribe.get(), brandID);
        }
        observable.compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddProductViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Object>() {
                    @Override
                    public void onSuccess(Object resultBean) {
                        finish();
                        if (TextUtils.isEmpty(goodsId)) {
                            ToastUtils.showShort("添加成功");
                        } else {
                            ToastUtils.showShort("修改成功");
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /**
     * 显示分类弹窗
     *
     * @param view
     */
    public void showCategoryDialog(View view) {
        ProductTypeDialog dialog = new ProductTypeDialog(view.getContext(), categoryDialogData);
        dialog.setDialogClickListener(new xxBaseDialog.onDialogClickListener<ProductTypeDialog.ProductTypeCurrent>() {
            @Override
            public void dialogClickBack(int code, ProductTypeDialog.ProductTypeCurrent data) {
                typeId = data.getId();
                pType.set(data.getContext());
                dialog.dismiss();
            }
        });
        dialog.show();
    }


    public void openBrankDialog(View view) {
        BoothListDialog dialoh = new BoothListDialog(view.getContext(), "请选择品牌名称", model.getMerchantBean().getBrandAuthorizationList(), brandID);
        dialoh.setDialogClickListener(new xxBaseDialog.onDialogClickListener<TextListProvider>() {
            @Override
            public void dialogClickBack(int code, TextListProvider data) {
                if (data != null) {
                    pBrand.set(data.providerText());
                    brandID = data.ProviderId();
                    brandDeleteGone.set(View.VISIBLE);
                }

            }
        });

        dialoh.show();
    }

    /**
     * 获取商品详情
     *
     * @param id
     */

    public void getInfo(String id) {

        goodsId = id;
        model.getProductInfo(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddProductViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<ProductBean>() {
                    @Override
                    public void onSuccess(ProductBean resultBean) {
                        /*下架原因字段判空*/
                        if (resultBean.getStatus().equals("4")) {
                            /*获取下架人*/
                            if (resultBean.getRecentDeactivatedLog() != null && resultBean.getRecentDeactivatedLog().getOperator() != null && !resultBean.getRecentDeactivatedLog().getOperator().isEmpty()) {
                                operator.setValue(resultBean.getRecentDeactivatedLog().getOperator());
                            } else {
                                Log.e("下架人为空", "RecentDeactivatedLog or its operator is null or empty");
                            }
                            /*获取下架原因*/
                            if (resultBean.getRecentDeactivatedLog() != null && resultBean.getRecentDeactivatedLog().getMark() != null && !resultBean.getRecentDeactivatedLog().getMark().isEmpty()) {
                                remark.setValue(resultBean.getRecentDeactivatedLog().getMark());
                            } else {
                                Log.e("下架原因为空", "RecentDeactivatedLog or its mark is null or empty");
                            }
                        }
                        if (resultBean.getRecentDeactivatedLog() == null) {
                            /*隐藏下架*/
                            RecentRejectionGone.set(View.GONE);
                        } else {
                            RecentRejectionGone.set(View.VISIBLE);
                            RecentRejectionStr = resultBean.getRecentDeactivatedLog().getMark();
                        }
                        /*显示驳回-----------------*/
                        List<RecentRejectionBhLogBean> recentRejectionLogList = resultBean.getRecentRejectionLogList();
                        if (recentRejectionLogList.size() > 0) {
                            /*显示驳回*/
                            RecentBhGone.set(View.VISIBLE);
                            RecentBhStr = recentRejectionLogList.get(0).getMark();
                            switch (recentRejectionLogList.size()) {
                                case 3:
                                    thirdRejectStr.setValue(recentRejectionLogList.get(2).getOperationStr());
                                    thirdRejectReason.setValue(recentRejectionLogList.get(2).getMark());
                                case 2:
                                    secondRejectStr.setValue(recentRejectionLogList.get(1).getOperationStr());
                                    secondRejectReason.setValue(recentRejectionLogList.get(1).getMark());
                                case 1:
                                    operationStr.setValue(recentRejectionLogList.get(0).getOperationStr());
                                    remark.setValue(recentRejectionLogList.get(0).getMark());
                            }
                        }
                        typeId = resultBean.getCategoryId();
                        if (!TextUtils.isEmpty(resultBean.getCommodityCode())) {
                            pNumber.set(resultBean.getCommodityCode());
                        }
                        pName.set(resultBean.getCommodityName());


                        productAdapter.mList.clear();
                        for (Filebean bean : resultBean.getFileList()) {
                            productAdapter.mList.add(new FileBean(bean.getBusinessId(), bean.getUrl()));
                        }

                        if (productAdapter.mList.size() < 5) {
                            productAdapter.mList.add(new FileBean("", ""));
                        }
                        productAdapter.notifyDataSetChanged();

                        detailAdapter.mList.clear();
                        for (Filebean bean : resultBean.getDetailImagesList()) {
                            detailAdapter.mList.add(new FileBean(bean.getBusinessId(), bean.getUrl()));
                        }

                        if (detailAdapter.mList.size() < 5) {
                            detailAdapter.mList.add(new FileBean("", ""));
                        }
                        detailAdapter.notifyDataSetChanged();


                        pType.set(resultBean.getCategoryNameStr());
                        pPrice.set(resultBean.getCommodityPrice() + "");

                        if (!TextUtils.isEmpty(resultBean.getCommodityDescriptionText())) {
                            pDescribe.set(resultBean.getCommodityDescriptionText());
                        }

                        if (!TextUtils.isEmpty(resultBean.getBrandName())) {
                            brandID = resultBean.getBrandAuthorization().getBusinessId();
                            pBrand.set(resultBean.getBrandName());
                            brandDeleteGone.set(View.VISIBLE);
                        }


                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }


    public void clearBrand(View view) {
        pBrand.set("");
        brandID = null;
        brandDeleteGone.set(View.GONE);
    }

    /**
     * 查看商品下架原因
     */
    public void showReason(View view) {
        boolean deFlag = true;
        RejectionShelfBean rejectionShelfBean = new RejectionShelfBean(deFlag, operator.getValue(), remark.getValue());
        showOffShelfDialog.postValue(rejectionShelfBean);
        /*   showCommTextDialog(new RefuseDialogBean(RecentRejectionStr,"确定",null,"下架意见"), new CommTextDialog.onAcceptCallBack() {
            @Override
            public void acceptBack() {

            }

            @Override
            public void refuseBack() {

            }
        });*/
    }
    /**
     * 查看商品驳回原因
     */
    public void showRejectReason(View view) {
        boolean deFlag = true;
        RejectionBhBean rejectionBhBean = new RejectionBhBean(deFlag, operationStr.getValue(), remark.getValue());
        showRejectDialog.postValue(rejectionBhBean);
    }


}
