package com.xx.merchanthbh.ui.appeal;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.MainActivity;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.AppealRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AppealBean;
import com.xx.merchanthbh.data.http.respons.AppealFilesBean;
import com.xx.merchanthbh.data.http.respons.AppealListBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityAppealDetailBinding;
import com.xx.merchanthbh.databinding.ActivityAppealEditBinding;
import com.xx.merchanthbh.dialog.RejectionDialog;
import com.xx.merchanthbh.fragment.adapter.ActivitiesCenterListAdapter;
import com.xx.merchanthbh.fragment.adapter.ActivityCenterListAdapter;
import com.xx.merchanthbh.fragment.adapter.AppealDetailListAdapter;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;

public class AppealDetailActivity extends BaseActivity<ActivityAppealDetailBinding, AppealDetailViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_appeal_detail;
    }

    @Override
    public int initVariableId() {
        return BR.appealDetailViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*调取诉求详情*/
        viewModel.getAppealDetailById(getIntent().getStringExtra("appealId"));
        //展示上传图片列表
        AppealDetailListAdapter adapter = new AppealDetailListAdapter(this);
        binding.rvDblList.setAdapter(adapter);

        viewModel.showRejectionDialog.observe(this, show -> {
            String rejectionReason = viewModel.remark.getValue();
            RejectionDialog rejectionDialog = new RejectionDialog(this,rejectionReason);
            rejectionDialog.show();
        });
        // 如果有驳回原因则显示控件
        viewModel.remark.observe(this, remark -> {
            if (remark != null) {
                binding.rejectReasonTip.setVisibility(View.VISIBLE);
            }
        });
        viewModel.AppealDetailList.observe(this, new Observer<List<Filebean>>() {
            @Override
            public void onChanged(List<Filebean> appealFilesBeans) {

                /*判断图片列表是否是空*/
                if (StaticData.imageFilesData == 0) {
                    Log.d("这是为了看是否上传图片的列表为空", "Adapter is not null");
                    binding.uploadImagsId.setVisibility(View.VISIBLE);
                } else {
                    Log.d("这是为了看是否上传图片的列表为空", "Adapter is null");
                    /*上传图片模块隐藏*/
                    binding.uploadImagsId.setVisibility(View.GONE);
                }
                adapter.mList = appealFilesBeans;
                adapter.notifyDataSetChanged();
            }

        });

    }

    @Override
    public AppealDetailViewModel initViewModel() {
        AppealRequest lm = new AppealRequest();
        return new AppealDetailViewModel(getApplication(), lm);
    }

}
