package com.xx.merchanthbh.ui.appeal;

import static me.goldze.mvvmhabit.utils.Utils.getContext;

import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.AppealRequest;
import com.xx.merchanthbh.databinding.ActivityAppealEditBinding;
import com.xx.merchanthbh.dialog.RejectionDialog;
import com.xx.merchanthbh.dialog.SignDialog;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.util.ArrayList;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;

public class AppealEditActivity extends BaseActivity<ActivityAppealEditBinding, AppealEditViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_appeal_edit;
    }

    @Override
    public int initVariableId() {
        return BR.appealEditViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*调取诉求详情*/
        viewModel.getAppealDetailById(getIntent().getStringExtra("appealId"));
        // 调用ViewModel的方法来刷新昵称
        viewModel.refreshNickName();
        viewModel.showRejectionDialog.observe(this, show -> {
            String rejectionReason = StringUtils.isEmpty(viewModel.remark.getValue()) ? "" : viewModel.remark.getValue();
            RejectionDialog rejectionDialog = new RejectionDialog(this, rejectionReason);
            rejectionDialog.show();
        });

        // 如果有驳回原因则显示控件
        viewModel.remark.observe(this, remark -> {
            if (remark != null) {
                binding.rejectReasonTip.setVisibility(View.VISIBLE);
            }
        });


        /*上传图片*/
        viewModel.appealPicsAdapter = new AddImgAdapter(this, new ArrayList(), 5, true);
        binding.rvAapProduct.setAdapter(viewModel.appealPicsAdapter);
        viewModel.appealPicsAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<FileBean>() {
            @Override
            public void itemClickCalBack(int position, FileBean data) {
                viewModel.openPhoto(viewModel.appealPicsAdapter, position);
            }
        });

    }

    @Override
    public AppealEditViewModel initViewModel() {
        AppealRequest lm = new AppealRequest();
        return new AppealEditViewModel(getApplication(), lm);
    }

}
