package com.xx.merchanthbh.ui.appeal;

import android.app.AlertDialog;
import android.app.Application;
import android.content.DialogInterface;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.xx.merchanthbh.data.http.requst.AppealRequest;
import com.xx.merchanthbh.data.http.respons.AppealBean;
import com.xx.merchanthbh.data.http.respons.AppealFilesBean;
import com.xx.merchanthbh.data.http.respons.AppealTypeBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.RejectionBean;
import com.xx.merchanthbh.dialog.AppealTypeListDialog;
import com.xx.merchanthbh.dialog.RejectionDialog;
import com.xx.merchanthbh.dialog.data.TextListProvider;
import com.xx.merchanthbh.ui.home.HomeViewModel;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;

public class AppealEditViewModel extends BaseViewModel<AppealRequest> {
    /*创建反馈类型数据字典实体对象*/
    public List<AppealTypeBean> appealTypeBeanList = new ArrayList<>();
    //展示驳回原因弹窗
    public MutableLiveData<RejectionBean> showRejectionDialog = new MutableLiveData<>();
    /*创建反馈类型的label*/
    public ObservableField<String> dictLabel = new ObservableField<>("");
    /*创建反馈类型的sort*/
    public String dictSort = null;
    /*businessId*/
    public ObservableField<String> businessId = new ObservableField<>("");
    /*诉求商户*/
    public ObservableField<String> appealCustom = new ObservableField<>("");
    /*诉求商户id*/
    public ObservableField<String> appealCustomId = new ObservableField<>("");
    /*反馈人*/
    public ObservableField<String> appealPerson = new ObservableField<>("");
    /*联系方式*/
    public ObservableField<String> appealPhone = new ObservableField<>("");
    /*文字描述*/
    public ObservableField<String> appealDescribe = new ObservableField<>("");
    /*上传图片*/
    public ObservableField<String> imgFList = new ObservableField<>("");
    /*上传图片*/
    public AddImgAdapter appealPicsAdapter;
    List<FileBean> fList = new ArrayList<>();

    /*驳回原因*/
    public MutableLiveData<String> remark = new MutableLiveData<>(null);

    public AppealEditViewModel(@NonNull Application application) {
        super(application);
    }

    public AppealEditViewModel(@NonNull Application application, AppealRequest model) {
        super(application, model);
    }

    private void setValueToNickName() {

    }

    public void refreshNickName() {
        setValueToNickName();
    }

    /*获取诉求详情*/
    public void getAppealDetailById(String id) {
        model.getAppealDetailById(id)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AppealEditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<AppealBean>() {
                    @Override
                    public void onSuccess(AppealBean resultBean) {
                        /*businessId*/
                        businessId.set(String.valueOf(resultBean.getBusinessId()));
                        /*反馈人*/
                        appealPerson.set(String.valueOf(resultBean.getFeedbackPerson()));
                        /*联系方式*/
                        appealPhone.set(String.valueOf(resultBean.getContactMode()));
                        /*描述*/
                        appealDescribe.set(String.valueOf(resultBean.getLiteralDescription()));
                        /*所属商户*/
                        appealCustom.set(String.valueOf(resultBean.getMerchant().getCompanyName()));
                        /*所属商户id*/
                        appealCustomId.set(String.valueOf(resultBean.getMerchantId()));
                        /*反馈类型*/
                        dictSort = String.valueOf(resultBean.getAppAppealType());
                        /*驳回原因赋值*/
                        if (!resultBean.getOperations().isEmpty()) {
                            Log.v("resultBean.getOperations().size()", String.valueOf(resultBean.getOperations().size()));
                            /*取操作日志最新的一条的remark*/
                            remark.setValue(resultBean.getOperations().get(resultBean.getOperations().size() - 1).getRemark());
                        }
                        /*上传图片*/
                        appealPicsAdapter.mList.clear();

                        for (Filebean appealFile : resultBean.getAppealFiles()) {
                            fList.add(new FileBean(appealFile.getBusinessId(), appealFile.getUrl()));
                        }
                        appealPicsAdapter.mList = fList;
                        if (appealPicsAdapter.mList.size() < 5) {
                            appealPicsAdapter.mList.add(new FileBean("", ""));
                        }

                        appealPicsAdapter.notifyDataSetChanged();
                        getAppealTypesList();

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /*获取反馈类型列表(数据字典)*/
    public void getAppealTypesList() {
        model.getAppealTypeList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AppealEditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AppealTypeBean>>() {
                    @Override
                    public void onSuccess(List<AppealTypeBean> resultBean) {
                        /*清空反馈类型数据列表*/
                        appealTypeBeanList.clear();
                        /*将接口的数据字典放入*/
                        appealTypeBeanList.addAll(resultBean);
                        /*在初始页面的时候要给选择器(反馈类型)一个初始值*/
                        dictLabel.set(resultBean.get(Integer.parseInt(dictSort)).getDictLabel());
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /*反馈类型选择*/
    public void openType(View view) {
        /*创建弹窗的adapter遍历*/
        AppealTypeListDialog dialoh = new AppealTypeListDialog(view.getContext(), appealTypeBeanList);
        dialoh.setDialogClickListener(new xxBaseDialog.onDialogClickListener<TextListProvider>() {
            /*最后点击确定以后执行set*/
            @Override
            public void dialogClickBack(int code, TextListProvider data) {
                if (data != null) {
                    /*选择以后把所在的label给set进去*/
                    dictLabel.set(data.providerText());
                    /*选择以后把所在的value给set进去*/
                    dictSort = data.ProviderId();
                }
            }
        });
        /*展示弹窗*/
        dialoh.show();
    }

    /*查看原因的弹窗*/
    public void openReason(View view) {
        boolean deFlag = true;
        RejectionBean rejectionBean = new RejectionBean(deFlag, StringUtils.isEmpty(remark.getValue()) ? "" : remark.getValue());
        showRejectionDialog.postValue(rejectionBean);
    }    /*上传图片*/
    public void openPhoto(AddImgAdapter type, int position) {
        int max = 1;
        if (TextUtils.isEmpty(appealPicsAdapter.mList.get(position).getId())) {
            max = 5 - appealPicsAdapter.getItemCount() + 1;
        }


        startPhotoPage(true, max, "申请的是摄像头和照片视频读取权限，用于在诉求场景中读取和写入相册和文件内容",new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                List<File> fList = new ArrayList<>();
                for (Photo p : photos) {
                    fList.add(new File(p.path));
                }

                model.upLoadFiles(fList).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(AppealEditViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {

                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {

                                if (TextUtils.isEmpty(type.mList.get(position).getId())) {


                                    List<FileBean> fList = new ArrayList<>();
                                    for (Filebean fb : resultBean) {
                                        fList.add(new FileBean(fb.getBusinessId(), fb.getUrl()));
                                    }
                                    type.addImg(fList);
                                } else {
                                    type.mList.get(position).setId(resultBean.get(0).getBusinessId());
                                    type.mList.get(position).setPath(resultBean.get(0).getUrl());
                                }

                                type.notifyDataSetChanged();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /*最后的提交修改诉求*/
    public void submitAppeal(View view) {
        /*上传图片*/
        /*把图片转成list<String>类型*/
        List<String> uploadImgs = null;
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.N) {
            uploadImgs = appealPicsAdapter.mList.stream()
                    .map(fileBean -> fileBean.getId())
                    .collect(Collectors.toList());
        }

        /*依次传入businessId,反馈类型,诉求商户,反馈人,联系方式,文字描述,上传图片*/
        /*调用request的添加接口*/
        model.postEditAppeal(businessId.get(), dictSort, appealCustomId.get(), appealPerson.get(), appealPhone.get(), appealDescribe.get(), uploadImgs).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AppealEditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        finish();
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }


    //跳转诉求反馈详情
    public BindingCommand goAppealEdit = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealActivity.class);
        }

    });
}
