package com.xx.merchanthbh.ui.appeallist

import android.os.Bundle
import android.view.View
import com.google.android.material.tabs.TabLayout
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener
import com.scwang.smart.refresh.layout.listener.OnRefreshListener
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.activity.adapter.MessageListAdapter
import com.xx.merchanthbh.data.http.requst.AppealListRequest
import com.xx.merchanthbh.data.http.respons.AppealListBean
import com.xx.merchanthbh.data.http.respons.MessageBean
import com.xx.merchanthbh.databinding.ActivityAppealListBinding
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter.OnItemClick
import me.goldze.mvvmhabit.base.BaseActivity

class AppealListActivity : BaseActivity<ActivityAppealListBinding, AppealListViewModel>(),
    OnRefreshListener, OnLoadMoreListener {
    override fun initContentView(savedInstanceState: Bundle?): Int {
        return R.layout.activity_appeal_list
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }

    override fun initData() {

        super.initData()

        //获取适配器上下文
        val appealListAdapter = AppealListAdapter(this)
        binding.refresh.setOnRefreshListener(this)
        binding.refresh.setOnLoadMoreListener(this)
        viewModel.adapter = AppealListAdapter(this)
        binding.rvAppealList.adapter = viewModel.adapter
        viewModel.getAppealList()
        // 对列表遍历项设置点击事件
        appealListAdapter.setOnItemClick { position, data ->
            /*返回位置参数*/
            /*将上下文和位置参数给方法*/
            viewModel.goAppealDetail(appealListAdapter, position)
        }


        //控制刷新加载状态
        viewModel.loadMoreStatic.observe(
            this
        ) {
            if (it == 1) {
                binding.rvAppealList.visibility= View.VISIBLE
                binding.llNoData.visibility= View.GONE
                binding.refresh.finishLoadMore();
            } else if (it == 2) {
                binding.rvAppealList.visibility= View.VISIBLE
                binding.llNoData.visibility= View.GONE
                binding.refresh.finishLoadMore();
                binding.refresh.setEnableLoadMore(false);
            }else if(it==3)
            {
                binding.rvAppealList.visibility= View.GONE
                binding.llNoData.visibility= View.VISIBLE
                binding.refresh.setEnableLoadMore(false);
            }
            binding.refresh.finishRefresh()
        }
        binding.tabs.addOnTabSelectedListener(object : TabLayout.OnTabSelectedListener {
            override fun onTabSelected(tab: TabLayout.Tab?) {
                viewModel.page = 1
                viewModel.adapter.mList.clear()
                binding.refresh.setEnableLoadMore(true)
                when (tab?.position) {
                    0 -> viewModel.appealStatus = arrayOf("1", "2", "3", "4")
                    1 -> viewModel.appealStatus = arrayOf("1", "3")
                    2 -> viewModel.appealStatus = arrayOf("4")
                    3 -> viewModel.appealStatus = arrayOf("2")
                }

                viewModel.getAppealList()
            }

            override fun onTabUnselected(tab: TabLayout.Tab?) {
            }

            override fun onTabReselected(tab: TabLayout.Tab?) {
            }

        })

    }

    override fun initViewModel(): AppealListViewModel {
        val lm: AppealListRequest = AppealListRequest()
        return AppealListViewModel(application, lm)
    }


    override fun onLoadMore(refreshLayout: RefreshLayout) {
        viewModel.page++;
        viewModel.getAppealList();
    }



    override fun onRefresh(refreshLayout: RefreshLayout) {
        viewModel.page = 1;
        viewModel.getAppealList();
        binding.refresh.setEnableLoadMore(true)
    }


}