package com.xx.merchanthbh.ui.assistant;

import android.app.Application;
import android.util.Log;
import android.view.View;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.merchanthbh.data.http.requst.AssistantAddRequest;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class AssistantAddViewModel extends BaseViewModel<AssistantAddRequest> {
    //员工名字绑定
    public ObservableField<String> shopAssistantName = new ObservableField<>("");
    //员工手机号绑定
    public ObservableField<String> shopAssistantPhone = new ObservableField<>("");
    //员工性别绑定
    public ObservableField<String> sex = new ObservableField<>("");

    /*性别存储*/
    public String sexValue = "0";

    public AssistantAddViewModel(@NonNull Application application) {
        super(application);
    }

    public AssistantAddViewModel(@NonNull Application application, AssistantAddRequest model) {
        super(application, model);
    }


    public void initSexListener(RadioGroup radioGroup) {
        radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                RadioButton radioButton = group.findViewById(checkedId);
                if (radioButton != null) {
                    sex.set(radioButton.getText().toString());
                    Log.v("sex的值啊啊啊啊", String.valueOf(sex.get()));
                    /*用户性别,0=男,1=女,2=未知*/
                    /*转换!!!!!!!!!!!!!!!!!!!!*/
                    sexValue = sex.get();
                    Log.v("sexValue刚开始的值",sexValue);
                    if (sexValue.contains("男")) {
                        sexValue = "0";
                        Log.v("选择男的话",sexValue);
                    } else if (sexValue.contains("女")) {
                        sexValue = "1";
                        Log.v("选择女的话",sexValue);
                    } else {
                        sexValue = "2";
                        Log.v("选择未知的话",sexValue);
                    }
                }
            }
        });
    }

    /**
     * 提交店员信息
     *
     * @param view
     */
    public void submitAssistantMsg(View view) {
        model.postAssistantMsg(shopAssistantName.get(), shopAssistantPhone.get(), sexValue).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AssistantAddViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        dismissDialog();
                        /*成功后的跳转*/
                        finish();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }
}
