package com.xx.merchanthbh.ui.assistant;

import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.AssistantInformationAdapter;
import com.xx.merchanthbh.activity.adapter.OrderListAdapter;
import com.xx.merchanthbh.data.http.requst.AssistantManagementRequest;
import com.xx.merchanthbh.data.http.respons.AppealFilesBean;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityAssistantManagementBinding;
import com.xx.merchanthbh.ui.msg.MessageActivity;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class AssistantManagementActivity extends BaseActivity<ActivityAssistantManagementBinding, AssistantManagementViewModel> implements OnRefreshListener, OnLoadMoreListener {
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(AssistantManagementActivity.this::onLoadMore);
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
//        获取适配器上下文
        viewModel.adapter = new AssistantInformationAdapter(this, viewModel);
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
        //把adapter set进去
        binding.rvAssistantList.setAdapter(viewModel.adapter);

        if (LocalData.getUser().getUserId() != LocalData.getMerchant().getUserId()) {
            binding.bar.getImg_right().setVisibility(View.GONE);
        } else {
            binding.bar.getImg_right().setVisibility(View.VISIBLE);
            binding.bar.getImg_right().setImageDrawable(getResources().getDrawable(R.drawable.dianyuanguanli_icon_xinzeng));
        }
        viewModel.assistantInformationList.observe(this, new Observer<List<AssistantInformationBean>>() {
            @Override
            public void onChanged(List<AssistantInformationBean> assistantInformationBeans) {
                /*判断列表是否是空*/
                if (assistantInformationBeans.size() > 0) {
                    Log.d("这是为了看列表为空", "店员列表不为空");
                    /*模块隐藏*/
                    binding.llNoData.setVisibility(View.GONE);
                    binding.refresh.finishLoadMoreWithNoMoreData();
                } else {
                    Log.d("这是为了看列表为空", "店员列表为空");
                    binding.llNoData.setVisibility(View.VISIBLE);
                    binding.refresh.closeHeaderOrFooter();
                }
            }
        });
        viewModel.loadMoreStatic.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 1) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvAssistantList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMore();
                } else if (it == 2) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvAssistantList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMoreWithNoMoreData();
                }else if(it==3)
                {
                    /*显示recycleView和它的暂无数据列表*/
                    binding.rvAssistantList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                }
                binding.refresh.finishRefresh();
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (StaticData.AssistantData == 1) {
            binding.llNoData.setVisibility(View.VISIBLE);
        }else {
            binding.llNoData.setVisibility(View.GONE);
        }
        /*调接口*/
        viewModel.geAssistantList();
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_assistant_management;
    }

    @Override
    public int initVariableId() {
        return BR.assistantManagementViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
    }

    @Override
    public AssistantManagementViewModel initViewModel() {
        AssistantManagementRequest lm = new AssistantManagementRequest();
        return new AssistantManagementViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(RefreshLayout refreshLayout) {
        viewModel.page++;
        viewModel.geAssistantList();
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.geAssistantList();
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
    }
}
