package com.xx.merchanthbh.ui.bill

import android.os.Build.VERSION_CODES.S
import android.os.Bundle
import android.os.Parcel
import android.os.Parcelable
import android.text.Editable
import android.text.TextUtils.split
import android.text.TextWatcher
import android.util.Log
import android.view.View
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.BillListRequst

import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener
import com.scwang.smart.refresh.layout.listener.OnRefreshListener
import com.xx.merchanthbh.data.http.respons.EletricListBean
import com.xx.merchanthbh.data.staticdata.StaticData
import com.xx.merchanthbh.databinding.ActivityBillListBinding
import com.xx.merchanthbh.dialog.DataPickerDialog
import com.xx.merchanthbh.dialog.SinglePickerDialog
import com.xx.merchanthbh.dialog.data.TextListProvider
import com.xx.merchanthbh.ui.billdetail.OrderStatusData
import com.xx.merchanthbh.ui.electric.ElectricPayViewModel
import me.goldze.mvvmhabit.base.BaseActivity
import me.goldze.mvvmhabit.binding.viewadapter.edittext.ViewAdapter.addTextChangedListener

class BillListActivity() : BaseActivity<ActivityBillListBinding, BillListViewModel>(),
    OnRefreshListener, OnLoadMoreListener {


    override fun initContentView(savedInstanceState: Bundle?): Int {
        return R.layout.activity_bill_list
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }


    override fun initData() {
        super.initData()
        /*状态筛选项重置*/
        StaticData.statusStr = ""
        /*电表筛选项重置*/
        StaticData.itemName = ""
        /*日期选项重置*/
        StaticData.dateYearsStr = ""
        StaticData.dateMonthsStr = ""

        binding.refresh.setOnRefreshListener(this)
        binding.refresh.setOnLoadMoreListener(this)


        viewModel.adapter = BillListAdapter(this, viewModel)
        binding.rvBillList.adapter = viewModel.adapter;
        //控制加载控件
        viewModel.loadMoreStatic.observe(
            this
        ) {
            if (it == 1) {
                binding.refresh.finishLoadMore();
                binding.rvBillList.visibility = View.VISIBLE
                binding.llNoData.visibility = View.GONE
            } else if (it == 2) {
                binding.rvBillList.visibility = View.VISIBLE
                binding.llNoData.visibility = View.GONE
                binding.refresh.finishLoadMoreWithNoMoreData()
            } else if (it == 3) {
                binding.rvBillList.visibility = View.GONE
                binding.llNoData.visibility = View.VISIBLE
            }
            /*结束上加载*/
            binding.refresh.finishRefresh()
        }
        viewModel.getBillList()

        /*账单时间筛选*/
        binding.llAblData.setOnClickListener {
            var dataDialog: DataPickerDialog = DataPickerDialog(this)
            dataDialog.setDialogClickListener { code, data ->
                viewModel.time = data.toString()
                /* 2024-1格式*/
                viewModel.selectTime.value = viewModel.time.toString()
                viewModel.page = 1
                viewModel.getBillList()
            }
            dataDialog.show()
        }
        /*账单状态筛选*/
        binding.llAblStatic.setOnClickListener {
            var dataDialog: SinglePickerDialog = SinglePickerDialog(this, viewModel.staticList)
            dataDialog.setDialogClickListener { code, data ->
                data as OrderStatusData
                if (data.res == 4) {
                    viewModel.status = null
                    /*重置状态回显*/
                    viewModel.selectStatus.value = "全部"
                } else {
                    viewModel.status = data.res.toString()
                    val statusData = data.toString()
                    val statusStr = statusData.substringAfter("statusStr=")
                        .substringBefore(")")
                    viewModel.selectStatus.value = statusStr
                }

                viewModel.page = 1;
                binding.refresh.resetNoMoreData()
                viewModel.getBillList()
            }
            dataDialog.show()
        }
        /*账单电表类别筛选*/
        binding.llAblElectric.setOnClickListener {
            var dataDialog: SinglePickerDialog = SinglePickerDialog(this, StaticData.ElectricList)
            dataDialog.setDialogClickListener { code, data ->
                data as EletricListBean
                if (data.itemId < 0) {
                    viewModel.itemId = null
                    viewModel.itemName = null
                    /*重置状态回显*/
                    viewModel.selectElectric.value = "全部"
                } else {
                    viewModel.itemId = data.itemId
                    viewModel.itemName = data.itemName
                    /*电表赋值*/
                    viewModel.selectElectric.value = viewModel.itemName.toString()
                }

                viewModel.page = 1;
                binding.refresh.resetNoMoreData()
                viewModel.getBillList()
            }
            dataDialog.show()
        }

    }

    override fun initViewModel(): BillListViewModel? {
        val lm = BillListRequst()
        return BillListViewModel(getApplication(), lm)
    }


    override fun onRefresh(refreshLayout: RefreshLayout) {
        viewModel.page = 1;
        viewModel.getBillList();
        binding.refresh.resetNoMoreData()
    }

    override fun onLoadMore(refreshLayout: RefreshLayout) {
        viewModel.page++
        viewModel.getBillList();
    }
}