package com.xx.merchanthbh.ui.bill

import android.content.Context
import android.graphics.Color
import android.view.View
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.respons.BillListBean
import com.xx.merchanthbh.data.http.respons.EletricListBean
import com.xx.merchanthbh.data.staticdata.StaticData
import com.xx.merchanthbh.databinding.ItemBillListBinding
import com.xx.merchanthbh.databinding.ItemElectricListBinding
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter

class BillListAdapter (context: Context,var viewModel: BillListViewModel): xxBaseRecyclerViewAdapter<ItemBillListBinding, BillListBean>(context) {

    init {
        itemClick=xxBaseRecyclerViewAdapter.OnItemClick { position, data ->
            viewModel.goDetail(data.orderId)
        }
    }

    override fun initLayout(): Int {
        return R.layout.item_bill_list
    }

    override fun covert(dataBind: ItemBillListBinding?, data: BillListBean?, position: Int) {

        dataBind?.data=data

        when(data?.status)
        {
            //订单状态 0-待支付，1-已关闭，2-已完成，3-充值中
            "0"->
            {
                dataBind?.btnIbl?.visibility= View.VISIBLE
                dataBind?.tvIblStatic?.setTextColor(mContext.getColor(R.color.foreground))
            }
            "1"->
            {
                dataBind?.btnIbl?.visibility= View.GONE
                dataBind?.tvIblStatic?.setTextColor(mContext.getColor(R.color.static_gray))
            }
            "2"->
            {
                dataBind?.btnIbl?.visibility= View.GONE
                dataBind?.tvIblStatic?.setTextColor(mContext.getColor(R.color.foreground))
            }
            "3"->
            {
                dataBind?.btnIbl?.visibility= View.VISIBLE
                dataBind?.tvIblStatic?.setTextColor(mContext.getColor(R.color.static_deal))
            }

        }

        dataBind?.tvIblStatic?.setText(StaticData.ElectricOrderStatus.get(data?.status)?.statusStr)
        dataBind?.btnIbl?.setOnClickListener {
            viewModel.refreshOrder(position,data?.orderId)
        }

    }



}