package com.xx.merchanthbh.ui.bill;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.BillListRequst;
import com.xx.merchanthbh.data.http.respons.BillListBean;
import com.xx.merchanthbh.data.http.respons.ElectricMsgBean;
import com.xx.merchanthbh.data.http.respons.EletricListBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.dialog.data.TextListProvider;
import com.xx.merchanthbh.ui.billdetail.BillDetailActivity;
import com.xx.merchanthbh.ui.billdetail.OrderStatusData;
import com.xx.merchanthbh.ui.electric.ElectricPayViewModel;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.base.ListBaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class BillListViewModel extends ListBaseViewModel<BillListRequst> {

    public BillListAdapter adapter;

    public String time=null;

    public Integer itemId=null;
    /*电表名称*/
    public String itemName=null;
    //状态筛选(做前端回显使用)
    public MutableLiveData<String> selectStatus = new MutableLiveData<>(StaticData.selectStatus);
    //电表筛选(做前端回显使用)
    public MutableLiveData<String> selectElectric = new MutableLiveData<>(StaticData.selectElectric);
    //时间筛选(做前端回显使用)
    public MutableLiveData<String> selectTime = new MutableLiveData<>(StaticData.selectTime);
    /*状态筛选赋值用*/
    public String status=null;

    public ArrayList<OrderStatusData> staticList=new ArrayList();

    public BillListViewModel(@NonNull Application application) {
        super(application);
    }

    public BillListViewModel(@NonNull Application application, BillListRequst model) {
        super(application, model);
        staticList.add(new OrderStatusData(4,"全部"));
        staticList.add(new OrderStatusData(0,"待付款"));
        staticList.add(new OrderStatusData(3,"充电中"));
        staticList.add(new OrderStatusData(2,"已完成"));
        staticList.add(new OrderStatusData(1,"已关闭"));
    }

    /**
     * 获取订单列表
     */
    public void getBillList()
    {
        model.getBillList(time,itemId,status,page).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(BillListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<BillListBean>() {
                    @Override
                    public void onSuccess(List<BillListBean> resultBean) {
                        if (page == 1) {
                            adapter.mList = resultBean;
                        } else {
                            adapter.mList.addAll(resultBean);
                        }
                        adapter.notifyDataSetChanged();

                    }

                    @Override
                    public void onError(String Error) {

                    }

                    @Override
                    public void getTotal(int total) {
                        if (total==0)
                        {
                            loadMoreStatic.postValue(3);
                        }else if (adapter.mList.size()>=total)
                        {
                            loadMoreStatic.postValue(2);
                        }else {
                            loadMoreStatic.postValue(1);
                        }
                    }
                });
    }


    /**
     * 跳转详情页
     * @param orderid
     */
    public void goDetail(String orderid)
    {
        Bundle bundle=new Bundle();
        bundle.putString("OrderID",orderid);
        startActivity(BillDetailActivity.class,bundle);
    }


    public void refreshOrder(int position,String id)
    {
        model.refreshOrderByID(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(BillListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog("正在刷新");
                    }
                }).subscribe(new ApiDisposableObserver<BillListBean>() {
                    @Override
                    public void onSuccess(BillListBean resultBean) {
                        adapter.mList.set(position,resultBean);
                        adapter.notifyDataSetChanged();
                        dismissDialog();

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }


}
