package com.xx.merchanthbh.ui.billdetail;

import android.app.Application;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.BillDetailRequst;
import com.xx.merchanthbh.data.http.respons.BillDetailBean;
import com.xx.merchanthbh.data.http.respons.PayMsgBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.ui.electric.ElectricPayViewModel;

import java.util.HashMap;
import java.util.Map;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class BillDetailViewModel extends BaseViewModel<BillDetailRequst> {

    public ObservableField<BillDetailBean> detail=new ObservableField<>();


    public ObservableField<Integer> statusImg=new ObservableField<>(R.mipmap.dingdan_icon_daifukuan);

    public ObservableField<String> statusStr=new ObservableField<>("待付款");

    public ObservableField<Integer> detailVisibility=new ObservableField<>(View.GONE);

    public BillDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public BillDetailViewModel(@NonNull Application application, BillDetailRequst model) {
        super(application, model);
    }


    public void getBillDetail(String id)
    {
        model.getBillDetail(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(BillDetailViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<BillDetailBean>() {

                    @Override
                    public void onSuccess(BillDetailBean resultBean) {

                        detail.set(resultBean);

                        statusStr.set(StaticData.ElectricOrderStatus.get(resultBean.getStatus()).getStatusStr());
                        statusImg.set(StaticData.ElectricOrderStatus.get(resultBean.getStatus()).getRes());

                        if (resultBean.getStatus().equals("3") || resultBean.getStatus().equals("2"))
                        {
                            detailVisibility.set(View.VISIBLE);
                        }else {
                            detailVisibility.set(View.GONE);
                        }
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

}
