package com.xx.merchanthbh.ui.consult;

import static com.xx.merchanthbh.utils.RetrofitClient.baseH5Url;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.os.Bundle;
import android.view.View;

import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.ConsultRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.databinding.ActivityConsultationListBinding;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationsInformationAdapter;
import com.xx.merchanthbh.ui.web.CommWabActivity;
import com.xx.merchanthbh.ui.web.PDFWebViewActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class ConsultationActivity extends BaseActivity<ActivityConsultationListBinding,ConsultationViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_consultation_list;
    }

    @Override
    public int initVariableId() {
        return BR.consultationViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //调用轮播图广告位接口
        viewModel.getADList();

        viewModel.consultationInformationTitleAdapter = new ConsultationInformationTitleAdapter(this);
        //把adapterset进去
        binding.rvZxtitleList.setAdapter(viewModel.consultationInformationTitleAdapter);
        viewModel.consultationInformationTitleAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ConsultationTitleBean>() {
            @Override
            public void itemClickCalBack(int position, ConsultationTitleBean data) {
                viewModel.consultationInformationTitleAdapter.select=data.getClassificationId();
                viewModel.consultationInformationTitleAdapter.notifyDataSetChanged();
                viewModel.consultationsInformationAdapter.mList=data.getChildren();
                viewModel.consultationsInformationAdapter.notifyDataSetChanged();
                if (viewModel.consultationsInformationAdapter.mList.size() > 0) {
                    // 显示RecyclerView，隐藏暂无数据列表
                    binding.rvZxmsgList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                } else {
                    // 隐藏RecyclerView，显示暂无数据列表
                    binding.rvZxmsgList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                }
            }
        });

        viewModel. consultationsInformationAdapter = new ConsultationsInformationAdapter(this);
        //把adapterset进去
        binding.rvZxmsgList.setAdapter(viewModel.consultationsInformationAdapter);
        viewModel.consultationsInformationAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ConsultationInformationBean>() {
            @Override
            public void itemClickCalBack(int position, ConsultationInformationBean data) {


                if (data.isView().equals("1"))
                {
                    Bundle bundle=new Bundle();
                    bundle.putString("url", data.getFileUrl());
                    bundle.putString("name", data.getInformationTitle());
                    startActivity(PDFWebViewActivity.class, bundle);

                    viewModel.addLook(data.getBusinessId());
                    binding.rvZxtitleList.postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            data.setClickNumber((Integer.valueOf(data.getClickNumber())+1)+"");
                            viewModel.consultationsInformationAdapter.notifyItemChanged(position);
                        }
                    },1000);


                }else {
                    Bundle bundle=new Bundle();
                    bundle.putString("title","资讯详情");
                    bundle.putString("URL",baseH5Url+data.getInformationUrl()+"&yplrm="+Interceptor_TOKEN);
                    startActivity(CommWabActivity.class,bundle);
                }

            }
        });
        viewModel.getConsultationsList();
    }
    @Override
    public ConsultationViewModel initViewModel() {
        ConsultRequest lm = new ConsultRequest();
        return new ConsultationViewModel(getApplication(), lm);
    }

    @Override
    protected void onResume() {
        super.onResume();

    }
}
