package com.xx.merchanthbh.ui.consult;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.ConsultRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationsInformationAdapter;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiViewModel;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ConsultationViewModel extends BaseViewModel<ConsultRequest> {
    /*资讯信息列表*/
    //获取适配器上下文
    ConsultationsInformationAdapter consultationsInformationAdapter;

    /*资讯列表页-资讯信息标题*/
    //获取适配器上下文
    ConsultationInformationTitleAdapter consultationInformationTitleAdapter;

    //    创建轮播图广告位实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());


    public ConsultationViewModel(@NonNull Application application) {
        super(application);
    }

    public ConsultationViewModel(@NonNull Application application, ConsultRequest model) {
        super(application, model);
    }
    //调用轮播图列表的接口信息
    public void getADList() {
        model.getAdList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ConsultationViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        AdvertisingList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    //调用资讯列表的接口信息
    public void getConsultationsList() {
        model.getConsultationInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ConsultationViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ConsultationTitleBean>>() {
                    @Override
                    public void onSuccess(List<ConsultationTitleBean> resultBean) {

                        if (resultBean.size()>0)
                        {

                            consultationInformationTitleAdapter.mList=resultBean;
                            consultationInformationTitleAdapter.select=resultBean.get(0).getClassificationId();
                            consultationInformationTitleAdapter.notifyDataSetChanged();
                            consultationsInformationAdapter.mList=resultBean.get(0).getChildren();
                            consultationsInformationAdapter.notifyDataSetChanged();
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    /**
     * 增加PDF咨询浏览量
     * @param id
     */
    public void addLook(String id)
    {
        model.addLook(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ConsultationViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {

                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

}
