package com.xx.merchanthbh.ui.home;

import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.view.KeyEvent;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityHomeBinding;
import com.xx.merchanthbh.ui.home.HomeFragment;
import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.ui.home.HomeViewModel;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiFragment;
import com.xx.merchanthbh.ui.login.LoginActivity;
import com.xx.merchanthbh.ui.mine.MineFragment;
import com.google.android.material.bottomnavigation.BottomNavigationView;
import com.xx.xxviewlibrary.base.AppManager;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;

import me.goldze.mvvmhabit.base.BaseActivity;

public class HomeActivity extends BaseActivity<ActivityHomeBinding, HomeViewModel> {


    // 定义一个变量，来标识是否退出
    private static boolean isExit = false;

    Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            isExit = false;
        }
    };

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_home;

    }

    @Override
    public void onResume() {
        super.onResume();
        // 手动更新页面UI内容
        updateUI();
    }

    /*更新页面,注销标志位做判断*/
    private void updateUI() {
        if (StaticData.logOffData == 1) {
            finish();
            startActivity(LoginActivity.class);
        }else {
        }
    }

    @Override
    public void initData() {
        super.initData();
        // 初始化底部导航栏
        BottomNavigationView bottomNavigationView = findViewById(R.id.bottom_navigation_view);
        bottomNavigationView.setOnNavigationItemSelectedListener(navItemSelectedListener);

        // 显示默认的 Fragment
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, new HomeFragment()).commit();


    }
    @Override
    public int initVariableId() {
        return BR.hmViewModel;
    }
    @Override
    public void onStart() {
        super.onStart();
    }



    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        super.onPointerCaptureChanged(hasCapture);
    }


    private final BottomNavigationView.OnNavigationItemSelectedListener navItemSelectedListener = item -> {
        Fragment selectedFragment = null;

        // 根据选项 ID 创建相应的 Fragment
        if (item.getItemId() == R.id.menu_home) {
            selectedFragment = new HomeFragment();
        } else if (item.getItemId() == R.id.menu_huanbohai) {
            selectedFragment = new HuanBoHaiFragment();
        }else if (item.getItemId() == R.id.menu_mine) {
            selectedFragment = new MineFragment();
        }


        // 替换当前显示的 Fragment
        // 确保选择项不能为空
        assert selectedFragment != null;
        getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, selectedFragment).commit();
        return true;
    };


    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            exit();
            return false;
        }
        return super.onKeyDown(keyCode, event);
    }


    private void exit() {
        showCommTextDialog(new RefuseDialogBean("是否确认退出APP？", "确定", "取消"), new CommTextDialog.onAcceptCallBack() {
            @Override
            public void acceptBack() {
                Intent intent = new Intent(Intent.ACTION_MAIN);
                intent.addCategory(Intent.CATEGORY_HOME);
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
            }

            @Override
            public void refuseBack() {

            }
        });

    }

    @Override
    protected void onStop() {
        super.onStop();

    }
}