package com.xx.merchanthbh.ui.home;

import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.Settings;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.ConsultRequest;
import com.xx.merchanthbh.data.http.requst.HomeRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.FragmentHomeBinding;
import com.xx.merchanthbh.dialog.SignDialog;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationsInformationAdapter;
import com.xx.merchanthbh.ui.consult.ConsultationActivity;
import com.xx.merchanthbh.ui.consult.ConsultationViewModel;
import com.xx.merchanthbh.ui.consult.HomeBannerAdapter;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class HomeFragment extends BaseFragment<FragmentHomeBinding, HomeViewModel> {


    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_home;
    }

    @Override
    public int initVariableId() {
        return BR.homeViewModel;
    }

    @Override
    public void onResume() {
        super.onResume();

        // 检查版本
        viewModel.rxPermissions = new RxPermissions(this);
//        检查版本
        viewModel.checkVersion(binding.getRoot().getRootView());

// 安装新版本
        viewModel.openInstall.observe(this, new Observer<String>() {
            @Override
            public void onChanged(String s) {
                if ("1".equals(s)) {
                    Uri packageURI = Uri.parse("package:" + getContext().getPackageName());
                    Intent intent = new Intent(Settings.ACTION_MANAGE_UNKNOWN_APP_SOURCES, packageURI);
                    startActivityForResult(intent, 1002);
                }
            }
        });

      /*  if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            if (!Environment.isExternalStorageManager()) {
                Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                intent.setData(Uri.parse("package:" + getContext().getPackageName()));
                startActivityForResult(intent, 1024);
            }
        }*/
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*调首页统计数据接口*/
        viewModel.getHomeStatistical();
        /*调用首页的查看有没有未读消息的接口*/
        viewModel.getMessageList();
        if (StaticData.messageData == 0) {
            /*已读隐藏*/
            binding.ivBarMsgYidu.setVisibility(View.GONE);
            /*未读显示*/
            binding.ivBarMsgWeidu.setVisibility(View.VISIBLE);
        } else {
            /*已读显示*/
            binding.ivBarMsgYidu.setVisibility(View.VISIBLE);
            /*未读隐藏*/
            binding.ivBarMsgWeidu.setVisibility(View.GONE);
        }
        viewModel.showSignDialog.observe(this, show -> {
            SignDialog dialog = new SignDialog(getContext());
            dialog.show();

        });


    }

    @Override
    public HomeViewModel initViewModel() {
        HomeRequest lm = new HomeRequest();
        return new HomeViewModel(getActivity().getApplication(), lm);
    }


}
