package com.xx.merchanthbh.ui.home;

import android.Manifest;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.core.content.FileProvider;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.utils.permission.PermissionUtil;
import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.HomeRequest;
import com.xx.merchanthbh.data.http.respons.HomeStatisticalBean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.http.respons.MessageBean;
import com.xx.merchanthbh.data.http.respons.UserInfoBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.ui.addproduct.AddProductActivity;
import com.xx.merchanthbh.ui.appeal.AppealActivity;
import com.xx.merchanthbh.ui.appeallist.AppealListActivity;
import com.xx.merchanthbh.ui.assistant.AssistantManagementActivity;
import com.xx.merchanthbh.ui.electric.ElectricPayActivity;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiViewModel;
import com.xx.merchanthbh.ui.login.LoginViewModel;
import com.xx.merchanthbh.ui.merchantenter.MerchantEnterActivity;
import com.xx.merchanthbh.ui.merchantinfo.MaterialInfoActivity;
import com.xx.merchanthbh.ui.msg.MessageActivity;
import com.xx.merchanthbh.ui.msg.MessageViewModel;
import com.xx.merchanthbh.ui.order.OrderActivity;
import com.xx.merchanthbh.ui.ordercreate.OrderCreateActivity;
import com.xx.merchanthbh.ui.point.StorePointsActivity;
import com.xx.merchanthbh.ui.productmanager.ProductManagerActivity;
import com.xx.merchanthbh.ui.recruitment.RecruitmentActivity;
import com.xx.merchanthbh.ui.share.ShareActivity;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.model.VersionBean;
import com.xx.xxviewlibrary.utils.CommUtilsKt;

import java.io.File;
import java.math.BigDecimal;
import java.text.NumberFormat;
import java.util.List;

import io.reactivex.rxjava3.core.Observer;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import io.reactivex.rxjava3.schedulers.Schedulers;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;
import okhttp3.ResponseBody;

public class HomeViewModel extends BaseViewModel<HomeRequest> {

    /*权限*/
    RxPermissions rxPermissions;

    public ObservableField<String> title = new ObservableField<>(LocalData.getMerchant().getStoreName());
    //今日成交的绑定
    public ObservableField<String> totalMoney = new ObservableField<>("");
    //今日订单的绑定
    public ObservableField<String> orderCount = new ObservableField<>("");
    //今日下单用户的绑定
    public ObservableField<String> memberCount = new ObservableField<>("");
    //电费余额的绑定
    public ObservableField<String> electricityBalance = new ObservableField<>("");
    //展示签到弹窗
    public MutableLiveData<Boolean> showSignDialog = new MutableLiveData<>();

    public MerchantBean mb = LocalData.getMerchant();
    /*安装新版本*/
    public MutableLiveData<String> openInstall = new MutableLiveData<>("");
    public HomeViewModel(@NonNull Application application) {
        super(application);
    }

    /*设置消息初始状态是0*/
    public String flag = "0";
    public Integer page = 1;

    //调用消息列表的接口信息
    public void getMessageList() {
        model.getMessageList(flag, page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MessageBean>() {
                    @Override
                    public void onSuccess(List<MessageBean> resultBean) {
                        Log.v("有没有未读消息啊啊啊啊", String.valueOf(StaticData.messageData));
                    }

                    @Override
                    public void onError(String Error) {

                    }

                    @Override
                    public void getTotal(int total) {
                        if (total != 0) {
                            /*有未读消息,标志位就是0*/
                            StaticData.messageData = 0;
                        } else {
                            /*无未读消息,标志位是1*/
                            StaticData.messageData = 1;
                        }
                    }
                });
    }
    /**
     * 获取最新APK版本号
     *
     * @param view
     */
    public void checkVersion(View view) {


        model.checkVersion().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<VersionBean>() {

                    @Override
                    public void onSuccess(VersionBean resultBean) {
                        if (CommUtilsKt.checkVersionUpdata(CommUtilsKt.getVersion(view.getContext()), resultBean.getAppVersion())) {


                            //不强制
                            if (resultBean.getPushFlag().equals("0")) {
                                showCommTextDialog(new RefuseDialogBean("是否前往更新", "确定", "取消", "更新提示"), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {

                                    }

                                    @Override
                                    public void acceptBack() {

                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .subscribe(granted -> {
                                                    if (granted) { // Always true pre-M
                                                     /*   rxPermissions
                                                                .request(Manifest.permission.REQUEST_INSTALL_PACKAGES)
                                                                .subscribe(granteds -> {
                                                                    if (granteds) { // Always true pre-M

                                                                    } else {
                                                                        ToastUtils.showShort("请允许安装外部来源应用");
                                                                        openInstall.postValue("1");
                                                                    }
                                                                });*/
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));

                                                    } else {
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                });

                                    }
                                });
                            } else {
                                showCommTextDialog(new RefuseDialogBean("请前往更新", "确定", null), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {
                                        finish();
                                    }

                                    @Override
                                    public void acceptBack() {

                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .subscribe(granted -> {
                                                    if (granted) { // Always true pre-M
                                                       /* rxPermissions
                                                                .request(Manifest.permission.REQUEST_INSTALL_PACKAGES)
                                                                .subscribe(granteds -> {
                                                                    if (granteds) { // Always true pre-M

                                                                    } else {
                                                                        ToastUtils.showShort("请允许安装外部来源应用");
                                                                        openInstall.postValue("1");
                                                                    }
                                                                });*/
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));
                                                    } else {
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                }, err -> {
                                                    err.printStackTrace();
                                                });

                                    }
                                });
                            }

                        } else {

                        }


                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }


    /**
     * 下载APK
     *
     * @param context
     * @param url     　下载地址
     * @param name    　文件名字
     */
    public void updataApk(Context context, String url, String name) {
        /*执行传参方法*/
        showDialog("正在下载...");
        model.downFile(url, name).subscribe(new Observer<ResponseBody>() {
            @Override
            public void onSubscribe(@io.reactivex.rxjava3.annotations.NonNull Disposable d) {
                Log.e("下载", "onSubscribe");
            }

            @Override
            public void onNext(@io.reactivex.rxjava3.annotations.NonNull ResponseBody responseBody) {

            }

            @Override
            public void onError(@io.reactivex.rxjava3.annotations.NonNull Throwable e) {
                ToastUtils.showShort("下载失败");
                dismissDialog();
            }

            @Override
            public void onComplete() {
                Log.e("下载", "onComplete");
                dismissDialog();
                ToastUtils.showShort("下载成功");
                installApk(context, name);
            }
        });
    }


    //跳转安装ＡＰＰ
    private void installApk(Context context, String path) {
        Intent intent = new Intent(Intent.ACTION_VIEW);
        File file = new File(Uri.parse(path).getPath());
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            intent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
            Uri uri = FileProvider.getUriForFile(context, "com.xx.merchanthbh.fileProvider", file);
            intent.setDataAndType(uri, "application/vnd.android.package-archive");
        } else {
            intent.setDataAndType(Uri.fromFile(file), "application/vnd.android.package-archive");
        }
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK); // Adding the flag here
        context.startActivity(intent);
    }


    public HomeViewModel(@NonNull Application application, HomeRequest model) {
        super(application, model);
    }

    //跳转添加商品
    public BindingCommand goAddProduct = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AddProductActivity.class);
        }

    });

    //跳转添加订单
    public BindingCommand goCreateOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderCreateActivity.class);
        }

    });


    //跳转添加商品
    public BindingCommand goProductManager = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ProductManagerActivity.class);
        }

    });
    //跳转店员管理
    public BindingCommand goAssistantManage = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AssistantManagementActivity.class);
        }

    });
    //跳转消息中心界面
    public BindingCommand goMessage = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MessageActivity.class);
        }

    });
    //跳转诉求反馈
    public BindingCommand goAppeal = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(AppealListActivity.class);
        }

    });

    //跳转com.xx
    public BindingCommand goPoints = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(StorePointsActivity.class);
        }

    });
    //跳转订单管理
    public BindingCommand goOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderActivity.class);
        }

    });
    //跳转人才招聘
    public BindingCommand goTalent = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(RecruitmentActivity.class);
        }

    });

    //跳转缴纳电费
    public BindingCommand goElectric = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ElectricPayActivity.class);
        }

    });

    //跳转店铺信息
    public BindingCommand goMerchantInfo = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MaterialInfoActivity.class);
        }

    });


    //跳转店铺信息
    public BindingCommand goShareTotal = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            startActivity(ShareActivity.class);
        }

    });

    /*获取首页统计数据*/
    public void getHomeStatistical() {
        model.getHomeStatistical()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<HomeStatisticalBean>() {
                    @Override
                    public void onSuccess(HomeStatisticalBean resultBean) {
                        /*今日成交赋值*/
                        totalMoney.set(String.valueOf(resultBean.getTotalMoney()));
                        /*今日订单赋值*/
                        orderCount.set(String.valueOf(resultBean.getOrderCount()));
                        /*今日下单用户赋值*/
                        memberCount.set(String.valueOf(resultBean.getMemberCount()));
                        /*电费余额赋值*/
                        electricityBalance.set(getPriceForm(resultBean.getElectricityBalance()));
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });

    }


    /**
     * 签到
     */
    public void getSign(View view) {
        model.getSign(mb.getBusinessId()).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HomeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {

                    @Override
                    public void onSuccess(Boolean resultBean) {

                        dismissDialog();
                        showSignDialog.postValue(true);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                        showSignDialog.postValue(true);
                    }
                });
    }

    public String getPriceForm(double num) {
        BigDecimal bg = new BigDecimal(num);

        NumberFormat nb = NumberFormat.getInstance();
        nb.setGroupingUsed(true);
        return nb.format(bg.setScale(2, BigDecimal.ROUND_HALF_UP));


    }

}
