package com.xx.merchanthbh.ui.huanbohai;

import static com.xx.merchanthbh.utils.RetrofitClient.baseH5Url;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.Settings;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.HuanBoHaiRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.databinding.FragmentHuanbohaiBinding;
import com.xx.merchanthbh.fragment.adapter.ActivityCenterListAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.ui.web.CommWabActivity;
import com.xx.merchanthbh.ui.web.PDFWebViewActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

/*环渤海页面*/
public class HuanBoHaiFragment extends BaseFragment<FragmentHuanbohaiBinding, HuanBoHaiViewModel> {
/*    @Override
    public void onResume() {
        super.onResume();

        // 检查版本
        viewModel.rxPermissions = new RxPermissions(this);
        *//*检查版本*//*
        viewModel.checkVersion(binding.getRoot().getRootView());

// 安装新版本
        viewModel.openInstall.observe(this, new Observer<String>() {
            @Override
            public void onChanged(String s) {
                if ("1".equals(s)) {
                    Uri packageURI = Uri.parse("package:" +getContext().getPackageName());
                    Intent intent = new Intent(Settings.ACTION_MANAGE_UNKNOWN_APP_SOURCES, packageURI);
                    startActivityForResult(intent, 1002);
                }
            }
        });

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) {
            if (!Environment.isExternalStorageManager()) {
                Intent intent = new Intent(Settings.ACTION_MANAGE_APP_ALL_FILES_ACCESS_PERMISSION);
                intent.setData(Uri.parse("package:" + getContext().getPackageName()));
                startActivityForResult(intent, 1024);
            }
        }
    }*/
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //展示活动列表
        ActivityCenterListAdapter adapter = new ActivityCenterListAdapter(requireContext());
        adapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ActivityCenterBean>() {
            @Override
            public void itemClickCalBack(int position, ActivityCenterBean data) {

              Bundle bundle=new Bundle();
                bundle.putString("title","活动详情");
                bundle.putString("URL",baseH5Url+data.getActivityUrl());
                bundle.putString("activityName",data.getActivityName());
                startActivity(CommWabActivity.class,bundle);
            }
        });
        binding.rvDblList.setAdapter(adapter);

        viewModel.ActivityCenterList.observe(this, new Observer<List<ActivityCenterBean>>() {
            @Override
            public void onChanged(List<ActivityCenterBean> activityCenterBeans) {
                adapter.mList=activityCenterBeans;
                adapter.notifyDataSetChanged();
            }
        });

        /*环渤海-资讯信息标题*/
        //获取适配器上下文
        viewModel.consultationInformationTitleAdapter = new ConsultationInformationTitleAdapter(requireContext());

        viewModel.consultationInformationTitleAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ConsultationTitleBean>() {
            @Override
            public void itemClickCalBack(int position, ConsultationTitleBean data) {
               viewModel.consultationInformationTitleAdapter.select=data.getClassificationId();
                viewModel.consultationInformationTitleAdapter.notifyDataSetChanged();
                viewModel.consultationInformationAdapter.mList=data.getChildren();
                viewModel.consultationInformationAdapter.notifyDataSetChanged();
                if (viewModel.consultationInformationAdapter.mList.size() > 0) {
                    // 显示RecyclerView，隐藏暂无数据列表
                    binding.rvZxmsgList.setVisibility(View.VISIBLE);
                    binding.llNoDatah.setVisibility(View.GONE);
                } else {
                    // 隐藏RecyclerView，显示暂无数据列表
                    binding.rvZxmsgList.setVisibility(View.GONE);
                    binding.llNoDatah.setVisibility(View.VISIBLE);
                }
            }
        });

        //把adapterset进去
        binding.rvZxtitleList.setAdapter( viewModel.consultationInformationTitleAdapter);
        /*资讯列表暂无数据状态位*/
        viewModel.loadMoreStatich.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 0) {
                    /*隐藏recycleView,显示暂无数据列表*/
                    binding.rvZxmsgList.setVisibility(View.GONE);
                    binding.llNoDatah.setVisibility(View.VISIBLE);
                }else {
                    /*显示recycleView,隐藏暂无数据列表*/
                    binding.rvZxmsgList.setVisibility(View.VISIBLE);
                    binding.llNoDatah.setVisibility(View.GONE);
                }
            }
        });
        /*广告列表暂无数据状态位*/
        viewModel.loadMoreStatics.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 0) {
                    /*隐藏recycleView,显示暂无数据列表*/
                    binding.rvDblList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                }else {
                    /*显示recycleView,隐藏暂无数据列表*/
                    binding.rvDblList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                }
            }
        });
        /*环渤海-资讯信息列表*/
        //获取适配器上下文
        viewModel.consultationInformationAdapter = new ConsultationInformationAdapter(requireContext());
        viewModel.consultationInformationAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ConsultationInformationBean>() {
            @Override
            public void itemClickCalBack(int position, ConsultationInformationBean data) {


                if (data.isView().equals("1"))
                {
                    Bundle bundle=new Bundle();
                    bundle.putString("url", data.getFileUrl());
                    bundle.putString("name", data.getInformationTitle());
                    startActivity(PDFWebViewActivity.class, bundle);
                    viewModel.addLook(data.getBusinessId());

                }else {
                    Bundle bundle=new Bundle();
                    bundle.putString("title","资讯详情");
                    bundle.putString("URL",baseH5Url+data.getInformationUrl()+"&yplrm="+Interceptor_TOKEN);
                    startActivity(CommWabActivity.class,bundle);
                }
            }
        });

        binding.rvZxmsgList.setAdapter(viewModel.consultationInformationAdapter);

        binding.bannerHbh.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(requireContext()));
        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {
                HbhBannerAdapter bannerAdapter=new HbhBannerAdapter(requireContext(),advertisingBeans);
                binding.bannerHbh.setAdapter(bannerAdapter);
            }
        });

    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        return R.layout.fragment_huanbohai;

    }

    @Override
    public int initVariableId() {
        return BR.huanbohaiViewModel;
    }


    @Override
    public HuanBoHaiViewModel initViewModel() {
//        List<Integer> list = new ArrayList<>();
        HuanBoHaiRequest lm = new HuanBoHaiRequest();
        return new HuanBoHaiViewModel(getActivity().getApplication(), lm);
    }
}