package com.xx.merchanthbh.ui.huanbohai;

import android.Manifest;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.core.content.FileProvider;
import androidx.lifecycle.MutableLiveData;

import io.reactivex.rxjava3.android.schedulers.AndroidSchedulers;
import io.reactivex.rxjava3.core.Observer;
import io.reactivex.rxjava3.schedulers.Schedulers;
import me.goldze.mvvmhabit.base.ListBaseViewModel;

import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.HuanBoHaiRequest;
import com.xx.merchanthbh.data.http.respons.ActivityCenterBean;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.ConsultationInformationBean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.data.http.respons.ConsultationTitleBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationAdapter;
import com.xx.merchanthbh.fragment.adapter.ConsultationInformationTitleAdapter;
import com.xx.merchanthbh.ui.activities.ActivitiesActivity;
import com.xx.merchanthbh.ui.consult.ConsultationActivity;
import com.xx.merchanthbh.ui.home.HomeViewModel;
import com.xx.merchanthbh.ui.mine.MineViewModel;
import com.xx.merchanthbh.ui.msg.MessageActivity;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.model.VersionBean;
import com.xx.xxviewlibrary.utils.CommUtilsKt;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;
import okhttp3.ResponseBody;

public class HuanBoHaiViewModel extends ListBaseViewModel<HuanBoHaiRequest> {

    /*权限*/
    RxPermissions rxPermissions;

    /*安装新版本*/
    public MutableLiveData<String> openInstall = new MutableLiveData<>("");
    //    创建活动中心实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());
    //    创建活动中心实体对象
    public MutableLiveData<List<ActivityCenterBean>> ActivityCenterList = new MutableLiveData<>(new ArrayList<>());
    /*广告列表暂无数据状态位*/
    public MutableLiveData<Integer> loadMoreStatics = new MutableLiveData<>(0);
    /*资讯列表暂无数据状态位*/
    public MutableLiveData<Integer> loadMoreStatich = new MutableLiveData<>(0);
    /*广告列表暂无数据状态位*/
    public MutableLiveData<Integer> loadMoreStatica = new MutableLiveData<>(0);
    //    创建资讯信息标题Adapter
    ConsultationInformationTitleAdapter consultationInformationTitleAdapter;
    //    创建资讯信息Adapter
    ConsultationInformationAdapter consultationInformationAdapter;
    public MerchantBean merchantInfo = LocalData.getMerchant();

    public HuanBoHaiViewModel(@NonNull Application application) {
        super(application);
    }

    public HuanBoHaiViewModel(@NonNull Application application, HuanBoHaiRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        getADList();
        getConsultationsList();
        getActivityCenterList();
    }

    /**
     * 获取最新APK版本号
     *
     * @param view
     */
    public void checkVersion(View view) {


        model.checkVersion().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<VersionBean>() {

                    @Override
                    public void onSuccess(VersionBean resultBean) {
                        if (CommUtilsKt.checkVersionUpdata(CommUtilsKt.getVersion(view.getContext()), resultBean.getAppVersion())) {


                            //不强制
                            if (resultBean.getPushFlag().equals("0")) {
                                showCommTextDialog(new RefuseDialogBean("是否前往更新", "确定", "取消", "更新提示"), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {

                                    }

                                    @Override
                                    public void acceptBack() {

                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .subscribe(granted -> {
                                                    if (granted) { // Always true pre-M
                                                     /*   rxPermissions
                                                                .request(Manifest.permission.REQUEST_INSTALL_PACKAGES)
                                                                .subscribe(granteds -> {
                                                                    if (granteds) { // Always true pre-M

                                                                    } else {
                                                                        ToastUtils.showShort("请允许安装外部来源应用");
                                                                        openInstall.postValue("1");
                                                                    }
                                                                });*/
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));

                                                    } else {
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                });

                                    }
                                });
                            } else {
                                showCommTextDialog(new RefuseDialogBean("请前往更新", "确定", null), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {
                                        finish();
                                    }

                                    @Override
                                    public void acceptBack() {

                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .subscribe(granted -> {
                                                    if (granted) { // Always true pre-M
                                                       /* rxPermissions
                                                                .request(Manifest.permission.REQUEST_INSTALL_PACKAGES)
                                                                .subscribe(granteds -> {
                                                                    if (granteds) { // Always true pre-M

                                                                    } else {
                                                                        ToastUtils.showShort("请允许安装外部来源应用");
                                                                        openInstall.postValue("1");
                                                                    }
                                                                });*/
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));
                                                    } else {
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                });

                                    }
                                });
                            }

                        } else {
                        }


                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }


    /**
     * 下载APK
     *
     * @param context
     * @param url     　下载地址
     * @param name    　文件名字
     */
    public void updataApk(Context context, String url, String name) {
        /*执行传参方法*/
        showDialog();
        model.downFile(url, name).subscribe(new Observer<ResponseBody>() {
            @Override
            public void onSubscribe(@io.reactivex.rxjava3.annotations.NonNull Disposable d) {
                Log.e("下载", "onSubscribe");
            }

            @Override
            public void onNext(@io.reactivex.rxjava3.annotations.NonNull ResponseBody responseBody) {

            }

            @Override
            public void onError(@io.reactivex.rxjava3.annotations.NonNull Throwable e) {
                ToastUtils.showShort("下载失败");
                dismissDialog();
            }

            @Override
            public void onComplete() {
                Log.e("下载", "onComplete");
                dismissDialog();
                ToastUtils.showShort("下载成功");
                installApk(context, name);
            }
        });
    }


    //跳转安装ＡＰＰ
    private void installApk(Context context, String path) {
        Intent intent = new Intent(Intent.ACTION_VIEW);
        File file = new File(Uri.parse(path).getPath());
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            intent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
            Uri uri = FileProvider.getUriForFile(context, "com.xx.merchanthbh.fileProvider", file);
            intent.setDataAndType(uri, "application/vnd.android.package-archive");
        } else {
            intent.setDataAndType(Uri.fromFile(file), "application/vnd.android.package-archive");
        }
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK); // Adding the flag here
        context.startActivity(intent);
    }


    //调用活动中心的接口信息
    public void getActivityCenterList() {
        model.getActivityList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<ActivityCenterBean>() {
                    @Override
                    public void onSuccess(List<ActivityCenterBean> resultBean) {
                        ActivityCenterList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        if (total == 0) {
                            loadMoreStatics.postValue(0);
                        }else {
                            loadMoreStatics.postValue(1);
                        }
                    }


                });
    }

    //调用资讯列表的接口信息
    public void getConsultationsList() {
        model.getConsultationInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ConsultationTitleBean>>() {
                    @Override
                    public void onSuccess(List<ConsultationTitleBean> resultBean) {

                        if (resultBean.size() > 0) {
                            consultationInformationTitleAdapter.mList = resultBean;
                            consultationInformationTitleAdapter.select = resultBean.get(0).getClassificationId();
                            consultationInformationTitleAdapter.notifyDataSetChanged();
                            consultationInformationAdapter.mList = resultBean.get(0).getChildren();
                            consultationInformationAdapter.notifyDataSetChanged();
                            loadMoreStatich.postValue(1);
                        } else {
                            loadMoreStatich.postValue(0);
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    /**
     * 获取banner
     */
    public void getADList() {
        model.getAdList(merchantInfo.getBooth().getAffiliatedCompany())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AdvertisingBean>>() {
                    @Override
                    public void onSuccess(List<AdvertisingBean> resultBean) {
                        if (resultBean != null && resultBean.size() > 0) {
                            // resultBean不为空且有数据
                            AdvertisingList.postValue(resultBean);
                            loadMoreStatica.postValue(1);
                        } else {
                            // resultBean为空或无数据
                            Log.v("没有banner图", "没有banner图");
                            loadMoreStatica.postValue(0);
                            /*放一张图进来*/
                            AdvertisingBean advertisingBean = new AdvertisingBean(null, null, "/profile/upload/2023/10/08/huanbohai_img_banner_20231008105550A008.png", null, null, "");
                            AdvertisingList.postValue(List.of(advertisingBean));
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    /**
     * 增加PDF咨询浏览量
     *
     * @param id
     */
    public void addLook(String id) {
        model.addLook(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HuanBoHaiViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {

                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }

    //跳转活动中心界面
    public BindingCommand goActivities = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ActivitiesActivity.class);
        }

    });
    //跳转消息中心界面
    public BindingCommand goMessage = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MessageActivity.class);
        }

    });


    //跳转资讯列表界面
    public BindingCommand goConsultation = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ConsultationActivity.class);
        }

    });

}