package com.xx.merchanthbh.ui.logoff;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.widget.RadioGroup;

import androidx.databinding.adapters.TextViewBindingAdapter;

import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.AssistantAddRequest;
import com.xx.merchanthbh.data.http.requst.LogOffRequest;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityLogOffBinding;
import com.xx.merchanthbh.ui.assistant.AssistantAddViewModel;
import com.xx.merchanthbh.ui.login.LoginActivity;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class LogOffActivity extends BaseActivity<ActivityLogOffBinding, LogOffViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_log_off;
    }

    @Override
    public int initVariableId() {
        return BR.logOffViewModel;
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        // 手动更新页面UI内容
        updateUI();

    }

    /*更新页面,注销标志位做判断*/
    private void updateUI() {
        if (StaticData.logOffData == 1) {
//            finish();
//            startActivity(LoginActivity.class);
        }else {
        }
    }


    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();

        binding.textView.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                // 在文本变化之前执行的操作
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (TextUtils.isEmpty(s) && viewModel.reasonValue.equals("其他")) {
                    // 当文本为空时执行的操作
                    viewModel.getNext.set(View.GONE);
                    viewModel.getNextNo.set(View.VISIBLE);
                } else if (TextUtils.isEmpty(s)) {
                    // 当文本为空时执行的操作，即最后一次删除后的情况
                    viewModel.getNext.set(View.GONE);
                    viewModel.getNextNo.set(View.VISIBLE);
                } else {
                    // 当文本不为空时执行的操作
                    viewModel.getNext.set(View.VISIBLE);
                    viewModel.getNextNo.set(View.GONE);
                }
            }

            @Override
            public void afterTextChanged(Editable editable) {
                if (TextUtils.isEmpty(editable) && viewModel.reasonValue.equals("其他")) {
                    // 当文本为空时执行的操作
                    viewModel.getNext.set(View.GONE);
                    viewModel.getNextNo.set(View.VISIBLE);
                } else if (TextUtils.isEmpty(editable)) {
                    // 当文本为空时执行的操作，即最后一次删除后的情况
                    viewModel.getNext.set(View.GONE);
                    viewModel.getNextNo.set(View.VISIBLE);
                } else {
                    // 当文本不为空时执行的操作
                    viewModel.getNext.set(View.VISIBLE);
                    viewModel.getNextNo.set(View.GONE);
                }
            }

        });
    }


    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
        /*单选按钮*/
        // 获取注销原因选择的RadioGroup
        RadioGroup reasonRadioGroup = findViewById(R.id.radio_group);
        // 初始化ViewModel中的注销原因选择监听器
        viewModel.initReasonListener(reasonRadioGroup);
        // 观察注销状态的变化
        viewModel.getLogOffStatus().observe(this, logOffStatus -> {
            if (logOffStatus != null && logOffStatus) {
                // 当注销状态变为true时执行退出应用的逻辑
                Intent intent = new Intent(Intent.ACTION_MAIN);
                intent.addCategory(Intent.CATEGORY_HOME);
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
            }
        });
    }


    @Override
    public LogOffViewModel initViewModel() {
        LogOffRequest lm = new LogOffRequest();
        return new LogOffViewModel(getApplication(), lm);
    }

}
