package com.xx.merchanthbh.ui.merchantenter;

import android.Manifest;
import android.app.Application;
import android.text.TextUtils;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.fragment.app.FragmentActivity;

import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.requst.MerchantEnterRequst;
import com.xx.merchanthbh.data.http.requst.body.Brankbody;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean;
import com.xx.merchanthbh.ui.appeal.AppealViewModel;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.utils.AddImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;
import com.huantansheng.easyphotos.EasyPhotos;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import com.xx.xxviewlibrary.base.AppManager;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import com.xx.xxviewlibrary.utils.GlideEngine;

import me.goldze.mvvmhabit.http.BaseResponse;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class AddBrankViewModel extends BaseViewModel<MerchantEnterRequst> {
    public Brankbody bean;
    public String position;
    /*上传图片*/
    public AddImgAdapter appealPicsAdapter;

    public AddBrankAdapter adapter;


    public RxPermissions rp;


    public ObservableField<Boolean> edit = new ObservableField<>(true);

    //编辑状态
    public ObservableField<Integer> editStatic=new ObservableField<>(View.GONE);

    //完成状态
    public ObservableField<Integer> completeStatic=new ObservableField<>(View.GONE);

    int create=0;
    public AddBrankViewModel(@NonNull Application application,int create) {
        super(application);
        model=new MerchantEnterRequst();

        this.create=create;
        rp=new RxPermissions((FragmentActivity) AppManager.getAppManager().currentActivity());
    }

    public void initAdapter(AddBrankAdapter mAdapter)
    {
        adapter=mAdapter;
    }

    public void InitData(Brankbody bean, int position)
    {
        this.bean=bean;
        this.position=(position+1)+"";
    }

    public String num()
    {return position;}



    /*上传图片*/
    public void openPhoto(AddImgAdapter type, int position) {


        int max = 1;
        if (TextUtils.isEmpty(appealPicsAdapter.mList.get(position).getId())) {
            max = 5 - appealPicsAdapter.getItemCount() + 1;
        }

        startPhotoPage(true, max,"申请的是摄像头和照片视频读取权限，用于在添加品牌时读取和写入相册和文件内容", new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                List<File> fList = new ArrayList<>();
                for (Photo p : photos) {
                    fList.add(new File(p.path));
                }

                model.upLoadFiles(fList).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(AddBrankViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {

                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {

                                if (TextUtils.isEmpty(type.mList.get(position).getId())) {

                                    List<FileBean> fList = new ArrayList<>();
                                    for (Filebean fb : resultBean) {
                                        fList.add(new FileBean(fb.getBusinessId(), fb.getUrl()));
                                    }
                                    type.addImg(fList);
                                } else {
                                    type.mList.get(position).setId(resultBean.get(0).getBusinessId());
                                    type.mList.get(position).setPath(resultBean.get(0).getUrl());
                                }

                                type.notifyDataSetChanged();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });

    }





    public void goEdit(View view)
    {

        if (create==0)
        {
            bean.setEdits(true);
            edit.set(true);
            editStatic.set(View.VISIBLE);
            completeStatic.set(View.GONE);
            if (appealPicsAdapter.mList.size()<5)
            {
                appealPicsAdapter.mList.add(new FileBean("",""));
            }
            appealPicsAdapter.changeEdit(true);
        }else {
            model.checkBrandAllow(bean.getId()).compose(RxUtils.schedulersTransformer()) //线程调度
                    .doOnSubscribe(AddBrankViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {

                        }
                    }).subscribe(new ApiDisposableObserver<Boolean>() {
                        @Override
                        public void onSuccess(Boolean resultBean) {

                            if (resultBean)
                            {
                                bean.setEdits(true);
                                edit.set(true);
                                editStatic.set(View.VISIBLE);
                                completeStatic.set(View.GONE);
                                if (appealPicsAdapter.mList.size()<5)
                                {
                                    appealPicsAdapter.mList.add(new FileBean("",""));
                                }
                                appealPicsAdapter.changeEdit(true);
                            }else {
                                ToastUtils.showShort("本品牌有待审核/已上架商品，不能修改");
                            }
                        }

                        @Override
                        public void onError(String Error) {

                        }
                    });
        }



    }


    public void completeEdit(View view)
    {

        if(StringUtils.isEmpty(bean.getOBrandName().get()))
        {
            ToastUtils.showShort("请填写品牌名称");

            return ;
        }

        List<String> list =new ArrayList();
        for (FileBean body : bean.getBrankImgs())
        {
            if(!StringUtils.isEmpty(body.getId()))
            {
                list.add(body.getId());
            }
        }

        if(list.size()<=0)
        {
            ToastUtils.showShort("请上传授权图片");

            return ;
        }

        if (create==0)
        {
            edit.set(false);
            bean.setEdits(false);
            editStatic.set(View.GONE);
            completeStatic.set(View.VISIBLE);
            if (StringUtils.isEmpty(appealPicsAdapter.mList.get(appealPicsAdapter.mList.size()-1).getId()))
            {
                appealPicsAdapter.mList.remove(appealPicsAdapter.mList.size()-1);
            }
            appealPicsAdapter.changeEdit(false);
        }else  if (StringUtils.isEmpty(bean.getId()))
        {
            model.addMerchantBrand(bean.getOBrandName().get(),list).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(AddBrankViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<IntegralTypeBean>() {

                    @Override
                    public void onSuccess(IntegralTypeBean resultBean) {
                        bean.setId(resultBean.getBusinessId());
                        edit.set(false);
                        bean.setEdits(false);
                        editStatic.set(View.GONE);
                        completeStatic.set(View.VISIBLE);
                        if (StringUtils.isEmpty(appealPicsAdapter.mList.get(appealPicsAdapter.mList.size()-1).getId()))
                        {
                            appealPicsAdapter.mList.remove(appealPicsAdapter.mList.size()-1);
                        }
                        appealPicsAdapter.changeEdit(false);
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
        }else {
            model.changeMerchantBrand(bean.getOBrandName().get(),list,bean.getId()).compose(RxUtils.schedulersTransformer()) //线程调度
                    .doOnSubscribe(AddBrankViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {

                        }
                    }).subscribe(new ApiDisposableObserver<Object>() {

                        @Override
                        public void onSuccess(Object resultBean) {
                            edit.set(false);
                            bean.setEdits(false);
                            editStatic.set(View.GONE);
                            completeStatic.set(View.VISIBLE);
                            if (StringUtils.isEmpty(appealPicsAdapter.mList.get(appealPicsAdapter.mList.size()-1).getId()))
                            {
                                appealPicsAdapter.mList.remove(appealPicsAdapter.mList.size()-1);
                            }
                            appealPicsAdapter.changeEdit(false);
                        }

                        @Override
                        public void onError(String Error) {

                        }
                    });
        }



    }


    public void checkAllow(String id)
    {

    }


    public void delete(View view)
    {
        if (StringUtils.isEmpty(bean.getId()))
        {
            if (adapter!=null)
            { adapter.mList.remove(Integer.valueOf(position)-1);
                adapter.notifyDataSetChanged();}

        }else {
            model.deleteMerchantBrand(bean.getId()) .compose(RxUtils.schedulersTransformer()) //线程调度
                    .doOnSubscribe(AddBrankViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {

                        }
                    }).subscribe(new ApiDisposableObserver<Object>() {

                        @Override
                        public void onSuccess(Object resultBean) {
                            if (adapter!=null)
                            { adapter.mList.remove(Integer.valueOf(position)-1);
                                adapter.notifyDataSetChanged();}
                        }

                        @Override
                        public void onError(String Error) {
                            ToastUtils.showShort( Error);
                        }
                    });
        }


    }

}
