package com.xx.merchanthbh.ui.merchantenter;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;

import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.MerchantEnterRequst;
import com.xx.merchanthbh.data.http.requst.body.Brankbody;
import com.xx.merchanthbh.data.http.requst.body.MerchantMsgbody;
import com.xx.merchanthbh.data.http.respons.BoothBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.http.respons.RegisterBean;
import com.xx.merchanthbh.data.http.respons.UserBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.dialog.adapter.BoothListAdapter;
import com.xx.merchanthbh.dialog.data.TextListProvider;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.witget.model.FileBean;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import io.reactivex.rxjava3.core.Observable;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import kotlin.text.Regex;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.BaseResponse;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MerchantEnterViewModel extends BaseViewModel<MerchantEnterRequst> {
    public ObservableField<String> title = new ObservableField<>("");

    public ObservableField<String> pwds = new ObservableField<>("");

    public ObservableField<String> boothSelect = new ObservableField<>("");

    public RegisterModel registerBody=new RegisterModel();

    public List<BoothBean> boothBeanList=new ArrayList<>();


    public BoothListAdapter boothAdapter;

    /**
     * 获取验证码按钮文字
     */
    public ObservableField<String> getCodeStr=new ObservableField<>("获取验证码");
    /**
     * 获取验证码按钮可点击状态
     */
    public ObservableField<Boolean> codeClick=new ObservableField<>(true);



    public String userStatic=null;
    /**
     * 通知添加品牌
     */
    public MutableLiveData<String> addbrank=new MutableLiveData<String>("");


    public UserBean user;
    public MerchantEnterRequst.MerchantInfo merchantInfo;



    /**
     * 商家入驻全部内容
     */
    public class RegisterModel
    {
        public ObservableField<String> oPhone = new ObservableField<String>("");

        public ObservableField<String> oCode = new ObservableField<String>("");

        public ObservableField<String> oPassword = new ObservableField<String>("");

    }




    public MerchantEnterViewModel(@NonNull Application application) {
        super(application);
        model= new MerchantEnterRequst();
        Log.e("fragment 生命周期","MerchantEnterViewModel");

        if(LocalData.getUser()!=null)
        {

            user=LocalData.getUser();
            merchantInfo=new MerchantEnterRequst.MerchantInfo(user.getPhonenumber());
        }
        MerchantBean merchantBean =LocalData.getMerchant();
        if (merchantBean!=null )
        {
           userStatic=merchantBean.getBusinessId();
            merchantInfo.setMerchantInfo(merchantBean);

        }


    }

    public MerchantEnterViewModel(@NonNull Application application, MerchantEnterRequst model) {
        super(application, model);
    }

    /**
     * 跳转注册
     * @param view
     */
    public void goRegister(View view)
    {

        NavController navController= Navigation.findNavController(view);
        navController.navigate(R.id.action_merchantIntroduceFragment_to_merchantRegisterFragment);
    }


    /**
     * 获取图片
     */
    public BindingCommand getPhoto = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startPhotoPage(true, "申请的是摄像头和照片视频读取权限，用于商家信息维护中读取和写入相册和文件内容",new SelectCallback() {
                @Override
                public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                    /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/

                    File file = new File(photos.get(0).path);
                    model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                            .doOnSubscribe(MerchantEnterViewModel.this)
                            .doOnSubscribe (new Consumer<Disposable>() {
                                @Override
                                public void accept(Disposable disposable) throws Exception {
                                    showDialog("请稍等");
                                }
                            }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                                @Override
                                public void onSuccess(List<Filebean> resultBean) {
                                    dismissDialog();
                                }

                                @Override
                                public void onError(String Error) {
                                    dismissDialog();
                                }


                            });
                }

                @Override
                public void onCancel() {

                }
            });
        }

    });

    /**
     * 核对手机号
     */
    public void checkRegisterPhone()
    {
        model.checkRegisterPhone(registerBody.oPhone.get())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {

                        if (resultBean)
                        {
                            ToastUtils.showShort("该手机号已被注册，请返回登录");

                        }else {
                            getCode();
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }


    /**
     * 获取验证码
     */
    public void getCode()
    {
        model.getCode(registerBody.oPhone.get())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        codeClick.set(false);
                        showDialog("正在获取验证码");
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {
//                            ToastUtils.showShort("已经发送成功");
                        codeCountDown();
                        ToastUtils.showShort(resultBean);
                        dismissDialog();
                    }

                    @Override
                    public void onError(String Error) {
                        codeClick.set(true);
                        dismissDialog();
                    }


                });
    }


    /**
     * 获取验证码
     */
    public BindingCommand getCode = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            if (TextUtils.isEmpty(registerBody.oPhone.get()))
            {
                ToastUtils.showShort("请输入手机号！");
                return;
            }

            checkRegisterPhone();

        }
    });

    /**
     * 获取验证码倒计时
     */
    public void codeCountDown()
    {
        final int[] second = {60};
        Timer timer=new Timer();
        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                second[0]--;
                if (second[0] >0)
                {
                    getCodeStr.set("重新获取（"+ second[0] +")");
                }else {
                    getCodeStr.set("获取验证码");
                    codeClick.set(true);
                    this.cancel();
                    timer.cancel();

                }
            }
        },1000,1000);
    }



    /**
     * 注册
     * @param view
     */
    public void register(View view)
    {

        String retxtpwd = "^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)[\\s\\S]{8,20}$";
        if (!registerBody.oPassword.get().matches(retxtpwd))
        {
            ToastUtils.showShort("密码长度8-20位，需要同时包含大小写字母和数字！");
            return ;
        }

        if (!pwds.get().equals(registerBody.oPassword.get()))
        {
            ToastUtils.showShort("两次密码输入不一致！");
            return;
        }

        model.register(registerBody)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog("正在加载");
                    }
                }).subscribe(new ApiDisposableObserver<RegisterBean>() {
                    @Override
                    public void onSuccess(RegisterBean resultBean) {
                        dismissDialog();
                        ToastUtils.showShort("成功");
                        LocalData.saveUser(new UserBean(resultBean.getUserId(),resultBean.getDeptId(),"","","",resultBean.getPhonenumber(),"","","",null));
                        Login(view);


                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    /**
     * 登陆
     * @param view
     */
    public void Login(View view)
    {
        model.Login(registerBody)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {
                        //是指token
                        dismissDialog();
                        Interceptor_TOKEN="Bearer "+resultBean;

                        merchantInfo=new MerchantEnterRequst.MerchantInfo(registerBody.oPhone.get());
                        NavController navController= Navigation.findNavController(view);
                        navController.navigate(R.id.action_merchantRegisterFragment_to_registerMaterialFragment);


                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    /**
     * 获取展位列表
     */
    public void getBoothList()
    {
        model.getBoothList()
            .compose(RxUtils.schedulersTransformer()) //线程调度
            .doOnSubscribe(MerchantEnterViewModel.this)
            .doOnSubscribe (new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposableObserver<List<BoothBean>>() {
                @Override
                public void onSuccess(List<BoothBean> resultBean) {
                    boothBeanList.clear();
                    boothBeanList.addAll(resultBean);
                }

                @Override
                public void onError(String Error) {
                    dismissDialog();
                }


            });}


    /**
     * 展示展位列表
     * @param view
     */
    public void openBooth(View view)
    {

        if (boothBeanList.size()<=0)
        {
            ToastUtils.showShort("正在加载展位数据请稍后点击");
        }else {
            NavController navController= Navigation.findNavController(view);
            navController.navigate(R.id.action_registerMaterialFragment_to_listSelectFragment);
        }




    }


    /**
     * 筛选展位号
     * @param view
     */
    public void searchBooth(View view)
    {
        List<BoothBean> newBoothBeanList=new ArrayList<>();
        if (!TextUtils.isEmpty(boothSelect.get()))
        {

             for (BoothBean bean:boothBeanList)
             {
                 if (bean.getBoothNumber().indexOf(boothSelect.get())>-1)
                 {
                     newBoothBeanList.add(bean);
                 }
             }


        }else {
            newBoothBeanList=boothBeanList;
        }
        boothAdapter.mList.clear();
        boothAdapter.mList.addAll(newBoothBeanList);
        boothAdapter.notifyDataSetChanged();
    }


    /**
     * 确定选择展位号
     * @param view
     */
    public void searchBoothSure(View view)
    {
        if (boothAdapter.getBuuthBusinessId()==null)
        {
            ToastUtils.showShort("请选择展位号");
        }else {
            NavController navController= Navigation.findNavController(view);
            navController.popBackStack();
            merchantInfo.getBoothNum().set(boothAdapter.getBuuthBusinessId().providerText());
            merchantInfo.setBoothId(boothAdapter.getBuuthBusinessId().ProviderId());
        }

    }

    /**
     * 添加品牌
     * @param view
     */
    public void addBrank(View view)
    {
        if (merchantInfo.getBranklist().size()<20) {
            addbrank.postValue("1");
        }

    }


    /**
     * 上传图片类信息
     * @param view
     */
    public void uploadPic(View view)
    {
        //选择图片
        startPhotoPage(true,"申请的是摄像头和照片视频读取权限，用于商家信息维护中读取和写入相册和文件内容", new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                model.upLoadFile(new File(photos.get(0).path)).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MerchantEnterViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog();
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                                FileBean bean= new FileBean(resultBean.get(0).getBusinessId(),resultBean.get(0).getUrl());


                                if (view.getId()==R.id.xup_frm_logo)
                                {
                                    merchantInfo.getCompanyLogo().set(bean);
                                }else if (view.getId()==R.id.xup_frm_licence)
                                {
                                    merchantInfo.getOperatingPermit().set(bean);
                                }else if (view.getId()==R.id.xup_frm_business_license)
                                {
                                    merchantInfo.getBusinessLicense().set(bean);
                                }

                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 提交商户信息
     * @param view
     */
    public void submitMerchantMsg(View view)
    {
        Observable<BaseResponse<Boolean>> observable;
        if (merchantInfo.getCompanyName().get().length()<2 || merchantInfo.getCompanyName().get().length()>30)
        {
            ToastUtils.showShort("请输入2-30位的公司全称");
            return;
        }

        if (merchantInfo.getStoreName().get().length()<2 || merchantInfo.getStoreName().get().length()>30)
        {
            ToastUtils.showShort("请输入2-30位的店铺名称");
            return;
        }
        if (merchantInfo.getResponsiblePerson().get().length()<2 || merchantInfo.getResponsiblePerson().get().length()>20)
        {
            ToastUtils.showShort("请输入2-20位的负责人名称");
            return;
        }

        if (merchantInfo.getBusinessLicense().get()==null)
        {
            ToastUtils.showShort("请上传营业执照");
            return;
        }else if (StringUtils.isEmpty(merchantInfo.getBusinessLicense().get().getPath())){
            ToastUtils.showShort("请上传营业执照");
            return;
        }

        if (merchantInfo.getOperatingPermit().get()==null)
        {
            ToastUtils.showShort("请上传经营许可证");
            return;
        }else if (StringUtils.isEmpty(merchantInfo.getOperatingPermit().get().getPath())){
            ToastUtils.showShort("请上传经营许可证");
            return;
        }
       for (Brankbody bbody : merchantInfo.getBranklist())
       {
           if (bbody.getEdits())
           {
               ToastUtils.showShort("请先保存品牌授权内容");
               return;
           }
       }

        //接口提交
        if (TextUtils.isEmpty(userStatic))
        {
            observable= model.postMerchantMsg(new MerchantMsgbody(merchantInfo));
        }else {
            MerchantMsgbody mb= new MerchantMsgbody(merchantInfo);
            mb.setBusinessId(userStatic);
            observable=model.postREMerchantMsg(mb);
        }





        observable.compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantEnterViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        dismissDialog();
                        NavController navController= Navigation.findNavController(view);
                        navController.navigate(R.id.action_registerMaterialFragment_to_merchantWaitFragment);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /**
     * 展示驳回原因
     * @param view
     */
    public void showReason(View view)
    {
        showCommTextDialog(new RefuseDialogBean(merchantInfo.getRefuseString(),"确定",null,"审核意见"), new CommTextDialog.onAcceptCallBack() {
            @Override
            public void acceptBack() {

            }

            @Override
            public void refuseBack() {

            }
        });

    }


}
