package com.xx.merchanthbh.ui.merchantenter

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.lifecycle.Observer
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.body.Brankbody
import com.xx.merchanthbh.data.http.respons.MerchantBean
import com.xx.merchanthbh.data.local.LocalData
import com.xx.merchanthbh.databinding.FragmentRegisterMaterialBinding
import me.goldze.mvvmhabit.base.BaseFragment
import me.goldze.mvvmhabit.utils.StringUtils

class RegisterMaterialFragment : BaseFragment<FragmentRegisterMaterialBinding, MerchantEnterViewModel>() {

    lateinit var adapter:AddBrankAdapter;
    override fun initContentView(
        inflater: LayoutInflater?,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): Int {
        return R.layout.fragment_register_material
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }


    override fun initParam() {
        super.initParam()
    }

    override fun initData() {
        super.initData()
        viewModel.title.set("商家信息")
       viewModel.getBoothList();
        adapter=AddBrankAdapter(context)
        binding.rvFrmBrankList.adapter=adapter

        viewModel.addbrank.observe(this,object :Observer<String>
        {
            override fun onChanged(t: String) {

                if(!StringUtils.isEmpty(t))
                {
                    if (adapter.mList==null)
                    {
                        adapter.mList=ArrayList()

                    }
                    var body =Brankbody()
                    body.edits=true
                    adapter.mList.add(body);
                    viewModel.merchantInfo.branklist=adapter.mList
                    adapter.notifyDataSetChanged()
                }

            }

        })

        var merchantBean :MerchantBean?=LocalData.getMerchant();
        if (merchantBean!=null )
        {

            if (merchantBean.brandAuthorizationList!=null)
            {
                adapter.mList =  viewModel.merchantInfo.reBrankbody(merchantBean.brandAuthorizationList!!)
            }

            if ("1" == merchantBean.status || "4" == merchantBean.status) {

                // 处理原始日志中的备注字段
                val mark: String? = merchantBean.merchantOperationLogList?.get(0)?.remark
                // 备注数据不为空,则做数据处理
                if (!StringUtils.isEmpty(mark)) {
                    // 获取分割符号索引
                    val separatorIndex = mark?.indexOf("：")
                    // 备注 ":" 分隔符存在则有审核备注
                    if (separatorIndex != null) {
                        viewModel. merchantInfo.refuseString =
                            if (separatorIndex > 0) mark.substring(separatorIndex + 1) else ""
                    }
                    if (!StringUtils.isEmpty(viewModel. merchantInfo.refuseString)) {
                        binding.llShopAuditMsg.visibility=View.VISIBLE
                    }
                }
            } else {
                binding.llShopAuditMsg.visibility=View.GONE;
            }
        }

    }

    override fun viewModelType(): Int {
        return 1
    }

  /*  override fun initViewModel(): MerchantEnterViewModel {
        val mr: MerchantEnterRespons = MerchantEnterRespons()
        return MerchantEnterViewModel(requireActivity().application,mr)
    }*/
}