package com.xx.merchanthbh.ui.merchantinfo;


import android.app.Application;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;
import androidx.navigation.NavController;
import androidx.navigation.Navigation;

import com.bumptech.glide.Glide;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.huantansheng.easyphotos.utils.permission.PermissionUtil;
import com.stfalcon.imageviewer.StfalconImageViewer;
import com.stfalcon.imageviewer.loader.ImageLoader;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.MerchantEnterRequst;
import com.xx.merchanthbh.data.http.requst.body.BrankBean;
import com.xx.merchanthbh.data.http.requst.body.Brankbody;
import com.xx.merchanthbh.data.http.requst.body.MerchantMsgbody;
import com.xx.merchanthbh.data.http.respons.BoothBean;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.MerchantBean;
import com.xx.merchanthbh.data.http.respons.RegisterBean;
import com.xx.merchanthbh.data.http.respons.UserBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.dialog.BoothListDialog;
import com.xx.merchanthbh.ui.merchantenter.AddBrankAdapter;
import com.xx.xxviewlibrary.base.xxBaseDialog;
import com.xx.xxviewlibrary.witget.XxUploudPic;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MerchantInfoViewModel extends BaseViewModel<MerchantEnterRequst> {



    public AddBrankAdapter adapter;
    public UserBean user;
    public MerchantEnterRequst.MerchantInfo merchantInfo;

    public ObservableField<String> supervisors=new ObservableField<>("");


    //品牌是否显示
    public MutableLiveData<Boolean> brandVisibility=new MutableLiveData<>(true);

    /**
     * 1:营业执照显示
     * 2：营业执照隐藏
     * 3：经营许可证显示
     * 4：经营许可证隐藏
     */
    public MutableLiveData<Integer> imgVisibility=new MutableLiveData<>(0);


    public MutableLiveData<MerchantBean> merchantInfos=new MutableLiveData<>();

    public MerchantInfoViewModel(@NonNull Application application) {
        super(application);
        model= new MerchantEnterRequst();
        user=LocalData.getUser();
        merchantInfo=new MerchantEnterRequst.MerchantInfo("138");
    }

    public MerchantInfoViewModel(@NonNull Application application, MerchantEnterRequst model) {
        super(application, model);

    }


    /**
     * 获取图片
     */
    public BindingCommand getPhoto = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startPhotoPage(true, "申请的是摄像头和照片视频读取权限，用于商家信息维护中读取和写入相册和文件内容",new SelectCallback() {
                @Override
                public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                    /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/

                    File file = new File(photos.get(0).path);
                    model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                            .doOnSubscribe(MerchantInfoViewModel.this)
                            .doOnSubscribe (new Consumer<Disposable>() {
                                @Override
                                public void accept(Disposable disposable) throws Exception {
                                    showDialog("请稍等");
                                }
                            }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                                @Override
                                public void onSuccess(List<Filebean> resultBean) {

                                    dismissDialog();
                                }

                                @Override
                                public void onError(String Error) {
                                    dismissDialog();
                                }


                            });
                }

                @Override
                public void onCancel() {

                }
            });
        }

    });





    /**
     * 添加品牌
     * @param view
     */
    public void addBrank(View view)
    {

        brandVisibility.postValue(true);
        adapter.mList.add(new Brankbody(new ObservableField(""),new ArrayList(),null,true));
        adapter.notifyDataSetChanged();
    }


    /**
     * 上传图片类信息
     * @param view
     */
    public void uploadPic(View view)
    {
        //选择图片
        startPhotoPage(true,"申请的是摄像头和照片视频读取权限，用于商家信息维护中读取和写入相册和文件内容", new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                model.upLoadFile(new File(photos.get(0).path)).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MerchantInfoViewModel.this)
                        .doOnSubscribe (new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog();
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                dismissDialog();
                                FileBean bean= new FileBean(resultBean.get(0).getBusinessId(),resultBean.get(0).getUrl());


                                if (view.getId()==R.id.xup_frm_logo)
                                {
                                    merchantInfo.getCompanyLogo().set(bean);
                                }else if (view.getId()==R.id.xup_frm_licence)
                                {
                                    merchantInfo.getOperatingPermit().set(bean);
                                }else if (view.getId()==R.id.xup_frm_business_license)
                                {
                                    merchantInfo.getBusinessLicense().set(bean);
                                }

                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }


    /**
     * 提交商户信息
     * @param view
     */
    public void submitMerchantMsg(View view)
    {

        for (Brankbody brank:adapter.mList)
        {
            if (brank.getEdits())
            {
                ToastUtils.showShort("请先保存品牌授权内容");
                return;
            }
        }

        MerchantMsgbody body= new MerchantMsgbody(merchantInfo);
        body.setBusinessId(LocalData.getMerchant().getBusinessId());
        model.postChangeMerchantMsg(body).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantInfoViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<Boolean>() {
                    @Override
                    public void onSuccess(Boolean resultBean) {
                        ToastUtils.showShort("修改成功");
                        dismissDialog();
                        finish();

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    /**
     * 获取详情
     */
    public void getMerchantInfo()
    {

        model.getMerchantInfoById().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MerchantInfoViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<MerchantBean>() {
                    @Override
                    public void onSuccess(MerchantBean resultBean) {
                        merchantInfo.setMerchantInfo(resultBean);
                        merchantInfos.postValue(resultBean);

                        if (resultBean.getBrandAuthorizationList().size()<=0)
                        {
                            brandVisibility.postValue(false);
                        }else {
                            brandVisibility.postValue(true);
                        }

                        adapter.mList=merchantInfo.reBrankbody(resultBean.getBrandAuthorizationList());
                        supervisors.set( StringUtils.join(resultBean.getSupervisorsUserInfoList(),",",supervisorsUserInfo -> supervisorsUserInfo.getNickName()));
                        adapter.notifyDataSetChanged();


                        //营业执照图片
                        if (TextUtils.isEmpty(resultBean.getBusinessLicense()))
                        {
                            imgVisibility.setValue(2);
                        }else {
                            imgVisibility.setValue(1);
                        }

                        //营业许可证
                        if (TextUtils.isEmpty(resultBean.getOperatingPermit()))
                        {
                            imgVisibility.setValue(4);
                        }else {
                            imgVisibility.setValue(3);
                        }
                    }

                    @Override
                    public void onError(String Error) {

                    }

                });
    }


    public void bigPic(View view)
    {
        XxUploudPic uploudPic= (XxUploudPic) view;
        List<FileBean> mlist=new ArrayList();
        mlist.add(uploudPic.getUrl());
        StfalconImageViewer sv= new StfalconImageViewer.Builder<FileBean>(view.getContext(), mlist, new ImageLoader<FileBean>() {
            @Override
            public void loadImage(ImageView imageView, FileBean image) {
                Glide.with(view.getContext()).load(image.getPath()).into(imageView);
            }
        }).allowSwipeToDismiss(true).withStartPosition(0).show();

    }


}
