package com.xx.merchanthbh.ui.msg;


import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.MessageListAdapter;
import com.xx.merchanthbh.data.http.requst.MessageRequest;
import com.xx.merchanthbh.data.http.respons.MessageBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityMessageBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class MessageActivity extends BaseActivity<ActivityMessageBinding, MessageViewModel>implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_message;
    }

    @Override
    public int initVariableId() {
        return BR.messageViewModel;
    }
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*flag 0-未读 1-已读*/
        StaticData.flag = 0;
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
        binding.refresh.setOnLoadMoreListener(MessageActivity.this::onLoadMore);
        //获取适配器上下文
        viewModel.messageListAdapter = new MessageListAdapter(this);
        //把adapterset进去
        binding.rvOrderList.setAdapter(viewModel.messageListAdapter);
        /*调消息列表接口*/
        viewModel.getMessageList();
        /*对订单列表内容进行遍历回显*/
        viewModel.messageList.observe(this, new Observer<List<MessageBean>>() {
            @Override
            public void onChanged(List<MessageBean> orderBeanList) {
                viewModel.messageListAdapter.mList = orderBeanList;
                /*实时更新*/
                viewModel.messageListAdapter.notifyDataSetChanged();
            }
        });
        // 对列表遍历项设置点击事件
        viewModel.messageListAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<MessageBean>() {
            /*返回位置参数*/
            @Override
            public void itemClickCalBack(int position, MessageBean data) {
                /*将上下文和位置参数给方法*/
                viewModel.goMessageDetail(viewModel.messageListAdapter, position);
            }
        });
        viewModel.loadMoreStatic.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 1) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvOrderList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    binding.refresh.finishLoadMore();
                } else if (it == 2) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvOrderList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    binding.refresh.finishLoadMoreWithNoMoreData();
                }else  if(it==3){
                    /*显示recycleView和它的暂无数据列表*/
                    binding.rvOrderList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                }
                /*结束上加载*/
                binding.refresh.finishRefresh();
            }
        });


        /*切换状态Tab*/
        binding.tabs.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewModel.messageListAdapter.mList.clear();
                // 重置页数
                viewModel.page = 1;
                // 重置 loadMoreStatic
                viewModel.loadMoreStatic.postValue(0);
                // 重置 SmartRefreshLayout 的状态
                binding.refresh.resetNoMoreData(); // 重置没有更多数据的状态
                binding.refresh.setNoMoreData(false); // 设置为不再有更多数据
                binding.refresh.finishLoadMore(); // 结束加载更多状态
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.flag = "0";
                        /*flag 0-未读 1-已读*/
                        StaticData.flag = 0;
                        viewModel.getMessageList();
                        break;
                    case 1:
                        viewModel.flag = "1";
                        /*flag 0-未读 1-已读*/
                        StaticData.flag = 1;
                        viewModel.getMessageList();
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });
    }

    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
    }
    @Override
    public MessageViewModel initViewModel() {
        MessageRequest lm = new MessageRequest();
        return new MessageViewModel(getApplication(), lm);
    }
    public void onLoadMore(RefreshLayout refreshLayout) {
        viewModel.page++;
        viewModel.getMessageList();
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {

        viewModel.page=1;
        viewModel.getMessageList();
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
    }
}
