package com.xx.merchanthbh.ui.msg;


import android.app.Application;
import android.os.Bundle;
import android.util.Log;

import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.activity.adapter.MessageListAdapter;

import me.goldze.mvvmhabit.base.ListBaseViewModel;

import com.xx.merchanthbh.data.http.requst.MessageRequest;
import com.xx.merchanthbh.data.http.respons.MessageBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.annotations.NonNull;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MessageViewModel extends ListBaseViewModel<MessageRequest> {
    /*查收适配器*/
    MessageListAdapter messageListAdapter;
    //    创建消息列表实体对象
    public MutableLiveData<List<MessageBean>> messageList = new MutableLiveData<>(new ArrayList<>());

    public MessageViewModel(@NonNull Application application) {
        super(application);
    }

    public MessageViewModel(@NonNull Application application, MessageRequest model) {
        super(application, model);
    }

    /*设置消息初始状态是0*/
    public String flag = "0";

    //调用消息列表的接口信息
    public void getMessageList() {
        model.getMessageList(flag, page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MessageViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MessageBean>() {
                    @Override
                    public void onSuccess(List<MessageBean> resultBean) {
//                        messageList.postValue(resultBean);
                        dismissDialog();
                        if (page == 1) {
                            messageListAdapter.mList = resultBean;
                        } else {
                            messageListAdapter.mList.addAll(resultBean);
                        }
                        messageListAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {

                    }

                    @Override
                    public void getTotal(int total) {
                        if (total == 0) {
                            loadMoreStatic.postValue(3);
                        } else if (messageListAdapter.mList.size() >= total) {
                            loadMoreStatic.postValue(2);
                        } else {
                            loadMoreStatic.postValue(1);
                        }
                    }
                });
    }

    /*跳转消息详情页面*/
    public void goMessageDetail(MessageListAdapter messageListAdapter, int position) {
        /*创建bundle*/
        Bundle bundle = new Bundle();
        /*将要传的createTime传过去*/
        bundle.putString("createTime", messageListAdapter.mList.get(position).getCreateTime());
        /*将要传的messageType传过去*/
        bundle.putString("messageType", messageListAdapter.mList.get(position).getMessageType());
        /*将要传的messageContent传过去*/
        bundle.putString("messageContent", messageListAdapter.mList.get(position).getMessageContent());
        /*连带参数一块跳转到详情页*/
        startActivity(MessageDetailActivity.class, bundle);
        /*未读的状态点进去调取接口改变状态位*/
        if (messageListAdapter.mList.get(position).getFlag().equals("0")) {
            model.putMessageStaticUpdate(messageListAdapter.mList.get(position).getBusinessId()).compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                    .doOnSubscribe(MessageViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {
                        }
                    }).subscribe(new ApiDisposableObserver<Number>() {
                        @Override
                        public void onSuccess(Number resultBean) {

                        }

                        @Override
                        public void onError(String Error) {

                        }
                    });
        }
    }


}
