package com.xx.merchanthbh.ui.order;


import static com.xx.merchanthbh.utils.RetrofitClient.baseImgUrl;

import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import androidx.lifecycle.Observer;

import com.bumptech.glide.Glide;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.OrderUnitUnitAdapter;
import com.xx.merchanthbh.data.http.requst.OrderDetailRequest;
import com.xx.merchanthbh.data.http.respons.OrderDetailBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityOrderDetailBinding;
import com.xx.xxviewlibrary.utils.CommUtilsKt;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class OrderDetailActivity extends BaseActivity<ActivityOrderDetailBinding, OrderDetailViewModel> {
    /*订单id,为了详情页通过id获取信息*/
    String businessId;
    /*订单状态,为了做前端状态回显,不参与到传参中*/
    String orderStatus;
    /*订单公司头像,为了做前端状态回显,不参与到传参中*/
    String filePath;

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.orderDetailViewModel;
    }

    @Override
    public void initParam() {
        super.initParam();
        /*获取列表页传过来的参数*/
        businessId = getIntent().getStringExtra("businessId");
        /*获取列表页传过来的参数*/
        orderStatus = getIntent().getStringExtra("orderStatus");
        StaticData.statusData= Integer.parseInt(orderStatus);

    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();

        /*给viewmodel传值的business设置值*/
        /*报错行!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
        viewModel.businessId = businessId;
        // 创建RecyclerView的适配器
        OrderUnitUnitAdapter orderUnitUnitAdapter = new OrderUnitUnitAdapter(this);

        viewModel.businessId=businessId;
        //把adapterset进去
        binding.rvOrderUnit.setAdapter(orderUnitUnitAdapter);
        viewModel.orderDetailList.observe(this, new Observer<List<OrderDetailBean.CommodityLists>>() {
            @Override
            public void onChanged(List<OrderDetailBean.CommodityLists> commodityLists) {
                /*设置内层列表值*/
                orderUnitUnitAdapter.mList = commodityLists;
                orderUnitUnitAdapter.notifyDataSetChanged();
            }
        });

        /*控制台拿到了图片路径了*/
        /*如果图片有刷新就会进行更新*/
        viewModel.getStoreImageUrl().observe(this, new Observer<String>() {
            @Override
            public void onChanged(String imageUrl) {
                if (imageUrl != null) {
                    Glide.with(OrderDetailActivity.this)
                            .load(baseImgUrl+imageUrl)
                            .into(binding.imageStore);
                }
            }
        });
        /*调用接口*/
        viewModel.getOrderDetailInfo();

        /*订单状态-待付款*/
        if (StaticData.statusData == 1) {
            /*状态位回显*/
            binding.statusObligationId.setVisibility(View.VISIBLE);
            viewModel.payMsgVisible.set(View.GONE);
        }
        /*订单状态-已完成*/
        if (StaticData.statusData == 2) {
            viewModel.payMsgVisible.set(View.VISIBLE);
            /*状态位回显*/
            binding.statusCompletedId.setVisibility(View.VISIBLE);
            /*付款时间label显示*/
            binding.tvAodTitlePayTime.setVisibility(View.VISIBLE);
            /*收银员显示*/
            binding.cashier.setVisibility(View.VISIBLE);
        }
        /*订单状态-已关闭*/
        if (StaticData.statusData == 3) {
            viewModel.payMsgVisible.set(View.VISIBLE);
            /*状态位回显*/
            binding.statusClosedId.setVisibility(View.VISIBLE);
            /*关闭时间label显示*/
            binding.tvAodTitleCloseTime.setVisibility(View.VISIBLE);
        }

        viewModel.CouponLists.observe(this, new Observer<List<OrderDetailBean.CouponLists>>() {
            @Override
            public void onChanged(List<OrderDetailBean.CouponLists> couponLists) {
                binding.llAodCouponList.removeAllViews();
                View view = LayoutInflater.from( binding.llAodCouponList.getContext()).inflate(R.layout.item_coupon_msg,binding.llAodCouponList);
                TextView tv_title=view.findViewById(R.id.tv_icm_title);
                TextView tv_context=view.findViewById(R.id.tv_icm_context);
                tv_title.setText("优惠金额");
                tv_context.setText(CommUtilsKt.priceSTrUtils(0.0));
                if (couponLists!=null && couponLists.size()>0)
                {
                    for (OrderDetailBean.CouponLists data :couponLists)
                    {

                        if (data.getCouponType().equals("1"))
                        {
                            tv_context.setText(CommUtilsKt.priceSTrUtils(data.getDiscountAmount()));
                        }else {
                            View cview = LayoutInflater.from( binding.llAodCouponList.getContext()).inflate(R.layout.item_coupon_msg,binding.llAodCouponList);
                            TextView ctv_title=view.findViewById(R.id.tv_icm_title);
                            TextView ctv_context=view.findViewById(R.id.tv_icm_context);
                            ctv_title.setText("赠品");
                            ctv_context.setText(data.getGiftName());

                        }



                    }
                }
            }
        });
    }

    @Override
    public OrderDetailViewModel initViewModel() {
        OrderDetailRequest lm = new OrderDetailRequest();
        return new OrderDetailViewModel(getApplication(), lm);
    }
}
