package com.xx.merchanthbh.ui.order;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.activity.adapter.OrderListAdapter;
import me.goldze.mvvmhabit.base.ListBaseViewModel;
import com.xx.merchanthbh.data.http.requst.OrderRequest;
import com.xx.merchanthbh.data.http.respons.OrderBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class OrderViewModel extends ListBaseViewModel<OrderRequest> {

    //    创建订单列表实体对象
    public MutableLiveData<List<OrderBean>> orderList = new MutableLiveData<>(new ArrayList<>());

    OrderListAdapter orderListAdapter;

    public OrderViewModel(@NonNull Application application) {
        super(application);
    }

    public OrderViewModel(@NonNull Application application, OrderRequest model) {
        super(application, model);
    }

    /*跳转订单详情页面*/
    public void goOrderDetail(OrderListAdapter orderListAdapter, int position) {
        /*创建bundle*/
        Bundle bundle = new Bundle();
        /*将要传的businessId传过去*/
        bundle.putString("businessId",  orderListAdapter.mList.get(position).getBusinessId());
        /*将要传的orderStatus传过去*/
        bundle.putString("orderStatus",  orderListAdapter.mList.get(position).getOrderStatus());
        /*连带参数一块跳转到详情页*/
        startActivity(OrderDetailActivity.class, bundle);
    }


    /*设置订单初始状态是0*/
    public String  orderStatus="";
    //调用订单列表的接口信息
    public void getOrderList() {
        model.getOrderList(orderStatus,page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(OrderViewModel.this)
                .doOnSubscribe(new Consumer<io.reactivex.rxjava3.disposables.Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog("");
                    }
                }).subscribe(new ApiDisposablePageObserver<OrderBean>() {
                    @Override
                    public void onSuccess(List<OrderBean> resultBean) {
//                        orderList.postValue(resultBean);
                        dismissDialog();
                        if (page == 1) {
                            orderListAdapter.mList = resultBean;
                        } else {
                            orderListAdapter.mList.addAll(resultBean);
                        }
                        orderListAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        if (total==0)
                        {
                            loadMoreStatic.postValue(3);
                        }else if (orderListAdapter.mList.size()>=total)
                        {
                            loadMoreStatic.postValue(2);
                        }else {
                            loadMoreStatic.postValue(1);
                        }
                    }
                });
    }

}
