package com.xx.merchanthbh.ui.ordercreate

import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.databinding.FragmentOrderCreateBinding
import com.xx.xxviewlibrary.utils.priceSTrUtils
import me.goldze.mvvmhabit.base.BaseFragment

class OrderCreatFragment: BaseFragment<FragmentOrderCreateBinding, OrderCreateViewModel>() {
    override fun viewModelType(): Int {
       return 1
    }

    override fun initContentView(
        inflater: LayoutInflater?,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): Int {
      return R.layout.fragment_order_create
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }

    override fun initData() {
        super.initData()

        if(viewModel.productAdapter==null)
        {
            viewModel.productAdapter=OrderProductAdapter(requireContext(),viewModel.total)
        }

        binding.rvFocProduct.adapter=viewModel.productAdapter;

        viewModel.total.observe(this)
        {


            if (viewModel.orderProductList.size <= 0) {
                viewModel. creatVisibility.set(View.GONE)
            } else {
                viewModel. creatVisibility.set(View.VISIBLE)
            }
            var money = 0.0
            for (bean in viewModel.orderProductList) {
                money = money + bean.reCommodityQuantity() * bean.price
            }
            if (money<=0)
            {
                binding.rvFocProduct.visibility=View.GONE
                if (viewModel.productAdapter!=null && viewModel.productAdapter.mList!=null)
                {
                    if (viewModel.productAdapter.mList.size<=0)
                    {
                        viewModel.creatVisibility.set(View.GONE)
                    }
                }
              

            }else{
                binding.rvFocProduct.visibility=View.VISIBLE
                binding.tvOrderTotal.setText(priceSTrUtils(money))
                viewModel. productAdapter.notifyDataSetChanged()


        }


        }


        binding.ivFocClear.setOnClickListener()
        {
            binding.ivFocClear.visibility=View.GONE
            viewModel.phone.set("")
        }


        binding.etWxeContent.addTextChangedListener(object:TextWatcher{
            override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
            }

            override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

            }

            override fun afterTextChanged(p0: Editable?) {
                if (p0==null)
                {
                    binding?.ivFocClear?.visibility= View.GONE
                }else if(p0.length>0){
                    binding?.ivFocClear?.visibility= View.VISIBLE
                }else{
                    binding?.ivFocClear?.visibility= View.GONE
                }

            }

        })
    }


}