package com.xx.merchanthbh.ui.ordercreate

import android.os.Bundle
import android.view.LayoutInflater
import android.view.ViewGroup
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener
import com.scwang.smart.refresh.layout.listener.OnRefreshListener
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.databinding.FragmentProductSelectListBinding
import me.goldze.mvvmhabit.base.BaseFragment

class SelectProductFragment:
    BaseFragment<FragmentProductSelectListBinding, OrderCreateViewModel>(), OnRefreshListener,
    OnLoadMoreListener {
    override fun viewModelType(): Int {
        return 1
    }

    override fun initContentView(
        inflater: LayoutInflater?,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): Int {
        return R.layout.fragment_product_select_list
    }

    override fun initVariableId(): Int {
       return BR.viewModel
    }

    override fun initData() {
        super.initData()
        binding.refresh.setOnRefreshListener(this)
        binding.refresh.setOnLoadMoreListener(this)
        viewModel.adapter= OrderSelectProductAdapter(requireContext(),viewModel.orderProductList);
        binding.rvProductList.adapter=viewModel.adapter
        viewModel.getProductList()

        viewModel.loadMoreStatic.observe(this
        ) {
            if (it == 1) {
                binding.refresh.finishLoadMore();
            } else if (it == 2) {
                binding.refresh.finishLoadMore();
                binding.refresh.setEnableLoadMore(false);
            }
            binding.refresh.finishRefresh()
        }

    }

    override fun onRefresh(refreshLayout: RefreshLayout) {
        viewModel.page=1;
        viewModel. getProductList();
        binding.refresh.setEnableLoadMore(true)

    }

    override fun onLoadMore(refreshLayout: RefreshLayout) {
        viewModel.page++;
        viewModel. getProductList();
    }
}