package com.xx.merchanthbh.ui.point;

import static com.xx.merchanthbh.utils.RetrofitClient.baseImgUrl;

import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.lifecycle.Observer;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.load.resource.drawable.DrawableTransitionOptions;
import com.bumptech.glide.request.RequestOptions;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.activity.adapter.StorePointAdapter;
import com.xx.merchanthbh.data.http.requst.StorePointsRequest;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean;
import com.xx.merchanthbh.data.http.respons.MerchantPointBean;
import com.xx.merchanthbh.data.staticdata.StaticData;
import com.xx.merchanthbh.databinding.ActivityStorePointsBinding;
import com.xx.merchanthbh.ui.order.OrderDetailActivity;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;

public class StorePointsActivity extends BaseActivity<ActivityStorePointsBinding, StorePointsViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_store_points;
    }

    @Override
    public int initVariableId() {
        return BR.storePointsViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        /*获取商户信息(头像)*/
        viewModel.getMerchantInfo();
        /*调取筛选类型的数据字典数据*/
        viewModel.getIntegralTypeList();
        /*控制台拿到了图片路径了*/
        /*如果图片有刷新就会进行更新*/
        viewModel.getStoreImageUrl().observe(this, new Observer<String>() {
            @Override
            public void onChanged(String imageUrl) {
                if (imageUrl != null) {
                    Glide.with(StorePointsActivity.this)
                            .load(baseImgUrl+imageUrl)
                            .into(binding.imageStore);
                }
            }
        });
        viewModel.merchantPointList.observe(this, new Observer<List<MerchantPointBean>>() {
            @Override
            public void onChanged(List<MerchantPointBean> merchantPointBeans) {
                /*判断列表是否是空*/
                if (StaticData.PointData == 0) {
                    Log.d("这是为了看列表为空", "积分列表不为空");
                    /*模块隐藏*/
                    binding.llNoData.setVisibility(View.GONE);
                } else {
                    Log.d("这是为了看列表为空", "积分列表为空");
                    binding.llNoData.setVisibility(View.VISIBLE);
                }
            }
        });

        /*控制台拿到了图片路径了*/
        /*如果图片有刷新就会进行更新*/
//        viewModel.getAvatarImageUrl().observe(this, new Observer<String>() {
//            @Override
//            public void onChanged(String imageUrl) {
//                if (!StringUtils.isEmpty(imageUrl)) {
//                    // 设置圆角半径
//                    int radius = 120;
//                    // 创建圆角转换器
//                    RoundedCorners roundedCorners = new RoundedCorners(radius);
//                    // 创建Glide请求选项
//                    RequestOptions requestOptions = RequestOptions.bitmapTransform(roundedCorners);
//                    // 使用Glide加载图片并应用圆角转换器
//                    Glide.with(StorePointsActivity.this)
//                            .load(baseImgUrl+imageUrl)
//                            .apply(requestOptions)
//                            .transition(DrawableTransitionOptions.withCrossFade())
//                            .into(binding.imageAvatar);
//                }
//            }
//        });


        /*首頁-店铺积分列表*/
        //获取适配器上下文
        viewModel.storePointAdapter = new StorePointAdapter(this);

        //把adapterset进去
        binding.rvPointsList.setAdapter( viewModel.storePointAdapter);

        viewModel.getStorePointsList();

    }

    //    重写初始方法调用参数
    @Override
    public void initViewObservable() {
        super.initViewObservable();
    }

    @Override
    public StorePointsViewModel initViewModel() {
        StorePointsRequest lm = new StorePointsRequest();
        return new StorePointsViewModel(getApplication(), lm);
    }

}
