package com.xx.merchanthbh.ui.productdetail;

import android.app.Application;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.xx.merchanthbh.data.http.requst.AddProductRequest;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.ProductBean;
import com.xx.merchanthbh.data.http.respons.RejectionBean;
import com.xx.merchanthbh.data.http.respons.RejectionShelfBean;
import com.xx.merchanthbh.dialog.data.ProductTypeProvider;
import com.xx.xxviewlibrary.utils.ImgAdapter;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ProductDetailViewModel extends BaseViewModel<AddProductRequest> {


    public String goodsId = null;


    public MutableLiveData<String> name;

    public MutableLiveData<Integer> brandGone = new MutableLiveData(View.GONE);

    public MutableLiveData<Integer> imgGone = new MutableLiveData(View.GONE);


    /**
     * productAdapter 商品图片
     * detailAdapter 详细图片
     */
    public ImgAdapter productAdapter, detailAdapter, brandAdapter;

    public ProductTypeProvider categoryDialogData;

    public ObservableField<String> pNumber = new ObservableField<>("");

    public ObservableField<String> pName = new ObservableField<>("");

    public ObservableField<String> pDescribe = new ObservableField<>("");

    public ObservableField<String> pPrice = new ObservableField<>("");

    public ObservableField<String> pType = new ObservableField<>("请选择");

    public String typeId = "";

    public ObservableField<String> pBrand = new ObservableField<>();

    public String brandID = null;

    public ProductDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public ProductDetailViewModel(@NonNull Application application, AddProductRequest model) {
        super(application, model);
    }

    @Override
    public void onResume() {
        super.onResume();
       /* if (model.getMerchantBean().getBrandAuthorizationList().size()<=0)
        {
            brandGone.setValue(View.GONE);
        }else {
            brandGone.setValue(View.VISIBLE);
        }*/
    }





    /**
     * 获取商品详情
     *
     * @param id
     */

    public void getInfo(String id) {

        goodsId = id;
        model.getProductInfo(id).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ProductDetailViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<ProductBean>() {
                    @Override
                    public void onSuccess(ProductBean resultBean) {

                        /*驳回原因赋值*/
                        if (!TextUtils.isEmpty(resultBean.getCommodityCode())) {
                            pNumber.set(resultBean.getCommodityCode());
                        }
                        pName.set(resultBean.getCommodityName());


                        for (Filebean bean : resultBean.getFileList()) {
                            productAdapter.mList.add(new FileBean(bean.getBusinessId(), bean.getUrl()));
                        }
                        productAdapter.notifyDataSetChanged();

                        //详细图片
                        if (resultBean.getDetailImagesList() == null || resultBean.getDetailImagesList().size() <= 0) {
                            imgGone.setValue(View.GONE);
                        } else {
                            imgGone.setValue(View.VISIBLE);
                            for (Filebean bean : resultBean.getDetailImagesList()) {
                                detailAdapter.mList.add(new FileBean(bean.getBusinessId(), bean.getUrl()));
                            }

                            detailAdapter.notifyDataSetChanged();
                        }

                        if (resultBean.getBrandAuthorization() == null) {
                            brandGone.setValue(View.GONE);
                        } else {
                            brandGone.setValue(View.VISIBLE);
                            for (Filebean bean : resultBean.getBrandAuthorization().getFileList()) {
                                brandAdapter.mList.add(new FileBean(bean.getBusinessId(), bean.getUrl()));
                            }

                            brandAdapter.notifyDataSetChanged();
                        }
                        pType.set(resultBean.getCategoryNameStr());
                        pPrice.set(resultBean.getCommodityPrice() + "");

                        if (!TextUtils.isEmpty(resultBean.getCommodityDescriptionText())) {
                            pDescribe.set(resultBean.getCommodityDescriptionText());
                        }

                        if (!TextUtils.isEmpty(resultBean.getBrandName())) {
                            pBrand.set(resultBean.getBrandName());
                        }


                    }

                    @Override
                    public void onError(String Error) {

                    }
                });
    }


}
