package com.xx.merchanthbh.ui.productmanager

import android.graphics.Typeface
import android.os.Bundle
import android.text.SpannableString
import android.text.Spanned
import android.text.style.AbsoluteSizeSpan
import android.text.style.StyleSpan
import android.view.View
import com.google.android.material.tabs.TabLayout
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener
import com.scwang.smart.refresh.layout.listener.OnRefreshListener
import com.xx.merchanthbh.BR
import com.xx.merchanthbh.R
import com.xx.merchanthbh.data.http.requst.ProductManagerRequst
import com.xx.merchanthbh.databinding.ActivityProductListBinding
import com.xx.merchanthbh.ui.productdetail.ProductDetailActivity
import me.goldze.mvvmhabit.base.BaseActivity

class ProductManagerActivity: BaseActivity<ActivityProductListBinding, ProductManagerViewModel>(),
    OnRefreshListener,OnLoadMoreListener{
    override fun initContentView(savedInstanceState: Bundle?): Int {
        return R.layout.activity_product_list
    }

    override fun initVariableId(): Int {
        return BR.viewModel
    }

    override fun initData() {
        super.initData()
        viewModel.listAdapter= ProductListAdapter(this,viewModel)
        binding.rvProductList.adapter= viewModel.listAdapter
        //跳转商品详情
        viewModel.listAdapter.setOnItemClick{
            i,data->
            var bundle:Bundle= Bundle()
            bundle.putString("goodsId",data?.businessId)
            startActivity(ProductDetailActivity::class.java,bundle);
        }
        binding.refresh.setOnRefreshListener(this)
        binding.refresh.setOnLoadMoreListener(this)

        //控制加载控件
        viewModel.loadMoreStatic.observe(
            this
        ) {
            if (it == 1) {
                binding.refresh.finishLoadMore();
                binding.rvProductList.visibility= View.VISIBLE
                binding.llNoData.visibility=View.GONE
            } else if (it == 2) {
                binding.rvProductList.visibility= View.VISIBLE
                binding.llNoData.visibility=View.GONE
                binding.refresh.finishLoadMoreWithNoMoreData()
            }else if(it==3)
            {
                binding.rvProductList.visibility= View.GONE
                binding.llNoData.visibility=View.VISIBLE
            }
            /*结束上加载*/
            binding.refresh.finishRefresh()
        }

        viewModel.getProductList()

        //分类控制
        binding.tabs.addOnTabSelectedListener(object: TabLayout.OnTabSelectedListener
        {
            override fun onTabSelected(tab: TabLayout.Tab?) {
                viewModel.listAdapter.mList.clear()
                // 重置页数
                viewModel.page = 1
                // 重置 loadMoreStatic
                viewModel.loadMoreStatic.postValue(0)
                // 重置 SmartRefreshLayout 的状态
                binding.refresh.resetNoMoreData()
                // 重置没有更多数据的状态
                binding.refresh.setNoMoreData(false)
                // 设置为不再有更多数据
                binding.refresh.finishLoadMore()
                // 结束加载更多状态
                when(tab?.position)
                {
                    0-> viewModel.listStatic=null
                    1-> viewModel.listStatic="1"
                    2-> viewModel.listStatic="2"
                    3-> viewModel.listStatic="3"
                    4-> viewModel.listStatic="5"
                    5-> viewModel.listStatic="4"
                }
                viewModel.getProductList()
            }

            override fun onTabUnselected(tab: TabLayout.Tab?) {
            }

            override fun onTabReselected(tab: TabLayout.Tab?) {
            }

        })
        val tab: TabLayout.Tab? = binding.tabs.getTabAt(0)
        val selectTab = tab?.text.toString().trim { it <= ' ' }

        val spannableString = SpannableString(selectTab)
        val ass =  AbsoluteSizeSpan(12, true)
        spannableString.setSpan(ass, 0, selectTab.length, Spanned.SPAN_INCLUSIVE_EXCLUSIVE)
        tab?.text = spannableString


        binding.llAplTime.setOnClickListener()
        {
            binding.ivAplTime.setImageDrawable(getDrawable(R.mipmap.shangpon_icon_jiangxu2))

            val selectOrder:ListOrderPopuwindow= ListOrderPopuwindow(this,object:
                ListOrderPopuwindow.OnItemClick
            {
                override fun itemClickCalBack(orser: String) {
                    viewModel.page=1
                    when(orser)
                    {
                        "0"-> viewModel.timeStr.set("时间降序");
                        "1"-> viewModel.timeStr.set("时间升序");
                        "2"-> viewModel.timeStr.set("价格降序");
                        "3"-> viewModel.timeStr.set("价格升序");

                    }
                    binding.ivAplTime.setImageDrawable(getDrawable(R.mipmap.shangpon_icon_jiangxu1))
                    viewModel.sortRules=orser;
                    binding.refresh.setEnableLoadMore(true);
                    viewModel.getProductList()
                }

            })
            selectOrder.setOnDismissListener {   binding.ivAplTime.setImageDrawable(getDrawable(R.mipmap.shangpon_icon_jiangxu1))}
            selectOrder.showAsDropDown(binding.llAplTime,-10,40)


        }


    }

    override fun initViewModel(): ProductManagerViewModel {
        val lm: ProductManagerRequst = ProductManagerRequst()
        return ProductManagerViewModel(application,lm)
    }

    override fun onLoadMore(refreshLayout: RefreshLayout) {
        viewModel.page++;
        viewModel.getProductList();
    }



    override fun onRefresh(refreshLayout: RefreshLayout) {
        viewModel.page = 1;
        viewModel.getProductList();
        binding.refresh.setEnableLoadMore(true)
    }


}