package com.xx.merchanthbh.ui.recruitment;


import static me.goldze.mvvmhabit.utils.Utils.getContext;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.merchanthbh.BR;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.data.http.requst.RecruitmentRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;
import com.xx.merchanthbh.data.http.respons.MessageBean;
import com.xx.merchanthbh.databinding.ActivityRecruitmentListBinding;
import com.xx.merchanthbh.fragment.adapter.JobInformationAdapter;
import com.xx.merchanthbh.fragment.adapter.JobInformationListAdapter;
import com.xx.merchanthbh.ui.huanbohai.HbhBannerAdapter;
import com.xx.merchanthbh.ui.msg.MessageActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class RecruitmentActivity extends BaseActivity<ActivityRecruitmentListBinding, RecruitmentViewModel>implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_recruitment_list;
    }

    @Override
    public int initVariableId() {
        return BR.recruitmentViewModel;
    }
    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(RecruitmentActivity.this::onLoadMore);

        /*首页-招聘信息列表*/
        //获取适配器上下文
        viewModel.jobInformationListAdapter = new JobInformationListAdapter(getContext());
        //把adapterset进去
        binding.rvZpmsgList.setAdapter(viewModel.jobInformationListAdapter);
        viewModel.JobInformationList.observe(this, new Observer<List<JobInformationBean>>() {
            @Override
            public void onChanged(List<JobInformationBean> jobInformationBeanList) {
                viewModel.jobInformationListAdapter.mList = jobInformationBeanList;
                viewModel.jobInformationListAdapter.notifyDataSetChanged();
            }
        });
        viewModel.loadMoreStatic.observe(this, new Observer<Integer>() {
            @Override
            public void onChanged(Integer it) {
                if (it == 1) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvZpmsgList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMore();
                } else if (it == 2) {
                    /*隐藏recycleView和它的暂无数据列表*/
                    binding.rvZpmsgList.setVisibility(View.VISIBLE);
                    binding.llNoData.setVisibility(View.GONE);
                    /*结束加载*/
                    binding.refresh.finishLoadMoreWithNoMoreData();
                }else if(it==3)
                {
                    /*显示recycleView和它的暂无数据列表*/
                    binding.rvZpmsgList.setVisibility(View.GONE);
                    binding.llNoData.setVisibility(View.VISIBLE);
                }
                binding.refresh.finishRefresh();
            }
        });
        /*跳转工作详情*/
        viewModel.jobInformationListAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<JobInformationBean>() {
            @Override
            public void itemClickCalBack(int position, JobInformationBean data) {
                /*将上下文和位置参数给方法*/
                viewModel.goJobDetail(viewModel.jobInformationListAdapter, position);
            }
        });
        viewModel.getJobsList();

        /*切换状态Tab*/
        binding.tabs.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*招聘类型 1-内部招聘 2-商户招聘*/
            public void onTabSelected(TabLayout.Tab tab) {
                viewModel.jobInformationListAdapter.mList.clear();
                // 重置页数
                viewModel.page = 1;
                // 重置 loadMoreStatic
                viewModel.loadMoreStatic.postValue(0);
                // 重置 SmartRefreshLayout 的状态
                binding.refresh.resetNoMoreData(); // 重置没有更多数据的状态
                binding.refresh.setNoMoreData(false); // 设置为不再有更多数据
                binding.refresh.finishLoadMore(); // 结束加载更多状态
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.recruitmentType = "1";
                        viewModel.getJobsList();
                        break;
                    case 1:
                        viewModel.recruitmentType = "2";
                        viewModel.getJobsList();
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });


    }
    @Override
    public RecruitmentViewModel initViewModel() {
        RecruitmentRequest lm = new RecruitmentRequest();
        return new RecruitmentViewModel(getApplication(), lm);
    }
    @Override
    public void onLoadMore(RefreshLayout refreshLayout) {
        viewModel.page++;
        viewModel.getJobsList();
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {

        viewModel.page=1;
        viewModel.getJobsList();
        binding.refresh.setEnableFooterFollowWhenNoMoreData(true);
    }
}
