package com.xx.merchanthbh.ui.recruitment;


import android.app.Application;
import android.os.Bundle;

import androidx.lifecycle.MutableLiveData;

import me.goldze.mvvmhabit.base.ListBaseViewModel;
import com.xx.merchanthbh.data.http.requst.RecruitmentRequest;
import com.xx.merchanthbh.data.http.respons.AdvertisingBean;
import com.xx.merchanthbh.data.http.respons.JobInformationBean;
import com.xx.merchanthbh.fragment.adapter.JobInformationListAdapter;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.annotations.NonNull;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class RecruitmentViewModel extends ListBaseViewModel<RecruitmentRequest> {
    //    创建轮播图广告位实体对象
    public MutableLiveData<List<AdvertisingBean>> AdvertisingList = new MutableLiveData<>(new ArrayList<>());

    //    创建招聘信息实体对象
    public MutableLiveData<List<JobInformationBean>> JobInformationList = new MutableLiveData<>(new ArrayList<>());

    /*招聘类型 1-内部招聘 2-商户招聘*/
    public String recruitmentType = "1";

    /*适配器*/
    JobInformationListAdapter jobInformationListAdapter ;

    public RecruitmentViewModel(@NonNull Application application) {
        super(application);
    }

    public RecruitmentViewModel(@NonNull Application application, RecruitmentRequest model) {
        super(application, model);
    }


    /*跳转招聘详情页面*/
    public void goJobDetail(JobInformationListAdapter jobInformationAdapter, int position) {
        /*创建bundle*/
        Bundle bundle = new Bundle();
        /*将要传的businessId传过去*/
        bundle.putString("businessId", jobInformationAdapter.mList.get(position).getBusinessId());
        /*连带参数一块跳转到详情页*/
        startActivity(JobDetailActivity.class, bundle);
    }


    //调用招聘列表的接口信息
    public void getJobsList() {
        model.getJobInformationList(recruitmentType,page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(RecruitmentViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<JobInformationBean>() {
                    @Override
                    public void onSuccess(List<JobInformationBean> resultBean) {
//                        JobInformationList.postValue(resultBean);
                        dismissDialog();
                        if (page == 1) {
                            jobInformationListAdapter.mList = resultBean;
                        } else {
                            jobInformationListAdapter.mList.addAll(resultBean);
                        }
                        jobInformationListAdapter.notifyDataSetChanged();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        if (total==0)
                        {
                            loadMoreStatic.postValue(3);
                        }else if (jobInformationListAdapter.mList.size()>=total)
                        {
                            loadMoreStatic.postValue(2);
                        }else {
                            loadMoreStatic.postValue(1);
                        }
                    }


                });
    }

}
