package com.xx.merchanthbh.ui.share;

import android.app.Application;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.merchanthbh.data.http.requst.ShareRequest;
import com.xx.merchanthbh.data.http.respons.AssistantInformationBean;
import com.xx.merchanthbh.data.http.respons.ShareTotalBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ShareViewModel extends BaseViewModel<ShareRequest> {

    public ShareTotalAdapter adapter;

   public List<AssistantInformationBean> personList= new ArrayList();

    public String personSelectList= "";

    public ObservableField<Integer> nodata=new ObservableField<>(View.GONE);

    public ShareViewModel(@NonNull Application application) {
        super(application);
    }

    public ShareViewModel(@NonNull Application application, ShareRequest model) {
        super(application, model);
    }

    public void getShareTotalList(String activity)
    {


        model.getShareTotalList(activity,personSelectList).compose(RxUtils.schedulersTransformer()) //线程调度
            .doOnSubscribe(ShareViewModel.this)
            .doOnSubscribe(new Consumer<Disposable>() {
                @Override
                public void accept(Disposable disposable) throws Exception {
                }
            }).subscribe(new ApiDisposableObserver<List<ShareTotalBean>>() {


                    @Override
                    public void onSuccess(List<ShareTotalBean> resultBean) {
                        adapter.mList=resultBean;
                        adapter.notifyDataSetChanged();
                        if (resultBean.size()<=0)
                        {
                            nodata.set(View.VISIBLE);
                        }else {
                            nodata.set(View.GONE);
                        }
                    }

                    @Override
                    public void onError(String Error) {

                    }

                });
    }


    /**
     * 获取店铺人员
     */
    public void geAssistantList() {
        model.getAssistantList().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ShareViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AssistantInformationBean>>() {
                    @Override
                    public void onSuccess(List<AssistantInformationBean> resultBean) {

                        personList=resultBean;

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }



}
