package com.xx.merchanthbh.ui.userinfo;

import android.app.Activity;
import android.app.Application;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.Observable;
import androidx.databinding.ObservableField;

import com.bumptech.glide.load.model.ModelLoader;
import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.requst.UserInfoRequst;
import com.xx.merchanthbh.data.http.respons.Filebean;
import com.xx.merchanthbh.data.http.respons.UserBean;
import com.xx.merchanthbh.data.local.LocalData;
import com.xx.merchanthbh.ui.home.HomeActivity;
import com.xx.merchanthbh.ui.login.LoginActivity;
import com.xx.merchanthbh.ui.merchantinfo.MerchantInfoViewModel;

import java.util.List;
import java.util.Locale;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class UserInfoViewModel extends BaseViewModel<UserInfoRequst> {


    UserBean bean =LocalData.getUser();

    public ObservableField<UserBean> user= new ObservableField<>(bean);

    public ObservableField<String> name=new ObservableField<>(bean.getNickName());

    public ObservableField<String> role=new ObservableField<>(LocalData.getMerchant().getUserId()== LocalData.getUser().getUserId()? "店长" :"店员");

    public UserInfoViewModel(@NonNull Application application) {
        super(application);
    }

    public UserInfoViewModel(@NonNull Application application, UserInfoRequst model) {
        super(application, model);
    }

    public void changeInfo(View view){

        model.updataUserInfo(bean.getUserId()+"",name.get(),bean.getSex()).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(UserInfoViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                        showDialog();
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {

                        dismissDialog();
                        bean.setNickName(name.get());
                        LocalData.saveUser(bean);
                       finish();
                        ToastUtils.showShort("修改成功");
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }
}
