package com.xx.merchanthbh.ui.web;

import android.app.Application;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.tencent.mm.opensdk.modelmsg.SendMessageToWX;
import com.tencent.mm.opensdk.modelmsg.WXMediaMessage;
import com.tencent.mm.opensdk.modelmsg.WXTextObject;
import com.tencent.mm.opensdk.modelmsg.WXWebpageObject;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;
import com.xx.merchanthbh.data.http.BaseRespons;
import com.xx.merchanthbh.data.http.requst.WebRespons;
import com.xx.merchanthbh.data.http.respons.IntegralTypeBean;
import com.xx.merchanthbh.ui.huanbohai.HuanBoHaiViewModel;
import com.xx.merchanthbh.ui.merchantenter.AddBrankViewModel;

import org.reactivestreams.Subscriber;
import org.reactivestreams.Subscription;

import io.reactivex.rxjava3.android.schedulers.AndroidSchedulers;
import io.reactivex.rxjava3.core.Observer;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import io.reactivex.rxjava3.schedulers.Schedulers;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.DownLoadManager;
import me.goldze.mvvmhabit.http.download.ProgressCallBack;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;
import okhttp3.ResponseBody;
import wendu.dsbridge.DWebView;

public class CommWebViewModel extends BaseViewModel<WebRespons> {
    public String url = "";

    public IWXAPI api;

    public ObservableField<String> title = new ObservableField<>("");

    public String activityName = "";

    private DWebView webView; // 声明 DWebView

    public CommWebViewModel(@NonNull Application application) {
        super(application);
        model = new WebRespons();
        // 初始化 webView，具体初始化方法可能有所不同，请根据你的实际情况调整
        webView = new DWebView(application);
    }


    public void down(String url,String name)
    {
      model.downFile(url,name).subscribe(new Observer<ResponseBody>() {
          @Override
          public void onSubscribe(@io.reactivex.rxjava3.annotations.NonNull Disposable d) {
              Log.e("下载","onSubscribe");
          }

          @Override
          public void onNext(@io.reactivex.rxjava3.annotations.NonNull ResponseBody responseBody) {

          }

          @Override
          public void onError(@io.reactivex.rxjava3.annotations.NonNull Throwable e) {
              ToastUtils.showShort("下载失败");
              dismissDialog();
          }

          @Override
          public void onComplete() {
              Log.e("下载","onComplete");
              dismissDialog();
              ToastUtils.showShort("下载成功,文件路径："+name);
          }
      });
    }


    public void share(View view) {

        // 在发送数据到微信之前，调用 JavaScript 来设置 WebView 字体大小
        String htmlContent = "<html><head><style>body {font-size: 24px;}</style></head><body>Your HTML content here</body></html>";
        webView.loadDataWithBaseURL(null, htmlContent, "text/html", "UTF-8", null);

        WXWebpageObject textObject = new WXWebpageObject();
        textObject.webpageUrl = url;

        WXMediaMessage msg = new WXMediaMessage();
        msg.mediaObject = textObject;
        msg.title = activityName;

        SendMessageToWX.Req req = new SendMessageToWX.Req();
        req.transaction = "";
        req.message = msg;
        req.scene = SendMessageToWX.Req.WXSceneSession;

        // 调用api接口，发送数据到微信
        api.sendReq(req);

        model.shareActivity(url.substring(url.lastIndexOf("=")+1)).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CommWebViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {

                    }
                }).subscribe(new ApiDisposableObserver<String>() {


                    @Override
                    public void onSuccess(String resultBean) {

                    }

                    @Override
                    public void onError(String Error) {

                    }
                });

    }
}
