package com.xx.merchanthbh.widget

import android.content.Context
import android.content.res.TypedArray
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.LinearLayout
import androidx.databinding.DataBindingUtil.inflate
import com.xx.merchanthbh.R
import com.xx.merchanthbh.databinding.WidgetRegisterStepBinding

class RegisterStepLayout: LinearLayout {

    lateinit var binding:WidgetRegisterStepBinding;
    constructor(context: Context) : super(context)
    {
        InitView(null)
    }
    constructor(context: Context, attrs: AttributeSet?) : super(context, attrs)
    {
        InitView(attrs)
    }
    constructor(context: Context, attrs: AttributeSet?, defStyleAttr: Int) : super(
        context,
        attrs,
        defStyleAttr
    ){
        InitView(attrs)
    }

    constructor(
        context: Context,
        attrs: AttributeSet?,
        defStyleAttr: Int,
        defStyleRes: Int
    ) : super(context, attrs, defStyleAttr, defStyleRes){
        InitView(attrs)
    }



    fun InitView(attrs: AttributeSet?) {
       binding= inflate(LayoutInflater.from(context),R.layout.widget_register_step, this, true);

        if (attrs!=null) {


            var typedArray: TypedArray =
                context.obtainStyledAttributes(attrs, R.styleable.registerStepStyle)
            when (typedArray.getInteger(R.styleable.registerStepStyle_step, 0)) {
                1 -> {
                    binding.tvRsRegister.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsSubmit.setTextColor(context.getColor(R.color.black))
                    binding.tvRsCheck.setTextColor(context.getColor(R.color.text_grey_blue))
                    binding.tvRsPass.setTextColor(context.getColor(R.color.text_grey_blue))
                    binding.ivRsRegister.setImageDrawable(context.getDrawable(R.mipmap.liucheng_icon_zhucewancheng))
                    binding.ivRsSubmit.setImageResource(R.mipmap.liucheng_icon_tijiaojinxing)

                }

                2 -> {
                    binding.tvRsRegister.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsSubmit.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsCheck.setTextColor(context.getColor(R.color.black))
                    binding.tvRsPass.setTextColor(context.getColor(R.color.text_grey_blue))
                    binding.ivRsRegister.setImageDrawable(context.getDrawable(R.mipmap.liucheng_icon_zhucewancheng))
                    binding.ivRsSubmit.setImageResource(R.mipmap.liucheng_icon_tijiaowancheng)
                    binding.ivRsCheck.setImageResource(R.mipmap.liucheng_icon_shenhejinxing)
                }

                3 -> {
                    binding.tvRsRegister.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsSubmit.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsCheck.setTextColor(context.getColor(R.color.text_foreground))
                    binding.tvRsPass.setTextColor(context.getColor(R.color.text_foreground))
                    binding.ivRsRegister.setImageDrawable(context.getDrawable(R.mipmap.liucheng_icon_zhucewancheng))
                    binding.ivRsSubmit.setImageResource(R.mipmap.liucheng_icon_tijiaowancheng)
                    binding.ivRsCheck.setImageResource(R.mipmap.liucheng_icon_shenhewancheng)
                    binding.ivRsPass.setImageResource(R.mipmap.liucheng_icon_yingye)
                }

                else -> {}
            }


        }

    }
}