package com.xx.merchanthbh.wxapi;

import android.content.Intent;
import android.os.Bundle;
import androidx.appcompat.app.AppCompatActivity;
import android.util.Log;

import com.chinaums.pppay.unify.UnifyPayPlugin;
import com.tencent.mm.opensdk.constants.ConstantsAPI;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelbiz.WXLaunchMiniProgram;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.IWXAPIEventHandler;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;
import com.xx.merchanthbh.R;
import com.xx.merchanthbh.ui.bill.BillListActivity;

import org.json.JSONException;
import org.json.JSONObject;

public class WXPayEntryActivity extends AppCompatActivity implements IWXAPIEventHandler {
    private static final String TAG = "WXEntryActivity";
    private IWXAPI api;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(TAG,"WXEntryActivity --- onCreate");
        setContentView(R.layout.activity_wxpay_entry);
        api = WXAPIFactory.createWXAPI(this,UnifyPayPlugin.getInstance(this).getAppId());
        api.handleIntent(getIntent(), this);

    }
    @Override
    protected void onNewIntent(Intent intent)
    {
        super.onNewIntent(intent);
        Log.d(TAG,"WXEntryActivity --- onNewIntent");
        setIntent(intent);
        api.handleIntent(getIntent(), this);
    }
    @Override
    public void onReq(BaseReq baseReq) {
        Log.d(TAG,"WXEntryActivity --- onReq");
    }

    @Override
    public void onResp(BaseResp baseResp) {
        Log.d(TAG,"WXEntryActivity --- onReq"+baseResp.getType());
        if (baseResp.getType() == ConstantsAPI.COMMAND_PAY_BY_WX) {

//            UnifyPayPlugin.getInstance(this).getWXListener().onResponse(this, baseResp);

                if (baseResp.errCode==0)
                {
                    startActivity(new Intent(this, BillListActivity.class));
                    finish();
                }else {
                    finish();
                }


        }else {
            Log.d(TAG,"WXEntryActivity --- onReq"+baseResp.getType());
            finish();
        }

    }
}
